=======================================================================================
This file is a translation of the main russian changelog and is provided by volunteers.
It might not always be as up to date as the main changelog.
=======================================================================================

drkns 22.05.2019 19:43:43 +0100 - build 5400

1. As it turned out, XP x64 has everything we need so wrappers have been disabled for x64 (at least until they use something else in the CRT that isn't there).

2. A few minor changes.

drkns 21.05.2019 21:42:42 +0100 - build 5399

1. x64 support in vc_crt_fix.asm. Probably we can work in XP x64 as well now.

drkns 15.05.2019 23:45:23 +0200 - build 5398

1. https://docs.microsoft.com/en-us/windows/desktop/shell/launch
   "In general, trying to determine the list of available verbs for a particular file is somewhat complicated.
   In many cases, you can simply set the lpVerb parameter to NULL, which invokes the default command for the file type."

   Let's follow the manual here - the result of "trying to determine" is sometimes insane.

drkns 11.05.2019 23:42:12 +0100 - build 5397

1. Fix build.

drkns 11.05.2019 22:55:22 +0100 - build 5396

1. New fmt version.

2. Refactoring.

drkns 06.05.2019 22:44:11 +0100 - build 5395

1. Use "…" instead of "..." for UI string truncation to save some space.

2. Minor changes in vcxproj and build scripts.

drkns 04.05.2019 17:16:12 +0100 - build 5394

1. initguid.cpp removed - GUIDs are initialised directly now.

2. A workaround to support GCC 7.1.

drkns 03.05.2019 22:15:49 +0100 - build 5393

1. 0003709: Incorrect relative dates in filters

2. A few minor changes.

drkns 01.05.2019 23:00:19 +0100 - build 5392

1. Refactoring.

2. More tests.

drkns 26.04.2019 23:37:23 +0100 - build 5391

1. Continuation of 5368.

drkns 25.04.2019 23:57:58 +0100 - build 5390

1. Refactoring.

2. More tests.

drkns 25.04.2019 22:42:44 +0100 - build 5389

1. 0003706: Pressing Enter clears the selection in the current line.

svs 24.04.2019 16:11:54 +0300 - build 5388

1. SQLite 3.28.0

drkns 18.04.2019 21:59:52 +0100 - build 5387

1. New fmt version.

2. Workaround for Clang 8.

3. Minor refactoring.

drkns 17.04.2019 22:23:24 +0100 - build 5386

1. Build process:
   - bootstrap directory moved to IntDir (some generated files contain platfrom-specific data).
   - simplidied the format of vbuild.m4 - now there is only a number.

drkns 16.04.2019 08:17:59 +0100 - build 5385

1. Correction of 5384.

drkns 15.04.2019 21:42:35 +0100 - build 5384

1. Refactoring.

2. Please do not check in files with crlf line endings into git. Thanks.

drkns 05.04.2019 17:10:06 +0100 - build 5383

1. Forum: corrections for WindowMode = false.

drkns 03.04.2019 20:01:25 +0100 - build 5382

1. Refactoring.

drkns 02.04.2019 19:41:21 +0100 - build 5381

1. Standard Boyer-Moore-Horspool implementation in Find File.

2. Refactoring.

drkns 28.03.2019 16:45:06 +0000 - build 5380

1. Running the screen saver resets the viewport position.

drkns 28.03.2019 13:54:13 +0000 - build 5379

1. Refactoring.

drkns 25.03.2019 17:22:38 +0000 - build 5378

1. Minor refactoring.

2. More tests.

drkns 22.03.2019 23:45:48 +0000 - build 5377

1. Fix GCC debug build.

drkns 20.03.2019 23:35:45 +0000 - build 5376

1. Use Catch2 for unit tests.

2. Run unit tests as a part of the build process (debug - always, release - optionally).

3. Continuation of 5373.2 - removed some more redundant code.

drkns 13.03.2019 22:27:54 +0000 - build 5375

1. SQLite exceptions include the database name.

w17 12.03.2019 15:24:39 +0300 - build 5374

1. Correction of 5360.

drkns 10.03.2019 00:47:09 +0000 - build 5373

1. Minimal supported Visual Studio version is now 2017 Update 9.

2. Removed VS2015-specific workarounds, some parts are reimplemented more efficiently.

3. Win32 versions of mingw are supported again.

4. Clang warnings.

zg 03.03.2019 16:22:37 +0200 - build 5372

1. Forum: keybar is not updated after calling a plugin.

svs 27.02.2019 13:44:44 +0300 - build 5371

1. SQLite 3.27.2

drkns 25.02.2019 23:31:27 +0000 - build 5370

1. Some AI in executor to skip scrolling if possible, based on https://forum.farmanager.com/viewtopic.php?p=153198#p153198.

MZK 24.02.2019 16:26:04 -0800

1. Revised @Viewer help page, both English and Russian

drkns 24.02.2019 02:23:08 +0000 - build 5369

1. Switching from editor to viewer didn't work in UTF-8 files due to a typo in 5345.

2. Lng read optimisation.

drkns 22.02.2019 23:12:51 +0000 - build 5368

1. Use '│' instead of ' ' as a separator in editor & viewer status lines. Readability should improve.

2. Show names for Unicode (UTF7-8-16) code pages instead of numbers in editor & viewer status lines.

3. Show proper names for system code pages in code pages menu.

4. Translation corrections.

drkns 22.02.2019 20:02:42 +0000 - build 5367

1. Don't try to read labels from the main lng if lng.custom files are absent.

2. Translation corrections.

3. VS2015.

drkns 21.02.2019 22:00:35 +0000 - build 5366

1. Show executed command exactly as entered by the user.

2. Removing selection worked incorrectly in Grabber.

3. Reading/setting file owners optimisation.

drkns 16.02.2019 21:38:09 +0000 - build 5365

1. Refactoring.

w17 12.02.2019 18:22:53 +0300 - build 5364

1. M#3695: Excessive movements during search

svs 12.02.2019 09:12:09 +0300 - build 5363

1. SQLite 3.27.1

drkns 10.02.2019 23:17:26 +0000 - build 5362

1. Continuation of 2493.

2. Refactoring.

w17 06.02.2019 19:46:32 +0300 - build 5361

1. M#3694: Guid is required for viewer search dialog

w17 06.02.2019 19:27:23 +0300 - build 5360

1. M#3636: VCTL_GETFILENAME not working on QView close

drkns 05.02.2019 23:40:18 +0000 - build 5359

1. Refactoring.

2. Fix 5356.3.

drkns 05.02.2019 21:16:42 +0000 - build 5358

1. Forum: invalid from utf-8 perspective byte sequence sometimes was treated as a valid character.

drkns 04.02.2019 22:22:35 +0000 - build 5357

1. #78 Add a placeholder symbol for file descriptions

drkns 24.01.2019 00:43:26 +0000 - build 5356

1. New version of fmt.

2. Task List didn't show captionless windows.

3. Refactoring.

drkns 18.01.2019 00:27:00 +0000 - build 5355

1. 5353 broke GCC build due to a bug in fmt.

drkns 16.01.2019 17:21:03 +0000 - build 5354

1. More 5352.

w17 16.01.2019 18:07:41 +0300 - build 5353

1. fmt library & Far thousands separator.

drkns 15.01.2019 20:56:22 +0000 - build 5352

1. 0003621: Add "Use shell name" option.

drkns 09.01.2019 13:13:13 +0000 - build 5351

1. More 5350.

drkns 09.01.2019 11:37:01 +0000 - build 5350

1. Don't try to set cursor size and position if it's not visible.

2. A few minor changes.

drkns 05.01.2019 14:08:45 +0000 - build 5349

1. 0003689: Search in encrypted archives doesn't work.

drkns 01.01.2019 16:19:36 +0000 - build 5348

1. Coverity warnings.

drkns 31.12.2018 17:05:00 +0000 - build 5347

1. Key combinations like Ctrl+[Shift+]VK_OEM_8 didn't work.

drkns 27.12.2018 22:28:16 +0000 - build 5346

1. /analyze warnings.

drkns 26.12.2018 11:22:00 +0000 - build 5345

1. std::function replaced with function_ref where possible. Something (somewhere, sometime) will work faster. Probably.

2. Clang warnings.

3. New version of fmt.

drkns 23.12.2018 16:09:53 +0000 - build 5344

1. ColorDialog uses more obvious colour (black) as the base of the preview by default.

drkns 16.12.2018 19:12:45 +0000 - build 5343

1. Incorrect keybar position in non-fullscreen windows (typo in 5268).

drkns 11.12.2018 01:59:56 +0000 - build 5342

1. VS 2015.

drkns 10.12.2018 22:50:11 +0000 - build 5341

1. Refactoring.

zg 10.12.2018 16:16:53 +0200 - build 5340

1. 0003657: DM_SETTEXT doesn't reset LeftPos to 0.

svs 10.12.2018 09:01:02 +0300 - build 5339

1. SQLite 3.26.0

zg 07.12.2018 10:52:37 +0200 - build 5338

1. Сontinuation of 5337:
   - memory usage optimization.
   - "ChangeTime" is not restored.

zg 05.12.2018 18:17:44 +0200 - build 5337

1. copying a folder keeps its timestamps.

drkns 05.12.2018 07:54:14 +0000 - build 5336

1. Fix 5334.

drkns 04.12.2018 23:30:45 +0000 - build 5335

1. Crash in far:config dialog under certain circumstances.

2. Support for compilation with Visual Studio 2019.

drkns 04.12.2018 02:08:22 +0000 - build 5334

1. More fixes in concurrent access to sqlite.

2. Refactoring.

drkns 02.12.2018 00:14:12 +0000 - build 5333

1. As it turned out, SQlite, when finalising a write transaction, does not actually finalise it,
   but downgrade it to a read-only transaction if there are any active statements.
   This led to amusing effects during creation of subsequent transactions, and, eventually, to crashes.

drkns 29.11.2018 18:07:01 +0000 - build 5332

1. Restore "ClearType-friendly redraw" for Windows 10 - still relevant for Legacy Console.

drkns 28.11.2018 19:20:40 +0000 - build 5331

1. VT-renderer wasn't expecting that plugins can provide arbitrary rubbish instead of normal colour.

2. ENABLE_VIRTUAL_TERMINAL_INPUT flag is cleared if set.

3. "ClearType-friendly redraw" option does nothing on Windows 10 now.

drkns 28.11.2018 01:12:50 +0000 - build 5330

1. Show LastError & NTSTATUS in the exception handler, if possible.

svs 27.11.2018 16:57:10 +0300 - build 5329

1. SQLite 3.25.3

drkns 26.11.2018 23:46:06 +0000 - build 5328

1. 0001726: Entering symbols using Input Method Editor doesn't work.

drkns 25.11.2018 22:07:47 +0000 - build 5327

1. Some improvements in exception handling.

2. Refactoring.

w17 23.11.2018 16:13:05 +0300 - build 5326

1. New option 'Save view mode' (true by default)

2. New option 'Detect dump view mode' (true by default)
   If disabled, new files will be always opened in text mode.

3. Changed F2 key behaviour in viewer:
   For Dump - switch to Text,
   For Code (Hex) - switch to either Dump or Text (F4 and F2 choose different modes)

drkns 21.11.2018 09:17:30 +0000 - build 5325

1. Typo in 5324.

drkns 20.11.2018 19:20:12 +0000 - build 5324

1. Partial revert of 5276: restored reading highlighting/sorting groups in the old format.
   If new parameters don't exist, but old ones do - we will read them, delete and save as a new immediately.

   The next attempt to finally remove the legacy code is in a year.

drkns 20.11.2018 01:10:03 +0000 - build 5323

1. New versions of tinyxml2 and fmt.

2. Refactoring.

drkns 18.11.2018 23:20:04 +0000 - build 5322

1. /clearcache command didn't work.

drkns 18.11.2018 14:59:47 +0000 - build 5321

1. Refactoring.

drkns 18.11.2018 11:07:28 +0000 - build 5320

1. And FastFind again.

drkns 17.11.2018 22:05:54 +0000 - build 5319

1. More 0003679: always reset a filter when closing a combobox.

drkns 17.11.2018 00:11:01 +0000 - build 5318

1. 0003679: DM_LISTGETCURPOS works incorrectly after pressing Esc in a filtered combobox.

zg 15.11.2018 15:00:02 +0200 - build 5317

1. ECTL_GETCOLOR was returning incorrect coordinates.

drkns 15.11.2018 07:37:31 +0000 - build 5316

1. And FastFind again.

drkns 15.11.2018 00:53:53 +0000 - build 5315

1. And once more.

drkns 14.11.2018 00:40:20 +0000 - build 5314

1. Some improvements in exception handling.

2. Strange things when closing FastFind with a mouse.

3. Correction of 5304.

4. Refactoring.

zg 14.11.2018 20:28:30 +0200 - build 5313

1. gcc.

drkns 12.11.2018 23:59:59 +0000 - build 5312

1. If codepage detection failed, but we know that it can't be valid UTF-8/16 -
   ANSI will be used, even if UTF-8/16 is the default. Less chance of damaging the text.

2. A few minor changes.

drkns 10.11.2018 18:52:03 +0000 - build 5311

1. Since SQLite doesn't support nested transactions and we use them only for performance -
   nested begin/end are ignored now.

drkns 10.11.2018 00:09:59 +0000 - build 5310

1. Small file sorting optimisations.

2. Refactoring.

w17 09.11.2018 14:25:26 +0300 - build 5309

1. GH #77 3.0.5300: Viewer Save file position is broken

drkns 09.11.2018 09:02:24 +0000 - build 5308

1. 5307 revealed an ancient bug - incorrect handle usage.

drkns 08.11.2018 21:55:13 +0000 - build 5307

1. Some improvements in exception throwing and handling.

2. After 5304 the profile was consireded "read only" in some cases.

3. Refactoring.

drkns 08.11.2018 08:56:21 +0000 - build 5306

1. Forum: Far hangs after moving the system date back a day.
   Some genius in MS implemented sleep_for in terms of sleep_until. *facepalm*

drkns 08.11.2018 00:26:26 +0000 - build 5305

1. Some improvements in exception handling.

2. Redundant allocations during subsequent SCTL_CREATESUBKEY calls.

drkns 06.11.2018 20:35:22 +0000 - build 5304

1. Major SQLite changes: now instead of returning false or error code (which we almost never checked anyway) on failures
   exceptions will be thrown. Currently they are handled during db opening (due all the shenanigans we do there)
   and plugin settings instantiation (for obvious reasons), i.e. SCTL_CREATE, as promised, will return FALSE in case of failure.
   This should also fix 0002940: SCTL_CREATE: issues when creating multiple instances of settings.
   In the rest of the code these possible exceptions are (currently) not handled, so you will notice if anything goes wrong.
   SQLITE_BUSY is processed separately - after a 5-sec timeout it will be possible to either retry or abort the operation

   In other words - these changes are quite experimental, here be dragons.

MZK 05.11.2018 22:34:40 -0800

1. Translated help page @OSCommands into English and reworked the Russian page.

drkns 05.11.2018 18:44:11 +0000 - build 5303

1. Fix 5281.2.

drkns 30.10.2018 22:03:16 +0000 - build 5302

1. GH #74 Problem with relative paths in arguments if running from directory with full path longer than MAX_PATH chars
   Let's try passing the short name to SHELLEXECUTEINFO.lpDirectory if the long one is longer than MAX_PATH.

drkns 29.10.2018 19:17:34 +0000 - build 5301

1. Forum: Shift+BS doesn't reset the filter.

drkns 28.10.2018 14:00:50 +0000 - build 5300

1. Reduce transactions lifetime in HierarchicalConfigDb for internal databases.
   For plugins everything is the same as before for now.

drkns 27.10.2018 17:44:42 +0100 - build 5299

1. Forum: Crash when renaming 1.1.1 to *.*.2

drkns 26.10.2018 23:27:41 +0100 - build 5298

1. And once more.

drkns 26.10.2018 23:09:45 +0100 - build 5297

1. Fix 5281.2.

drkns 26.10.2018 19:48:27 +0100 - build 5296

1. Forum: Visual issue with moving items between groups in Files highlighting

drkns 26.10.2018 18:59.10 +0100 - build 5295

1. FSF.FarClock / Far.UpTime worked incorrectly after 5080.

2. Color dialog improvements.

drkns 26.10.2018 01:20:13 +0100 - build 5294

1. Forum: Add color code (#RRGGBB) to the Color dialog

drkns 25.10.2018 20:33:20 +0100 - build 5293

1. Fix 5291.

drkns 24.10.2018 22:20:59 +0100 - build 5292

1. In command line and file associations "if [not] exist" parser didn't work properly - a first encountered "not" was affecting all nested "if", e.g. "if not exist foo if defined tmp echo yes".
   I suppose it newer worked properly.

2. A few minor changes.

drkns 24.10.2018 00:09:27 +0100 - build 5291

1. Refactoring.

drkns 22.10.2018 22:26:20 +0100 - build 5290

1. Fix 5288.1.

drkns 21.10.2018 15:23:33 +0100 - build 5289

1. Fix 5288.1.

drkns 20.10.2018 23:14:28 +0100 - build 5288

1. Hello again, rainbow: continuation of build 2070 after seven years.
   - Added a new option "Use Virtual Terminal for rendering" to Interface settings.
   - Added "Advanced" button to Color dialog.
   - Fixed bugs related to colors combination.
   In other words - happy Windows 10 owners now can enjoy TrueColor without intermediaries and right on the spot.

2. Workaround for https://github.com/Microsoft/console/issues/281.

drkns 14.10.2018 13:21:57 +0100 - build 5287

1. Removed added in 2145 options "Highlight column separators" and "Double stripe separators".
   Separators always use Panel.Box colour and doubled between stripes.

drkns 14.10.2018 02:29:18 +0100 - build 5286

1. Removed option "-a Disable display of characters with codes 0 - 31 and 255".
   Reason: Far already doesn't show control characters for like 15 years, always replacing them with unicode glyphs.

2. Removed option "-ag Disable display of pseudographics characters".
   Reason: not all pseudographics was covered anyway and only in the interface, but not in, say, editor content or file names.
   If for aesthetic reasons you find frames with -=|+ more pleasant than with ─═║┼ - System.BoxSymbols can be changed via far:config.

drkns 13.10.2018 10:38:58 +0100 - build 5285

1. Show "<Folder>" or "<  Up  >" for folders in "P" column (allocation size) as well.

drkns 10.10.2018 19:46:45 +0100 - build 5284

1. Fix 5281.2.

drkns 09.10.2018 23:49:36 +0100 - build 5283

1. Fix 5273.1.

svs 09.10.2018 09:22:17 +0300 - build 5282

1. SQLite 3.25.2

drkns 09.10.2018 01:14:41 +0100 - build 5281

1. Fix bugs in string_view implementation for VS2015.

2. Refactoring.

w17 06.10.2018 21:06:14 +0300 - build 5280

1. Fix 3837

drkns 03.10.2018 11:41:16 +0300 - build 5279

1. Correction of 5276.2.

drkns 02.10.2018 19:19:52 +0300 - build 5278

1. #71: Ampersand in !?<title>?<init>!

drkns 02.10.2018 02:59:59 +0300 - build 5277

1. The color preview in Files highlighting takes transparency into account.

2. The color preview in Color dialog takes transparency into account.

3. By default directories highlighting does not make an exception for ".." (simpler rules and faster processing).

drkns 30.09.2018 17:49:39 +0300 - build 5276

1. Continuation of 5068: removed reading filters and highlighting/sorting groups in the old format.

2. Filters menu now works in the same way as all other dynamic menus - all changes performed in it
   will be applied regardless of how it has been closed - using Esc or Enter.

3. Visual artefacts during moving items of the highlighting menu with Ctrl+Up / Ctrl+Down.
   Also, menu optimisation: items updated individually instead of "erase all and read from scratch".

4. New versions of tinyxml2 and fmt.

5. Refactoring.

drkns 30.09.2018 02:13:21 +0300 - build 5275

1. Lng MListFileSize can contain "{3}" replacement field, which will receive a sum of files and folders.
   By replacing the string with something like "{0} bytes in {3} files" one can get the same selection status as before 4442.

drkns 30.09.2018 00:16:35 +0300 - build 5274

1. More 5141 aka M#3578: the fix didn't work for formats like "ddddddddd, dd/MM/yy".

2. Correction of wildcards processing in file names. It should be closer to cmd now.

3. Scanning directories on plugin panels uses the same UI as on the regular.

4. Crash on elevation dialog appearing during tree re-reading.

5. Window maximise/restore didn't work during some operations.

6. Refactoring.

drkns 26.09.2018 18:54:39 +0300 - build 5273

1. Added keyboard-style delays to mouse handling for cases like "a button is pressed and held for scrolling":
   action -> long pause -> action -> short pause -> action -> short pause -> action...

2. Small refactoring and a few more corrections of 5268.1.

MZK 23.09.2018 19:02:35 -0700

1. Translated help page @SelectFiles into English and reworked the Russian page.

drkns 20.09.2018 07:47:30 +0100 - build 5272

1. Correction of 5264.1.

MZK 18.09.2018 00:12:21 -0700

1. Help: clarified description of file size formatting options.

w17 17.09.2018 21:04:43 +0300 - build 5271

1. Another correction of 5268.1.

svs 17.09.2018 13:56:40 +0300 - build 5270

1. SQLite 3.25.0

drkns 16.09.2018 07:59:04 +0100 - build 5269

1. Correction of 5268.1.

drkns 15.09.2018 15:13:24 +0100 - build 5268

1. Refactoring. Patterns of "int X1, int X2, int Y1, int Y2" form are replaced with "rectangle", "int X, int Y" - with "point".

2. Experimental: Ctrl+U does not change the size of panels.

3. tag_build.bat should work correctly in locales other than 866.

zg 13.09.2018 12:09:52 +0300 - build 5267

1. correction of 5262: DialogInit(-1,-1,0,0) call is equal to DialogInit(-1,-1,1,1).

drkns 10.09.2018 20:39:25 +0100 - build 5266

1. Export of pluginhotkeys.db was broken.

drkns 06.09.2018 23:43:10 +0100 - build 5265

1. Initial size calculation would display incorrectly when deleting several folders.

2. assert in debug when space is typed in the command line.

3. Refactoring.

drkns 04.09.2018 21:37:50 +0100 - build 5264

1. In presence of the elevated process the main process would stop earlier than necessary.

2. Forum: Error getting help on plugin.

MZK 02.09.2018 23:09:13 -0700

1. Translated help page @ChangeDriveMode into English and edited Russian page.

drkns 02.09.2018 22:14:00 +0100 - build 5263

1. "Owner" field in attributes dialog has been moved to the bottom.

2. Refactoring.

3. Update Slovak translation.

zg 01.09.2018 18:59:52 +0300 - build 5262

1. check for correctness of coordinates in DialogInit.

drkns 22.08.2018 23:59:59 +0100 - build 5261

1. Rollback of rollback of (4858), revert to 4853 and shared_mutex. It may improve search in archives. Or not.

zg 22.08.2018 17:50:28 +0300 - build 5260

1. rollback of 5256.

drkns 22.08.2018 02:28:40 +0100 - build 5259

1. CRT VS 2017 15.8 turned out to be full of yet another junk, vc_crt_fix* are updated for support of old OS.

MZK 19.08.2018 16:14:41 -0700

1. Translated help page @Codepages.NoAutoDetectCP into English.

drkns 19.08.2018 14:58:35 +0100 - build 5258

1. Corrections in processing of ".." in plugin panels.
   - OPIF_ADDDOTS always adds "..".
   - if OPIF_ADDDOTS is not set then the parent directory is the first ".." in the list regardless of FILE_ATTRIBUTE_DIRECTORY presence.
   - Distinguish between a virtual ".." and a real folder if possible.

drkns 19.08.2018 08:53:24 +0100 - build 5257

1. VS 2017 15.8.1.

zg 15.08.2018 00:00:47 +0300 - build 5256

1. protect all plugin calls with a global critical section.

drkns 09.08.2018 21:06:04 +0100 - build 5255

1. SQLite does not use rand_s() since 3.21 so Win2k support which has been introduced in 4710 now can be removed.

2. A couple of issues.

drkns 05.08.2018 14:05:25 +0100 - build 5254

1. Continuation of 5252.

drkns 03.08.2018 12:13:31 +0100 - build 5253

1. Continuation of 5249.

drkns 03.08.2018 00:28:15 +0100 - build 5252

1. Correction of 5248.

drkns 02.08.2018 19:06:57 +0100 - build 5251

1. Correction of 5250.2.

drkns 02.08.2018 18:08:20 +0100 - build 5250

1. Refactoring.

2. A few small tweaks of interaction with sqlite.

zg 02.08.2018 18:54:18 +0300 - build 5249

1. correction of 5242.1 when the panel is closed in GetFilesW and DeleteFilesW.

drkns 01.08.2018 15:04:37 +0100 - build 5248

1. Refactoring.

drkns 25.07.2018 00:21:37 +0100 - build 5247

1. Correction of 5240.

2. Refactoring.

drkns 23.07.2018 23:54:41 +0100 - build 5246

1. Continuation of 5211.1. Associations !.! must be working again in archives.

zg 24.07.2018 00:57:09 +0300 - build 5245

1. correction of 5242.1 if the panel is closed in GetFindDataW.

drkns 23.07.2018 20:05:28 +0100 - build 5244

1. Refactoring of strings and string literals.

drkns 22.07.2018 23:02:33 +0100 - build 5243

1. Adapter UUID is checked on load, duplicates are ignored.

2. clang & gcc warnings.

3. Some renaming.

zg 22.07.2018 16:11:54 +0300 - build 5242

1. FCTL_CLOSEPANEL closes panel synchronously.

2. gcc warnings.

drkns 21.07.2018 18:41:29 +0100 - build 5241

1. Null character could not be entered in command line for some reason.

2. Strings containing null characters would be correctly added to db and incorrectly read.

drkns 20.07.2018 23:07:50 +0100 - build 5240

1. Fix obtaining strings with winapi functions.

drkns 16.07.2018 18:30:13 +0100 - build 5239

1. Correction of 5238.2.

drkns 15.07.2018 14:42:42 +0100 - build 5238

1. New versions of tinyxml2 and fmt.

2. Adapters are shown in far:about.

drkns 14.07.2018 20:45:49 +0100 - build 5237

1. Clang warnings.

2. Compiler is shown in far:about.

drkns 08.07.2018 14:29:41 +0100 - build 5236

1. Improve exceptions processing.

2. Refactoring.

drkns 07.07.2018 14:31:27 +0100 - build 5235

1. Correction of 5215.

drkns 29.06.2018 20:49:29 +0100 - build 5234

1. #54: Far crashes when trying to free up memory used to store Descript.ion file records

drkns 27.06.2018 22:31:19 +0100 - build 5233

1. Continuation of 5068: remove storing filters and highlighting/sorting groups in the old format.

2. Refactoring.

zg 27.06.2018 13:41:38 +0300 - build 5232

1. correction of 5222.

drkns 22.06.2018 19:39:48 +0100 - build 5231

1. Correction of 5230.2.

drkns 21.06.2018 22:26:50 +0100 - build 5230

1. 0003531: Sort far:config entries.

2. "Eat Your Own Dog Food" - implementation of #1 revealed inconveniences in Dialog API.
   FarListItem now contains intptr_t UserData in order to bind data to the list item
   not fiddling with sending messages (unrelated to DM_LIST<G|S>ETDATA, there's other data).

drkns 21.06.2018 18:53:53 +0100 - build 5229

1. 0003621: It would be good to show "volume label" for network devices.

w17 20.06.2018 17:40:35 +0300 - build 5228

1. M#3614: arclite does not update sizes of files inside archive if external editor is used

svs 09.06.2018 18:11:19 +0300 - build 5227

1. SQLite 3.24.0

zg 05.06.2018 12:47:24 +0300 - build 5226

1. do not sort panel while receiving file list from plugin.

drkns 03.06.2018 10:21:52 +0100 - build 5225

1. Naive logic "if the file contains ASCII only then open it with default codepage" would not take 
   into account that user could set the default codepage to UTF-16.
   Also, simplify the codepage guessing logic.

2. Continuation of 5215, 5205, 5141 : date/time parsing in attributes/filters dialogs does not look for
   separators - we have got the input mask and know exactly what to search and where.

3. If editor settings have "[x] Allow editing files opened for writing" set then append FILE_SHARE_DELETE.

4. Correct the UTF-8 recognition algorithm.

5. Refactoring.

drkns 28.05.2018 17:48:30 +0100 - build 5224

1. After F3 on plugin panel and cancelling the scanning the allocated memory was not freed.

2. Refactoring.

drkns 23.05.2018 22:50:03 +0100 - build 5223

1. fmt v5.

2. VS2017 warning: std::all_of - nodiscard.

3. "Find all" menu could be bigger than needed.

zg 23.05.2018 16:25:25 +0300 - build 5222

1. crash if help is opened with menu and then the console window is closed with "X".

zg 22.05.2018 21:28:23 +0300 - build 5221

1. forum: If a dialog is redrawing something inside itself regularly (say, once a second)
   while user is trying to grab (AltIns) the part of console window
   then the displayed capture area is being reset constantly.

drkns 20.05.2018 17:11:57 +0100 - build 5220

1. Links to main help file themes were erroneously considered external.

drkns 20.05.2018 11:51:48 +0100 - build 5219

1. Forum: clock won't refresh.

drkns 19.05.2018 15:06:40 +0100 - build 5218

1. Another odd bug after 5211.

drkns 19.05.2018 13:37:59 +0100 - build 5217

1. Bring interface of handmade string_view closer to the standard one. Part 2 - iterators.

2. Use std::string_view (if present).

3. Metacharacters wouldn't expand in the caption of variable substitution dialog called from user menu.

drkns 18.05.2018 21:42:40 +0100 - build 5216

1. Bring interface of handmade string_view closer to the standard one. Part 1 - _sv -> sv.

drkns 17.05.2018 21:55:24 +0100 - build 5215

1. Continuation of 5211 - odd bugs.

2. #0003608: 3.0.5214 x86 - changing attributes resets year to 2000 in DD.MM.YYYY (should be 5205).

drkns 16.05.2018 23:07:37 +0100 - build 5214

1. Use OS regional settings to group digits in numbers.

2. Refactoring.

drkns 15.05.2018 22:05:12 +0100 - build 5213

1. Another pair of corrections for 5211.

2. Refactoring.

drkns 14.05.2018 19:29:57 +0100 - build 5212

1. Correction of 5211.

drkns 14.05.2018 00:15:53 +0100 - build 5211

1. Refactoring. A lot of changes in fnparse.cpp, possible glitches in processing of metacharacters.

2. In some cases, possiblility of empty short filename returned by OS was ignored.
   Now it should be checked everywhere.

drkns 10.05.2018 23:23:38 +0100 - build 5210

1. 0003606: Pause before displaying result of Ctrl+Q on folder

drkns 07.05.2018 16:51:02 +0100 - build 5209

1. Remove unwanted things from headers.hpp. Part 3.

2. 0003605: Command 'cd /d' doesn't work in User Menu

zg 06.05.2018 17:39:35 +0300 - build 5208

1. AltF1 F4 Enter - the dialog disappears and appears again after cursor move.

zg 06.05.2018 14:57:28 +0300 - build 5207

1. forum: Invoke Options->File panel modes dialog, then proceed to, say, Long descriptions and press Ctrl+Enter - the dialog disappears.

drkns 05.05.2018 17:04:38 +0100 - build 5206

1. Remove unwanted things from headers.hpp. Part 2.

w17 04.05.2018 15:40:01 +0300 - build 5205

1. forum: crash while parsing a date out of spaces if the date separator is also a space.

zg 04.05.2018 12:57:28 +0300 - build 5204

1. forum: unpacking an archive on Shift-F2: the name of the archive is not substituted as a folder for unpacking.

drkns 03.05.2018 21:55:10 +0100 - build 5203

1. Remove unwanted things from headers.hpp. Part 1.

drkns 02.05.2018 21:03:29 +0100 - build 5202

1. GCC 7.1 warning.

2. Possible truncation of a file name in copy dialog.

drkns 02.05.2018 00:54:38 +0100 - build 5201

1. Possible garbage in drive change error dialog.

drkns 01.05.2018 22:48:34 +0100 - build 5200

1. For some global objects independent of the rest of code and potentially required everywhere
   (imports, console, memcheck), use Nifty Counters to guarantee their availability at any time.

2. Incluse precompiled headers and memcheck with the compiler tools.

3. Other refactoring.

drkns 28.04.2018 17:04:23 +0100 - build 5199

1. Remove formatting with spaces from *.lng finally.

2. GCC.

3. Warnings.

4. Refactoring.

drkns 26.04.2018 23:49:40 +0100 - build 5198

1. Do not show stack on *.lng reading errors.

drkns 25.04.2018 20:44:36 +0100 - build 5197

1. Show no more than 5 processes in blocked file dialog.
   Also show additional information on the processes.

2. Refactoring.

drkns 24.04.2018 23:29:12 +0100 - build 5196

1. Because of introduction string_view::data() without terminating zero in C++17 
   and potential bugs while replacing string to string_view where \0 is important, 
   use string::c_str() instead string::data() where it is justified.

   A rule of thumb: if string::size() is used somewhere nearby then data() is ok, else use c_str().

   Examples:
   auto RawPointer = string.c_str();               // c_str here
   WinapiFunction1(string.c_str());                // c_str too
   WinapiFunction2(string.data(), string.size());  // data here

2. Minor refactoring related to #1.

w17 23.04.2018 23:42:59 +0300 - build 5195

1. Correction of 5194.

drkns 21.04.2018 20:29:10 +0100 - build 5194

1. Show less rubbish in Task List.

MZK 15.04.2018 18:17:41 -0700

1. Reworked @CodePagesMenu and @EditCodePageNameDlg help pages.

MZK 14.04.2018 14:38:52 -0700 - build 5193

1. Reworked @FindAllMenu and @FileOpenCreate help pages.

2. Minor improvement of the Find-all menu.

drkns 14.04.2018 19:18:53 +0100 - build 5192

1. Continuation of 5190.

drkns 14.04.2018 11:34:11 +0100 - build 5191

1. Continuation of 5190.

drkns 13.04.2018 23:41:30 +0100 - build 5190

1. Continue experimenting with launcher - now it is also used to launch links from help pages.
   Side effect - one can launch http://example.com etc. from command line.
   Also trying to define console-ness for the specified of associated program if shortcuts are launched.

2. GCC 7.3.

3. Correction of 5188.

svs 12.04.2018 20:41:01 +0300 - build 5189

1. SQLite 3.23.1

drkns 09.04.2018 07:48:13 +0100 - build 5188

1. Limit the Find-All menu hight to the half of the window heigh.

drkns 09.04.2018 07:28:34 +0100 - build 5187

1. Forum: Bug in renaming (Shift-F6) a file on a network share.

drkns 08.04.2018 13:30:30 +0100 - build 5186

1. Removed 'System settings / CD drive auto mount' (Windows 9x artefact, forgotten in 662).

MZK 07.04.2018 21:20:12 -0700 - build 5185

1. Find-all menu disappeared after go to a bookmark (LeftCtrl+0..9).

drkns 05.04.2018 11:07:08 +0300 - build 5184

1. Correction of 5182.

svs 04.04.2018 20:22:36 +0300 - build 5183

1. SQLite 3.23.0

drkns 04.04.2018 19:02:50 +0300 - build 5182

1. Repeated search of the string suffix did not work (aftermath of 5181). Try to fix another way.

MZK 02.04.2018 20:46:14 -0700 - build 5181

1. Fixed buffer overflow in SearchString + refactoring.

drkns 02.04.2018 16:36:26 +0300 - build 5180

1. Correction of 5175.

zg 02.04.2018 13:55:55 +0300 - build 5179

1. ctrlenter in "menu with the list of all matching entries" incorrectly refreshed the screen.

w17 02.04.2018 12:04:49 +0300 - build 5178

1. Extract alternate streams from .wim archives

drkns 31.03.2018 01:41:08 +0300 - build 5177

1. Use std::any (if present).

drkns 30.03.2018 11:35:45 +0300 - build 5176

1. Continuation of 5175.

drkns 29.03.2018 13:05:45 +0300 - build 5175

1. Forum: crash on File panel modes -> Ins Enter.

2. Incorrect deletion of multiple selected symlinks.

3. Refactoring.

drkns 23.03.2018 19:16:27 +0000 - build 5174

1. Continuation of 5173 - similar changes in deletion progress window.

drkns 23.03.2018 00:15:02 +0000 - build 5173

1. Folder scanning window is rearranged:
   - now it always looks identical (F3 on a folder, before copying, before deleting)
   - total size and number of items is displayed
   - F3 on multiple folders does not flicker any more.

drkns 20.03.2018 21:35:50 +0000 - build 5172

1. Correction of 5171.

drkns 19.03.2018 22:47:53 +0000 - build 5171

1. Choice of standard association in archive plugin choice menu worked incorrectly.

2. Refactoring.

MZK 18.03.2018 21:30:11 -0700

1. Rewrote @PreserveStyle help page (Both English and Russian).

drkns 14.03.2018 22:33:55 +0000 - build 5170

1. Non-functional cosmetics:
   - virtual override -> override
   - (void) -> ()
   - // fallthrough -> [[fallthrough]];
   - --memcpy

drkns 14.03.2018 10:01:32 +0000 - build 5169

1. A couple of corrections of 5168.

drkns 13.03.2018 22:40:25 +0000 - build 5168

1. Refactoring.

2. clang warnings.

3. Corrections of 5154.

yjh 11.03.2018 14:04:57 +0300 - build 5167

1. Corrections for old OS versions support with the use of DelayLoad

drkns 11.03.2018 09:47:19 +0000 - build 5166

1. 0003591: F9 "Right" item is highlighted while "Left" is not

drkns 10.03.2018 21:35:39 +0000 - build 5165

1. Correction of 5164.1.

drkns 10.03.2018 20:23:38 +0000 - build 5164

1. Fix VS2017.6 warnings instead of suppressing them.

2. "NoDrives" OS policy was not applied to detached network volumes.

drkns 05.03.2018 19:15:49 +0000 - build 5163

1. Correction of 5161.

drkns 05.03.2018 08:01:15 +0000 - build 5162

1. Fix VS2015 build.

drkns 04.03.2018 22:56:16 +0000 - build 5161

1. Static analysis warnings.

2. Refactoring.

drkns 03.03.2018 17:24:57 +0000 - build 5160

1. Do not mix narrow and wide characters in fmt calls.

zg 03.03.2018 17:11:47 +0200 - build 5159

1. correction of 5049: crash after passing null pointer to PointToName.

drkns 02.03.2018 13:57:21 +0000 - build 5158

1. Correction of 5155.

drkns 02.03.2018 09:54:21 +0000 - build 5157

1. Correction of 5155.

drkns 02.03.2018 09:28:54 +0000 - build 5156

1. Correction of 5155.

drkns 01.03.2018 21:45:36 +0000 - build 5155

1. Refactoring.

MZK 28.02.2018 22:26:27 -0800

1. Translated and edited @Viewer help page (both English and Russian).

drkns 01.03.2018 00:25:44 +0000 - build 5154

1. Continuation of 5150.3.

2. Refactoring.

zg 28.02.2018 14:24:01 +0200 - build 5153

1. ECTL_SETSTRING did not set eol when the string is empty.

zg 27.02.2018 13:51:24 +0200 - build 5152

1. Correction of 5150.2.

drkns 26.02.2018 00:18:23 +0000 - build 5151

1. fmt v5.

drkns 25.02.2018 23:42:42 +0000 - build 5150

1. Sorting settings (numeric & case-sensitive) are moved to System Settings.
   Base comparison mode (linguistic / invariant / ordinal) now can be set there as well.
   Sorting settings are applied globally across the board.

2. The function FSF.CompareStrings is available to plugins. It allows to sort the way Far sorts
   (exactly how is not specified and depends on the settings).
   FSF.LStricmp and FSF.LStrnicmp - deprecated; their use is discouraged.

3. FCTL_SETNUMERICSORT, FCTL_SETCASESENSITIVESORT, PFLAGS_NUMERICSORT, PFLAGS_CASESENSITIVESORT do not exist anymore.

MZK 22.02.2018 23:18:21 -0800

1. Edited @CopyFiles help page (English and Russian).

2. Minor help additions and corrections; English translation.

MZK 21.02.2018 22:37:57 -0800 - build 5149

1. Fixed VC15 64-bit compilation error: C3487: 'int': all return expressions must deduce to the same type: previously it was '__int64'.

drkns 21.02.2018 21:29:53 +0000 - build 5148

1. Numeric sort is now more like "as in Windows" with regard to sequences of zeros.

2. In Windows 7 and above, the system function (SORT_DIGITSASNUMBERS) is used for case-insensitive numeric sort.

drkns 21.02.2018 01:56:58 +0000 - build 5147

1. Show module name in the stack trace.

zg 17.02.2018 17:43:21 +0200 - build 5146

1. 0003580: Text in input field is shifted when entering text in another field.

MZK 13.02.2018 23:19:56 -0800

1. Description of columns and stripes on @PanelViewModes and @PanelSettings help pages.

drkns 13.02.2018 20:42:25 +0000 - build 5145

1. Refactoring.

2. Autodetect gcc platform.

MZK 11.02.2018 19:01:14 -0800 - build 5144

1. In the FileList class, renamed "global columns" to "stripes" + refactoring.

drkns 11.02.2018 14:03:19 +0000 - build 5143

1. Correction of 5140 - revert trimming of spaces in lists.

2. Refactoring.

drkns 09.02.2018 00:33:16 +0000 - build 5142

1. Correction of 5140 - revert the logic "separator in square brackets is not a separator" for lists of masks.

2. Refactoring.

w17 08.02.2018 15:04:43 +0300 - build 5141

1. Forum: Commas in date

drkns 07.02.2018 23:31:59 +0000 - build 5140

1. Unify Go To dialogs (Alt+F8) in viewer and editor - now this is one dialog. Bugs are expected.

2. UserDefinedList is fully removed. String tokenization is now lazy everywhere and does minimum or zero allocations.

3. Other refactoring.

MZK 04.02.2018 22:16:59 -0800

1. Translated @FindFileAdvanced and @PanelSettings help pages to English in FarEng.hlf.m4.

2. Added missing option descriptions to Russian and English help.

w17 05.02.2018 01:51:12 +0300 - build 5139

1. fix 5136.2

zg 04.02.2018 19:58:46 +0200 - build 5138

1. guid for "Plugin information" dialog.

zg 04.02.2018 15:03:05 +0200 - build 5137

1. if the height of editor/viewer is less than 3 then the hotkeys panel is not shown.

2. if the height of editor/viewer is less than 2 then the status line is not shown.

drkns 03.02.2018 14:02:24 +0000 - build 5136

1. There were no warnings on rewrite when moving multiple files into one of them.
   An old bug existing from 1.0 b4.

2. GH #22: Add support for symbolic links creation without elevation.

3. Corrections of hlf, lng and documentation.

4. Support for git in update_headers.bat

5. Minor fixes.

MZK 01.02.2018 22:43:46 -0800

1. Translated @FindFile help page to English in FarEng.hlf.m4.

2. Replaced "codepage" with "code page" in the help and resource files.

zg 01.02.2018 22:12:58 +0200 - build 5135

1. In the part-screen editor/viewer, only editor/viewer was redrawn after CtrlO.

2. In the part-screen editor/viewer, CtrlB/CtrlShiftB did not work.

3. Forum: In the part-screen editor/viewer, hotkey panel sometimes did not refresh.

MZK 28.01.2018 15:50:33 -0800

1. Translated @FarAbout and @FarConfig help pages to English in FarEng.hlf.m4.

zg 27.01.2018 14:55:05 +0200 - build 5134

1. 0003577: Incorrect UNDO functioning after Editor.InsStr.

drkns 25.01.2018 22:03:48 +0000 - build 5133

1. '@' in launcher now turns off the echo.

2. 0003525: FCTL_SETUSERSCREEN: undesirable carriage return.
   Suppress it by passing 1 to Param1.

3. Refactoring.

svs 24.01.2018 11:56:03 +0300 - build 5132

1. SQLite 3.22.0

drkns 24.01.2018 07:37:22 +0000 - build 5131

1. '@' now has no meaning in launcher and is ignored.

zg 21.01.2018 15:17:46 +0200 - build 5130

1. correction of 5118.

drkns 20.01.2018 15:25:15 +0000 - build 5129

1. Forum: F5 in filters menu works for the next item

drkns 15.01.2018 21:52:18 +0000 - build 5128

1. 0003575: Selection with "+" with the use of filters

zg 15.01.2018 17:29:26 +0200 - build 5127

1. SendDlgMessage(hDlg,DM_ENABLEREDRAW,TRUE,0) forbid dialog redraw if it was enabled.

2. excessive DM_ENABLEREDRAW calls in color settings menu.

drkns 11.01.2018 23:30:04 +0000 - build 5126

1. Refactoring.

drkns 11.01.2018 16:23:01 +0000 - build 5125

1. 0003574: Alt+F7 search won't work in directories if their names contain a comma

drkns 10.01.2018 23:23:33 +0000 - build 5124

1. Private buffer for ostream as a replacement for CachedWrite.

zg 07.01.2018 17:29:09 +0200 - build 5123

1. after 5118 filling of autocompletion menu vas visible.

drkns 06.01.2018 18:38:21 +0000 - build 5122

1. Standard input/output streams use their own buffer (for more correct processing of unicode).

2. New version of tinyxml2.

drkns 05.01.2018 23:03:50 +0000 - build 5121

1. Fixes for handling exceptions.

drkns 05.01.2018 21:47:18 +0000 - build 5120

1. Static analysis warnings & minor refactoring.

drkns 04.01.2018 18:17:13 +0000 - build 5119

1. Correction of 5108.

2. Optimization for GetFileString.

zg 04.01.2018 15:56:53 +0200 - build 5118

1. reduce the number of redraws for vertical menu.

zg 04.01.2018 14:17:44 +0200 - build 5117

1. if the dialog has cancelled moving while ctrlf5 effect, the keypress is passed to the dialog procedure.

zg 30.12.2017 19:30:26 +0200 - build 5116

1. 0003573: If File View (F3) is invoked from Find Files (Alt-F7) results, switching to Edit (F6) shows Find Files dialog.

drkns 27.12.2017 21:45:47 +0000 - build 5115

1. Correction of 5114.

drkns 21.12.2017 21:50:42 +0000 - build 5114

1. After 4563 the recursive tree walk would not enter DFS catalogs.
   Conceptually, while walking the tree we are only interested in junction and symlink, but FILE_ATTRIBUTE_REPARSE_POINT
   can formally mean anything, therefore checking only this attribute is not enough.
   Now protection from recursive links and other useful and useless intellect in this and other places
   is applied only to IO_REPARSE_TAG_MOUNT_POINT and IO_REPARSE_TAG_SYMLINK.

drkns 20.12.2017 23:36:38 +0000 - build 5113

1. Another correction of 5108.

2. For lines inserted by ansi plugins, explicit absence of EOL could be ignored.

drkns 20.12.2017 12:25:34 +0000 - build 5112

1. G#12 - correction of 5108.

drkns 20.12.2017 07:56:47 +0000 - build 5111

1. Correction of 5108.1 - bugs as expected.

drkns 19.12.2017 23:12:07 +0000 - build 5110

1. Remove excessively smart processing of prefixes (rollback down to 1840), it also fixes G#11.

2. Refactoring.

drkns 19.12.2017 08:16:14 +0000 - build 5109

1. Correction of 5108.

drkns 18.12.2017 19:00:52 +0000 - build 5108

1. Refactoring. Weird processing of line ends in editor has been redone. Bugs are possible.

2. Support for the next VS2017 update.

drkns 17.12.2017 16:24:34 +0000 - build 5107

1. 0003120: Search and Replace in Editor fails if Replace pattern contains 0x0D + Search Pattern
   Also, block Undo has been added.

drkns 13.12.2017 17:28:49 +0000 - build 5106

1. arclite and netbox could get unexpected values from apiCreateFile.

zg 30.11.2017 02:10:31 +0200 - build 5105

1. 0003529: FE_GOTFOCUS is not sent on panel create.

zg 29.11.2017 23:09:27 +0200 - build 5104

1. 0003561: Macro area is not changed on QView switch off.

zg 29.11.2017 18:50:13 +0200 - build 5103

1. 0002737: FCTL_SETPANELDIR closes plugin panels for no purpose.

zg 28.11.2017 17:39:59 +0200 - build 5102

1. FCTL_SETPANELDIRECTORY: always returned TRUE for plugin panels.

2. FCTL_SETPANELDIRECTORY: OPM_SILENT flag would not be used when setting the directory for a plugin panel.

drkns 26.11.2017 21:10:49 +0000 - build 5101

1. Don't use GetThreadLocale().

zg 26.11.2017 17:18:49 +0200 - build 5100

1. remove implementation of panel.SetPath macro function.

drkns 26.11.2017 14:25:46 +0000 - build 5099

1. Correction of 5068 - more correct loading for filters of old format.

2. Refactoring.

drkns 23.11.2017 22:33:18 +0000 - build 5098

1. 0003554: "Search only in the first" parameter is not taken into account in repeated search

2. "Search only in the first" has not been working for 9 years now.

3. 0003558: No search result in FindFiles if current directory ends with a space character

drkns 15.11.2017 21:09:49 +0000 - build 5097

1. Correction of 5095.1.

drkns 15.11.2017 18:56:07 +0000 - build 5096

1. Correction of 5095.1.

drkns 14.11.2017 22:59:35 +0000 - build 5095

1. Refactoring.

2. A new version for fmt.

3. Some help translation.

4. gcc min version is 7.1.

zg 11.11.2017 01:34:14 +0200 - build 5094

1. correction of 5090.

pmisik 08.11.2017 18:40:00 +0000 - build 5093

1. Support to expand environment variables in title

drkns 07.11.2017 20:28:56 +0000 - build 5092

1. 0002323: WindowMode: click in empty space opens menu
   0002648: Mouse selection for copying from the console buffer when MindowMode=true

drkns 05.11.2017 15:25:38 +0000 - build 5091

1. Smarter clipping of command line prompt (by its components).

zg 04.11.2017 20:22:28 +0200 - build 5090

1. rollback of 5082.

2. the last FCTL_SETUSERSCREEN always closes Desktop.

shmuel 03.11.2017 16:34:19 +0200 - build 5089

1. Correction of 5088.

shmuel 03.11.2017 16:12:16 +0200 - build 5088

1. Correction of 4575 for plugin panels.

zg 03.11.2017 13:24:25 +0200 - build 5087

1. various combinations of ctrl, alt and shift do not interrupt selection in editor and do not close quick search in panels.

drkns 01.11.2017 22:08:24 +0000 - build 5086

1. An excessive item is removed from user name format settings in info panel.

2. English translation in Help.

drkns 01.11.2017 17:34:28 +0000 - build 5085

1. In some cases, instructions at the beginning of language files could be ignored.

drkns 31.10.2017 18:35:11 +0000 - build 5084

1. "lua:panel.GetUserScreen(), then f10 and exit - crash".

w17 31.10.2017 20:58:37 +0300 - build 5083

1. Panel.ShowBytes setting will be visible to plugins.

zg 30.10.2017 18:50:05 +0200 - build 5082

1. plugin prefixes are processed outside of launcher context.

drkns 29.10.2017 19:39:55 +0000 - build 5081

1. Error in processing the "%z" parameter of date() function - DST bias was always taken into account.

drkns 29.10.2017 15:39:04 +0000 - build 5080

1. Refactoring.

drkns 28.10.2017 12:18:36 +0100 - build 5079

1. Refactoring - rename & move.

svs 27.10.2017 21:18:41 +0300 - build 5078

1. SQLite 3.21.0

drkns 26.10.2017 23:03:02 +0100 - build 5077

1. Correction of 5076.2 - synchronize caching.

drkns 26.10.2017 20:06:28 +0100 - build 5076

1. Forum: crash on delete with privilege escalation.

2. Caching LookupPrivilegeValue results.

drkns 26.10.2017 00:01:39 +0100 - build 5075

1. Continuation of 3503: pass LastError / LastNtStatus state into Message directly, not via global variables.

drkns 25.10.2017 22:37:34 +0100 - build 5074

1. The sorting groups work only in modes by name and by extension just like before.

drkns 25.10.2017 19:02:49 +0100 - build 5073

1. Correction of 5071 - OEM CP by default.

zg 25.10.2017 13:41:20 +0300 - build 5072

1. 0003524: FCTL_SETUSERSCREEN and dialogs.

drkns 24.10.2017 20:41:53 +0100 - build 5071

1. Correction of 5067 - broken logic "when neither the correct lng nor the english one is found then use anything".

drkns 23.10.2017 20:20:30 +0100 - build 5070

1. Malfunctioning query for privileges when copying symlinks.

2. A couple of issues.

zg 20.10.2017 17:09:22 +0300 - build 5069

1. forum: Dialog redrawing error in Viewer.

drkns 19.10.2017 20:23:16 +0100

1. Fix gcc build.

2. Since I had broken gcc 5 support for 3 weeks ago and nobody complained, the minimum version is now 6.0.

3. Check for presence of Update 3 for VS2015.

drkns 19.10.2017 01:07:23 +0100 - build 5068

1. Inner representation of time uses standard time_point and duration instead FILETIME and raw numbers if possible. The changes are extensive, bugs are expected.

2. Unify the format for filters and highlighting/sorting groups because of too much copy-paste.
   For compatibility the old format is still supported both ways (read and written).
   After a while, the support will be removed.

drkns 18.10.2017 00:47:15 +0100 - build 5067

1. Forum: incorrect displaying of help (actually reading, see "even number of bugs") if its language does not match the current one.

zg 16.10.2017 17:28:26 +0300 - build 5066

1. 0002760: Separate macro areas for GRABBER, HMENU, DESKTOP.

2. 0002761: Publish WTYPE_GRABBER, WTYPE_HMENU, WTYPE_DESKTOP, WTYPE_FINDFOLDER constants in API.

zg 15.10.2017 16:22:28 +0300 - build 5065

1. correction of 5050.1: macro Align Block Special is broken.

drkns 11.10.2017 22:04:47 +0100 - build 5064

1. Privilege escalation on directory creation was broken in 5049.

zg 08.10.2017 14:45:39 +0300 - build 5063

1. 0003514: Possibility of setting priority for macros defined via MCTL_ADDMACRO.

drkns 06.10.2017 18:12:24 +0100 - build 5062

1. And another one.

drkns 04.10.2017 23:47:28 +0100 - build 5061

1. Another one.

drkns 02.10.2017 16:09:16 +0100 - build 5060

1. Another one.

drkns 02.10.2017 15:59:05 +0100 - build 5059

1. Another correction of 5049.

drkns 02.10.2017 00:34:01 +0100 - build 5058

1. Correction of 5057 (actually not, the bug is 4+ years old).

drkns 01.10.2017 22:59:43 +0100 - build 5057

1. Refactoring.

drkns 01.10.2017 10:02:27 +0100 - build 5056

1. Another correction of 5049.

zg 01.10.2017 03:15:57 +0300 - build 5055

1. correction of 5050.1: Start VisRen plugin and press Down many times, some UI flashing occurs.

drkns 30.09.2017 23:23:55 +0100 - build 5054

1. Forum: Search stops after folder (symlink) excluded in filter.

2. Correction of search in alternate streams.

zg 01.10.2017 00:05:03 +0300 - build 5053

1. incorrect sending of DN_CONTROLINPUT with Param1=-1 on any mouse movement if TRUE was returned the first time.

zg 30.09.2017 23:33:20 +0300 - build 5052

1. correction of 5050.1: lua: Keys"F7 Tab" Dlg.SetFocus(3) win.Sleep(200) Keys"Esc"
   A dialog is shown on screen when it seems not to be.

drkns 30.09.2017 14:00:05 +0100 - build 5051

1. Refactoring.

2. Correction of 5049 - incorrect processing of masks containing [] and alignment of extensions.

zg 30.09.2017 15:01:48 +0300 - build 5050

1. partial fix for direct drawing dialog on screen.

2. a non-modal dialog is shown immediately.

drkns 29.09.2017 23:31:12 +0100 - build 5049

1. Start dividing big and ugly farwinapi to separate modules.

2. Refactoring.

3. Forum - crash on empty history.

zg 29.09.2017 11:35:02 +0300 - build 5048

1. DN_GOTFOCUS/DN_KILLFOCUS events with param1=-1 are issued for non-modal dialogs when the window gains/loses the focus.

zg 28.09.2017 19:22:53 +0300 - build 5047

1. if DialogInit has FDLG_NONMODAL flag specified then a non-modal dialog is created and started immediately.
   DialogRun and DialogFree needn't be specified for such a dialog. the dialog is destroyed automatically when closed.

drkns 25.09.2017 22:30:09 +0100 - build 5046

1. Another correction of 5038.

drkns 25.09.2017 20:58:23 +0100 - build 5045

1. Continuation of 4679 - recognition of launch type for system associations given without full path.

drkns 25.09.2017 20:22:04 +0100 - build 5044

1. Correction of 5038.

drkns 25.09.2017 19:57:02 +0100 - build 5043

1. Correction of 5041.

drkns 25.09.2017 08:43:19 +0100 - build 5042

1. 0003506: Crash when Shift+Enter on any folder

drkns 24.09.2017 23:23:04 +0100 - build 5041

1. 0003501: Do not hide panels on launching a prefix according to association from command line

drkns 24.09.2017 21:26:19 +0100 - build 5040

1. 0003504: Hotkey continues functioning after rebind

drkns 24.09.2017 18:26:06 +0100 - build 5039

1. Correction of 5038.2.

drkns 24.09.2017 16:59:37 +0100 - build 5038

1. 0003505: FarMenu.ini may be a folder, we don't try to process it in this case.

2. Some corrections in launcher on files without extensions and on logic of searching for a file to be launched.

zg 23.09.2017 15:25:28 +0300 - build 5037

1. on file save in editor the current directory was set to where the editor was invoked.
   removed.

drkns 21.09.2017 21:43:58 +0100 - build 5036

1. 0003499: Excessive full file path is displayed in command line on launch from panel

2. For some reason, "Use registered types" option would have influence on launch of files without extensions from command line.
   If someone remembers the reason then post it.

drkns 20.09.2017 21:35:37 +0100 - build 5035

1. Continuation of 5030.3.

drkns 20.09.2017 07:37:25 +0100 - build 5034

1. Correction of 5032.

drkns 19.09.2017 23:14:44 +0100 - build 5033

1. 0003497: regexps stopped working (more correct fix than 4492).

drkns 16.09.2017 23:23:44 +0100 - build 5032

1. Continuation of 5030.3.

drkns 15.09.2017 23:44:07 +0100 - build 5031

1. Continuation of 5030.3 - only load/save required folder shortcuts, not all of them.

2. 0003492: Incorrect indication in upper status line

drkns 15.09.2017 00:48:00 +0100 - build 5030

1. 0003490: Crash on F4 in empty submenu

2. 0003491: Unreasonable creation of a submenu after editing undone

3. Folder shortcuts are simplified and reworked.

drkns 13.09.2017 20:19:28 +0100 - build 5029

1. Rollback 5027.2 and 5028.1.

drkns 12.09.2017 21:04:02 +0100 - build 5028

1. Continuation of 0003481.

drkns 11.09.2017 20:45:30 +0100 - build 5027

1. 0003481: hlf: Text can be indented despite absence of <CtrlStartPosChar>

2. CtrlStartPosChar could unexpectedly affect the previous paragraph.

3. Experimental - support for TrueColor in hlf. The format is ([[T]FFFFFFFF][:[T]BBBBBBBB]), same as in prompt.

drkns 09.09.2017 22:00:37 +0100 - build 5026

1. Capture the stack also for the exceptions that have been caught and rethrown via exception_ptr.

2. Refactoring.

drkns 09.09.2017 17:32:31 +0100 - build 5025

1. 0003485: Exception on attempt of viewing an incorrect? hlf

zg 03.09.2017 14:24:00 FLE Daylight Time - build 5024

1. if selection was removed in an inactive editor then it would be drawn on top of all the windows.

drkns 02.09.2017 20:59:58 +0100 - build 5023

1. 0003470: GetVHDInfo called even DRIVE_SHOW_TYPE is not set and even under XP where VHD API is not available

shmuel 02.09.2017 20:34:02 +0200 - build 5022

1. FileList::SetSortMode() - memory read out of array bounds.

drkns 02.09.2017 16:16:24 +0100 - build 5021

1. Correction of 5020.1.

drkns 02.09.2017 15:38:54 +0100 - build 5020

1. Refactoring. Remove duplicated code and move something out from common.hpp.

2. Use IsProcessorFeaturePresent to detect absence of SSE2.

drkns 30.08.2017 20:44:52 +0100 - build 5019

1. New versions of tinyxml2 and fmt.

2. Do not preload lua51.dll for no plugins installed.

svs 30.08.2017 14:14:51 +0300 - build 5018

1. SQLite 3.20.1

w17 30.08.2017 13:53:46 +0300 - build 5017

1. Correction+ of 5015

w17 30.08.2017 13:19:19 +0300 - build 5016

1. Correction of 5015

w17 30.08.2017 12:21:12 +0300 - build 5015

1. Preload %FARHOME%\legacy\lua51.dll if x86 CPU doesn't support SSE2.

drkns 26.08.2017 11:20:44 +0100 - build 5014

1. The 'date' macrofunction was a mess:
   According to documentation, "%Z" should return "Timezone name or empty if timezone unspecified".
   It actually returned the difference between UTC and current TZ as ±hhmm, that is almost as %z in strftime but, ATTENTION, not taking DST bias into consideration.
   As an example, this means that all dates in changelogs (including this one) have little to do with reality.

   Now:
     %Z - is actually the NAME of the timezone, as promised.
     %z - is relative offset of local time to UTC.

   Do not forget to replace %Z with %z in your macros.

shmuel 24.08.2017 15:16:45 +0200 - build 5013

1. MCTL_GETLASTERROR can now be also called after MSSC_POST and MCTL_EXECSTRING.

2. MCTL_EXECSTRING now respects KMFLAGS_SILENTCHECK flag.

shmuel 23.08.2017 12:57:35 +0200 - build 5012

1. KMFLAGS_SILENTCHECK flag was ignored in MSSC_POST command.

drkns 18.08.2017 09:30:57 +0000 - build 5011

1. Adjustment of buttons to the center of search dialog on size change would not work.

drkns 17.08.2017 22:31:49 +0000 - build 5010

1. Forum: hotkeys line would not refresh after browsing the network.

2. Forum: search dialog had the separator incorrectly redrawn on size change.

drkns 16.08.2017 11:43:28 +0000 - build 5009

1. Correction of 5008.

drkns 16.08.2017 09:54:19 +0000 - build 5008

1. Forum: text adjusted to the left/right border was displayed completely even if it would not fit in the borders.

drkns 16.08.2017 09:22:10 +0000 - build 5007

1. Forum: DI_TEXT + DIF_CENTERTEXT was adjusted to dialog center instead of coordinates X1 and X2.

drkns 14.08.2017 21:38:39 +0000 - build 5006

1. Now FCTL_<G|S>ETUSERSCREEN can be used also from editor (-e) and viewer (-v) modes.

drkns 13.08.2017 17:07:42 +0000 - build 5005

1. Correction of 4959.

drkns 11.08.2017 01:15:42 +0000 - build 5004

1. Refactoring.

drkns 09.08.2017 00:11:01 +0000 - build 5003

1. Once more for the owners.

drkns 08.08.2017 20:27:34 +0000 - build 5002

1. 0003466: Memory depletion crash when adding new panel columns with unspecified width

2. Forum: File owner is not shown for a Windows share

svs 08.08.2017 12:26:57 +0300 - build 5001

1. SQLite 3.20.0

drkns 06.08.2017 11:07:04 +0000 - build 5000

1. Another correction of 4996.

drkns 04.08.2017 20:07:24 +0000 - build 4999

1. Forum: "Crash on going upwards from RESearch panel"

drkns 04.08.2017 00:27:23 +0000 - build 4998

1. Correction of 4997 - broken replace.

2. Fix for the old bug on replacing a line containing "\r".

drkns 01.08.2017 20:39:18 +0000 - build 4997

1. Continuation of #3462 - do not change cursor position without the need.

drkns 31.07.2017 20:01:11 +0000 - build 4996

1. Correction of 4995.1.

2. 0003462: Searching for all matches skips match in the first line

3. Do not clear selection ahead of time nor if nothing is found.

drkns 30.07.2017 01:45:36 +0000 - build 4995

1. Refactoring.

drkns 23.07.2017 22:34:57 +0000 - build 4994

1. 0003457: Mouse is functional in FAR even if the "Interface settings - Mouse" setting is off

2. Refactoring.

drkns 23.07.2017 10:31:34 +0000 - build 4993

1. Search would not work in help.

2. Autocompletion would not work in some cases.

drkns 22.07.2017 13:25:18 +0000 - build 4992

1. Forum: Incorrect indication of error position in regular expression

drkns 21.07.2017 19:29:12 +0000 - build 4991

1. Correction of 4989.

drkns 20.07.2017 23:10:16 +0000 - build 4990

1. Return low memory protection, added in 1741 and lost in 3791.

drkns 20.07.2017 01:09:52 +0000 - build 4989

1. Refactoring. Stop spreading PANEL_STOP all over the codebase.

drkns 18.07.2017 20:34:50 +0000 - build 4988

1. Refactoring.

2. Coverity warnings.

shmuel 18.07.2017 13:36:33 +0200 - build 4987

1. M#3428: add GUIDs for dialogs of editing/insertion of user menu items.

drkns 17.07.2017 21:53:50 +0000 - build 4986

1. 0003454: Completion of paths stopped recognition of / as a separator.

shmuel 12.07.2017 23:53:19 +0200 - build 4985

1. Erroneous DM_SETTEXT for DI_LISTBOX (since build 4248).

drkns 04.07.2017 23:44:29 +0000 - build 4984

1. Automatic update of panels would not work in folders with unusual names.

2. Related to #1 refactoring of filesystemwatcher, which was somewhat unclear.

drkns 03.07.2017 19:31:28 +0000 - build 4983

1. A macro could cause an exception in menu with active filter under some circumstances.

drkns 02.07.2017 13:53:50 +0000 - build 4982

1. Forum: Weird values in copy/move dialogs

drkns 01.07.2017 13:08:48 +0000 - build 4981

1. Stubs in vc_crt_fix_impl.cpp are replaced with more or less working implementations.

2. Correct the leak detector.

drkns 28.06.2017 19:02:42 +0000 - build 4980

1. Incorrect display of information on locked file.

2. fmt v4.0.0.

3. TinyXML-2 v5.0.1

drkns 25.06.2017 02:03:37 +0000 - build 4979

1. Refactoring.

drkns 23.06.2017 16:48:00 +0000 - build 4978

1. Forum: unnecessary privilege request

drkns 22.06.2017 23:26:01 +0000 - build 4977

1. Refactoring.

drkns 21.06.2017 07:30:17 +0000 - build 4976

1. In some cases, the plugin could cause an exception in a menu with filter enabled.

svs 19.06.2017 07:24:13 +0300 - build 4975

1. SQLite 3.19.3

drkns 18.06.2017 10:59:10 +0000 - build 4974

1. Correction of 4945.

drkns 05.06.2017 13:26:32 +0200 - build 4973

1. Correction of 4887.

2. Refactoring.

svs 30.05.2017 23:13:19 +0300 - build 4972

1. SQLite 3.19.2

drkns 29.05.2017 14:46:17 +0000 - build 4971

1. Correction of 4969.

shmuel 27.05.2017 02:27:03 +0200 - build 4970

1. Correction of 4585: switching between FAR and plugin panel would not save custom sorting.

drkns 26.05.2017 21:45:31 +0000 - build 4969

1. Continuation of 4963.

svs 24.05.2017 21:58:27 +0300 - build 4968

1. SQLite 3.19.1

drkns 23.05.2017 23:10:16 +0000 - build 4967

1. Another correction of 4963.

drkns 22.05.2017 23:20:20 +0000 - build 4966

1. Correction of 4963.

drkns 22.05.2017 20:44:12 +0000 - build 4965

1. More on gcc 7.

drkns 20.05.2017 23:45:02 +0000 - build 4964

1. gcc 7.

drkns 19.05.2017 23:29:09 +0000 - build 4963

1. 0003434: FormatFileSize function had Width parameter which did not fully meet the documentation.
   API changes: "undetermined" defaults now for 0 instead of -1.

2. Other fixes (and possibly new bugs) around the function.

drkns 16.05.2017 07:34:39 +0000 - build 4962

1. Correction of plugin loading process.

drkns 15.05.2017 14:39:00 +0000 - build 4961

1. Continuation of 4959 - displaying of plugin loading errors is now done by the corresponding loader
   in order to not try showing LastError where there's none. SilentLoadPlugin parameter is removed.

drkns 14.05.2017 20:32:53 +0000 - build 4960

1. Correction of 4957.

drkns 14.05.2017 20:09:37 +0000 - build 4959

1. Extend Adapter API a little:
   BOOL WINAPI GetError(ErrorInfo* info)
     - Far calls the function after each adapter invocation to know if everything is ok.
       If not, the error message will be shown.

drkns 13.05.2017 20:07:39 +0000 - build 4958

1. Fix broken sorting.

drkns 13.05.2017 11:11:40 +0000 - build 4957

1. 0003430: Privilege escalation error in Far 3.0.4949

drkns 11.05.2017 00:06:47 +0000 - build 4956

1. 0003433: FAR doesn't restore console caption changed by a program

2. A pair of minor issues.

drkns 09.05.2017 22:40:36 +0000 - build 4955

1. Correction of 4950 - crash on messages without strings.

drkns 06.05.2017 21:45:46 +0000 - build 4954

1. Correction of 4945.

drkns 05.05.2017 00:31:34 +0000 - build 4953

1. Correction of 4952.

drkns 04.05.2017 20:45:42 +0000 - build 4952

1. Refactoring.

drkns 03.05.2017 00:02:38 +0000 - build 4951

1. Correction of 4950.

drkns 02.05.2017 23:55:28 +0000 - build 4950

1. Somewhat reduce data copying in Message().

zg 02.05.2017 16:38:35 +0200 - build 4949

1. correction of 4945: 'if exist' would not work.

drkns 01.05.2017 22:42:32 +0000 - build 4948

1. Correction of 4945.

zg 01.05.2017 16:49:59 +0200 - build 4947

1. correction of 4945: CtrlEnd would not work in command line and editor lines when autocompletion was off.

zg 01.05.2017 16:05:46 +0200 - build 4946

1. correction of 4945: case-insensitive search in editor would not work.

drkns 01.05.2017 00:21:40 +0000 - build 4945

1. Refactoring.

drkns 27.04.2017 20:58:46 +0000 - build 4944

1. Remove space characters when processing 'pushd'.

2. More correct removal of quotes when processing 'set'.

zg 25.04.2017 12:59:57 +0200 - build 4943

1. exception on mf.fsplit('a.:',0x4+0x8) call

drkns 24.04.2017 07:59:10 +0000 - build 4942

1. Correction of 4940 once more.

drkns 23.04.2017 22:24:28 +0000 - build 4941

1. Correction of 4936.

2. Correction of 4940.

3. Refactoring.

drkns 23.04.2017 15:52:18 +0000 - build 4940

1. 0003216: Shift key is ignored in dialogs when "Append first matched item" autocompletion option is on

drkns 22.04.2017 20:39:26 +0000 - build 4939

1. Correction of 4938.

2. Refactoring.

drkns 22.04.2017 14:04:11 +0000 - build 4938

1. 0003424: New command line parameter for console caption inheritance

2. Correction of completion functioning:
   - sorting does not take quote marks into account
   - save the already typed letter case
   - selection takes the cursor position into account

3. Refactoring.

drkns 18.04.2017 22:21:06 +0000 - build 4937

1. Refactoring.

drkns 17.04.2017 22:16:12 +0000 - build 4936

1. Panel.RememberLogicalDrives must be usable now - saved list of drives will be updated if needed.

2. Launch from a plugin panel removes the temporary file after the panel close, not immediately.

3. Refactoring.

drkns 12.04.2017 18:58:51 +0000 - build 4935

1. Continuation of 4934.

drkns 11.04.2017 07:51:48 +0000 - build 4934

1. Processing of numpad keys in panel modes editing menu.

drkns 08.04.2017 19:00:16 +0000 - build 4933

1. Refactoring.

drkns 06.04.2017 07:53:14 +0000 - build 4932

1. Wiping of empty files would not work.

drkns 05.04.2017 20:10:41 +0000 - build 4931

1. Correction of 4928.

2. Minor issues.

zg 05.04.2017 20:41:01 +0200 - build 4930

1. 0003419: Crash on resizing a window containing an opened drop-down list.

svs 02.04.2017 20:22:22 +0300 - build 4929

1. SQLite 3.18.0

drkns 01.04.2017 13:54:43 +0000 - build 4928

1. Refactoring.

shmuel 28.03.2017 13:40:20 +0200 - build 4927

1. M#3415: error in menu.itemstatus

drkns 26.03.2017 12:56:32 +0000 - build 4926

1. Refactoring.

zg 26.03.2017 14:48:27 +0200 - build 4925

1. RestoreScreen restores the screen content right away.

drkns 24.03.2017 18:18:14 +0000 - build 4924

1. Correction of 4923.

drkns 23.03.2017 23:28:58 +0000 - build 4923

1. Refactoring.

w17 23.03.2017 21:39:02 +0300 - build 4922

1. forum: Automatic replacement of a share with a drive letter
   On navigation from server share list to a selected item with Enter now there is no transition
   to the drive (if assigned), for CtrlPgDn there is the old behavior (is the drive is available, go to it).

drkns 21.03.2017 20:39:52 +0000 - build 4921

1. From the forum: Crash in cancelled file edit in NetBox

drkns 21.03.2017 01:31:42 +0000 - build 4920

1. Debug symbols would not always be loaded.

2. Refactoring.

drkns 20.03.2017 23:25:32 +0000 - build 4919

1. Correction of 4888.

drkns 16.03.2017 23:14:59 +0000 - build 4918

1. Refactoring.

shmuel 15.03.2017 21:40:52 +0200 - build 4917

1. Remove nonstandard behavior of Right and Left keys for moving between check boxes in dialog.
   (If the time shows that the former behavior is more preferable it will be brought back).
   Radio buttons are not touched because it would affect the color selection dialog.

drkns 15.03.2017 11:30:29 +0000 - build 4916

1. Correction of 4907.

2. Refactoring.

drkns 13.03.2017 15:01:25 +0000 - build 4915

1. Correction of processing of SEH exceptions in non-main threads.

drkns 13.03.2017 13:39:47 +0000 - build 4914

1. Forum: Archive containing another archive is deleted

drkns 11.03.2017 00:05:34 +0000 - build 4913

1. Forum: the caption of help window is shifted right.

zg 10.03.2017 13:55:54 +0200 - build 4912

1. under certain circumstances in user menu the editor/viewer, called via edit:/view:, was modal.

drkns 09.03.2017 07:35:59 +0000 - build 4911

1. 0003404: `Lock editing of read-only files` is ignored (regression)

drkns 08.03.2017 19:14:38 +0000 - build 4910

1. Remove constexpr from static objects - it has become even worse in VS2017.

drkns 08.03.2017 17:34:21 +0000 - build 4909

1. VS2017 support.

2. VS2017 & clang warnings.

3. Refactoring.

zg 07.03.2017 03:02:10 +0200 - build 4908

1. remove WaitInMainLoop global variable.

drkns 06.03.2017 14:08:55 +0000 - build 4907

1. Exit from network plugin could cause transition to an inexisting folder.

2. Refactoring.

zg 06.03.2017 14:02:30 +0200 - build 4906

1. 0003401: Weird bug with clock in editor.

drkns 05.03.2017 16:01:22 +0000 - build 4905

1. Forum: when browsing the network with NAS QNAP opening any shared resource adds the current and parent directories to the list for some reason.
   Guys from QNAP seem to be unfamiliar with "2.4.17 FileIdBothDirectoryInformation" too.

drkns 28.02.2017 18:57:23 +0000 - build 4904

1. Temporary files were not removed after invoking viewer from search results.

drkns 27.02.2017 19:04:21 +0000 - build 4903

1. 0003358: ArcLite. The system cannot find the path specified

drkns 22.02.2017 23:45:29 +0000 - build 4902

1. Processing of 'set' command would not remove quotes from the filter.

drkns 21.02.2017 18:50:57 +0000 - build 4901

1. A typo in 4883.

drkns 20.02.2017 19:16:22 +0000 - build 4900

1. Coverity warnings.

drkns 18.02.2017 19:05:09 +0000 - build 4899

1. Refactoring, renaming.

svs 14.02.2017 20:19:16 +0300 - build 4898

1. SQLite 3.17.0

zg 12.02.2017 20:58:11 +0200 - build 4897

1. correction of 4889.

drkns 11.02.2017 15:51:04 +0000 - build 4896

1. Refactoring.

drkns 10.02.2017 22:44:19 +0000 - build 4895

1. Correction of 4892.

drkns 10.02.2017 22:12:46 +0000 - build 4894

1. Refactoring.

yjh 08.02.2017 23:33:29 +0300 - build 4893

1. adaptation of ulink helper to VS2015sp3 headers (const)
2. the previous commit had a compilation error (part of a string was lost)

drkns 08.02.2017 19:50:19 +0000 - build 4892

1. Refactoring.

drkns 08.02.2017 19:44:46 +0000 - build 4891

1. Forum - files which are run via OS associations are written to history unquoted even if their names contain space characters, so repeated launch with Ctrl+E is not possible.

zg 07.02.2017 12:15:01 +0200 - build 4890

1. correction of 4889.

zg 30.01.2017 17:04:33 +0200 - build 4889

1. ECTL_SETTITLE being called from EE_REDRAW does not reset the console buffer.

drkns 24.01.2017 22:13:49 +0000 - build 4888

1. Correction of 4887.

2. Refactoring.

drkns 23.01.2017 19:30:10 +0000 - build 4887

1. Correction of 4885.

2. Refactoring.

w17 23.01.2017 19:46:07 +0300 - build 4886

1. forum: a mark character can't be inserted in highlighting

drkns 20.01.2017 18:35:54 +0000 - build 4885

1. 0003385: User menu is broken after editing.

drkns 19.01.2017 23:30:22 +0000 - build 4884

1. tinyxml2 and fmt new versions.

drkns 19.01.2017 23:23:24 +0000 - build 4883

1. Refactoring.

svs 11.01.2017 15:22:11 +0300 - build 4882

1. SQLite 3.16.2

svs 04.01.2017 23:15:57 +0300 - build 4881

1. SQLite 3.16.1

w17 02.01.2017 13:31:46 +0300 - build 4880

1. Correction of 4874

w17 02.01.2017 12:14:24 +0300 - build 4879

1. Correction and continuation of 4875

drkns 30.12.2016 21:51:04 +0200 - build 4878

1. Remove forgotten debug code.

drkns 30.12.2016 20:12:15 +0200 - build 4877

1. Refactoring.

drkns 28.12.2016 23:04:30 +0200 - build 4876

1. Forum: garbage could be displayed at a panel while moving files with descriptions.

2. Refactoring.

w17 24.12.2016 21:57:03 +0300 - build 4875

1. 0003361: Admin privileges are requested for file rename

w17 24.12.2016 21:39:58 +0300 - build 4874

1. 0003366: expand the area of Ctrl-Shift-S function

w17 22.12.2016 20:51:29 +0300 - build 4873

1. -viewer crashes searching in very long lines.

drkns 19.12.2016 20:38:48 +0200 - build 4872

1. Refactoring.

drkns 18.12.2016 18:52:41 +0200 - build 4871

1. Refactoring.

zg 17.12.2016 01:01:39 +0200 - build 4870

1. 0003367: Undo leaves space characters which were missing before.

drkns 14.12.2016 01:41:17 +0200 - build 4869

1. 0003353: Incorrect drawing after pc wake up from sleep.

2. Minor issues.

drkns 06.12.2016 09:32:48 +0200 - build 4868

1. Rollback 4866.1 for now because it happened to be even worse.

drkns 06.12.2016 02:43:44 +0200 - build 4867

1. Correction of 4866.

drkns 06.12.2016 00:43:52 +0200 - build 4866

1. 0003361: Admin privileges are requested for renaming a file
   The problem is the broken copier, not the privilege request. This is part #1, it may or may not help.

2. If System.WipeSymbol is set to -1, the wipe uses random values.

3. Refactoring.

svs 02.12.2016 12:10:47 +0300 - build 4865

1. SQLite 3.15.2

drkns 01.12.2016 22:11:17 +0200 - build 4864

1. Incorrect path for ".." on panel in screens list (F12)

2. A bit of refactoring.

drkns 29.11.2016 21:50:31 +0200 - build 4863

1. Crash on invoking the associations menu with no associations.

zg 29.11.2016 19:09:02 +0200 - build 4862

1. continuation of 4808.1.

zg 29.11.2016 17:06:30 +0200 - build 4861

1. forum: search files with "*gs.x*" mask in FAR folder (clean FAR has one).
   get an empty field instead of search results and three points in status line.

drkns 28.11.2016 17:01:39 +0200 - build 4860

1. Forum: persistent blocks, editor, a line longer than the screen width,
   go to the end of line (the screen scrolls horizontally), select a short substring, press Home, Far crashes silently

drkns 27.11.2016 11:48:40 +0200 - build 4859

1. On drive change with mouse, the current directory of the panel was not always set.

drkns 26.11.2016 14:11:57 +0200 - build 4858

1. Partial rollback for 4853 for W2k compatibility.

drkns 26.11.2016 03:41:05 +0200 - build 4857

1. In gcc, wcschr and the like removed constness from the returned pointer.
   The bug is 10 years old and it looks like nobody is going to fix it.

zg 25.11.2016 23:42:39 +0200 - build 4856

1. Correction of 4853.2.

drkns 25.11.2016 17:46:52 +0200 - build 4855

1. Correction of 4853.2.

drkns 25.11.2016 17:34:15 +0200 - build 4854

1. gcc 5.

drkns 25.11.2016 15:41:04 +0200 - build 4853

1. 0003355: Far freeze on request for privileges while searching in archives.

2. Continuation of 4849.

drkns 23.11.2016 23:32:50 +0200 - build 4852

1. Forum: crash on persistent blocks and a selected block from nearly the beginning of a line to its end and Enter pressed at the beginning

w17 23.11.2016 08:18:32 +0300 - build 4851

1. Fix for 2643 -- text disappear in viewer.

drkns 23.11.2016 02:44:51 +0200 - build 4850

1. Incorrect displaying of hex viewer.

drkns 22.11.2016 03:33:12 +0200 - build 4849

1. Continue what's started in 4848:
   - update on timeout as elsewhere
   - remove the remnants from search (although not everything)
   - minor corrections in related modules.

zg 21.11.2016 20:27:54 +0200 - build 4848

1. search results dialog is now updated in the main thread. synchronization in dialogs and menus is removed.

drkns 21.11.2016 10:20:02 +0200 - build 4847

1. Another correction of 4834.

2. Refactoring.

w17 20.11.2016 15:40:36 +0300 - build 4846

1. Fix 2201.

drkns 19.11.2016 14:44:48 +0200 - build 4845

1. After 4834 the associations menu worked incorrectly.

2. A couple of issues.

drkns 18.11.2016 20:16:18 +0200 - build 4844

1. Another couple of corrections in 4834.

drkns 18.11.2016 17:53:42 +0200 - build 4843

1. Correction of right border line alignment in UI elements.

2. Coverity warnings.

3. Refactoring.

zg 17.11.2016 11:48:08 +0200 - build 4842

1. 0003352: CtrlC resets "unmodified text" state.

zg 16.11.2016 14:48:22 +0200 - build 4841

1. separate dragging with mouse and with keyboard.

svs 15.11.2016 11:18:33 +0300 - build

1. Append info on "far:config" and "far:about" in Help

drkns 15.11.2016 07:32:16 +0200 - build 4840

1. Remove workaround added in 4835 - fixed in library.

zg 13.11.2016 23:24:26 +0200 - build 4839

1. correction of 4838 for menu.

zg 13.11.2016 20:44:50 +0200 - build 4838

1. remove direct processing of input while dragging a dialog.

drkns 13.11.2016 18:38:58 +0200 - build 4837

1. Correction of 4834.

drkns 13.11.2016 14:47:30 +0200 - build 4836

1. 0003348: Far(build 4834) Trap on show folder/file attribute dialog

drkns 13.11.2016 14:17:47 +0200 - build 4835

1. gcc version did not work in ancient OSes.

drkns 12.11.2016 13:07:03 +0200 - build 4834

1. Use fmtlib instead of FormatString, FormatScreen, str_printf, ostringstream etc.
   A lot of changes, bugs are possible.

2. Other related refactoring.

svs 08.11.2016 08:10:59 +0300 - build 4833

1. SQLite 3.15.1

drkns 04.11.2016 00:29:33 +0200 - build 4832

1. Correction of 4831.

zg 31.10.2016 20:55:32 +0200 - build 4831

1. 0003337: Console caption is not restored since 4809.

drkns 21.10.2016 00:55:50 +0200 - build 4830

1. Coverity warnings.

2. A couple of issues.

shmuel 20.10.2016 19:36:54 +0200 - build 4829

1. M#3275: Allow plugins to load and edit unsaved macro
   Macro browser invokes FAR "Macro settings" dialog after F4/AltF4 on an unsaved keyboard macro.

drkns 20.10.2016 01:41:37 +0200 - build 4828

1. More on Maximise/Restore and Alt+F9.

svs 17.10.2016 11:50:09 +0300 - build 4827

1. SQLite 3.15.0

drkns 15.10.2016 14:32:31 +0200 - build 4826

1. Forum: sometimes decreasing the console size caused garbage in the inner buffer.

2. Other related issues. Write if something has been broken.

zg 15.10.2016 03:59:22 +0200 - build 4825

1. correction of 4808.1.

2. ACTL_REDRAWALL could leave some windows not redrawn.

w17 14.10.2016 20:34:39 +0300 - build 4824

1. Usual behavior showing the number of background windows.
   Panel.ScreenNumber is now 3-state, = 1 by default.
   The number of dialogs is shown for state 2 only.

zg 13.10.2016 17:16:58 +0200 - build 4823

1. 0003327: ECTL_REDRAW does not redraw during processing.

drkns 13.10.2016 09:33:05 +0200 - build 4822

1. Correction of 4603. Pass the enumerated to custom sorting only if it has already been read or it will be read.

drkns 12.10.2016 23:24:37 +0200 - build 4821

1. 0003304: Console output from a plugin is duplicated beyond the window

zg 11.10.2016 18:16:57 +0200 - build 4820

1. correction of 4818: pressing enter on multiarc panel would ask for unpacking.

2. correction of 4818: same behavior for launching built-in associations on enter key press.

drkns 10.10.2016 23:09:35 +0200 - build 4819

1. Shorten copy-paste a bit in file modification time check.

zg 10.10.2016 16:33:04 +0200 - build 4818

1. 0003325: Detect external file editing and post back to plugin.

drkns 10.10.2016 02:27:15 +0200 - build 4817

1. Correction of 4816.

drkns 09.10.2016 21:48:44 +0200 - build 4816

1. Refactoring.

drkns 09.10.2016 01:42:02 +0200 - build 4815

1. Correction of 4796.4.

2. LTCG can be inhibited in makefile_vc for debug purposes.

3. Commands moved from svn_tag_build_ssl.m4 to svn_tag_build_ssl.bat.
   Also, the created tag is now shown explicitly.

drkns 08.10.2016 15:14:07 +0200 - build 4814

1. Line selection would reset on replacement if persistent blocks mode was on.

zg 08.10.2016 13:51:32 +0200 - build 4813

1. 0003324: Find/Replace in editor does not highlight found entries.

drkns 08.10.2016 10:38:23 +0200 - build 4812

1. Workaround for another VS bug.

drkns 08.10.2016 02:27:23 +0200 - build 4811

1. Continuation of 4810.2.

drkns 08.10.2016 01:10:06 +0200 - build 4810

1. More on console flags: instead of creating from scratch we inherit the existing ones and change the necessary.

2. Refactoring.

drkns 06.10.2016 22:59:17 +0200 - build 4809

1. ENABLE_AUTO_POSITION and ENABLE_INSERT_MODE console flags would not be saved:
   - the window could be positioned suboptimally on restore;
   - apps like cmd could work in 'overwrite' mode when launched from FAR.

2. A couple of issues.

zg 06.10.2016 19:59:25 +0200 - build 4808

1. correction of 4803 for nested dialogs.

2. correction of 4807.

zg 05.10.2016 20:37:13 +0200 - build 4807

1. correction of 4803 for the grabber.

drkns 04.10.2016 09:47:59 +0200 - build 4806

1. Correction of 4794 & 4805.

drkns 03.10.2016 21:28:23 +0200 - build 4805

1. 0003318: "Message not found" errors when opening F9 > Options > Colors

drkns 02.10.2016 18:45:31 +0200 - build 4804

1. Refactoring.

zg 01.10.2016 18:23:05 +0200 - build 4803

1. 0003051: ECTL_REDRAW call from dialog.

drkns 01.10.2016 14:28:21 +0200 - build 4802

1. IN some cases, temporary files would not be deleted after browsing archives.

drkns 01.10.2016 00:08:29 +0200 - build 4801

1. Correction of 4800.

drkns 30.09.2016 19:31:55 +0200 - build 4800

1. 0003315: unload:plugin.dll not close panel

drkns 30.09.2016 12:04:12 +0200 - build 4799

1. Correction of 4798.

drkns 29.09.2016 17:30:16 +0200 - build 4798

1. Modifiers did not work with the mouse wheel.

2. CtrlP/CtrlM should not interfere with built-in clipboard now.

3. Crash after AltEnd on plugin panel containing custom columns.

4. Refactoring.

drkns 25.09.2016 20:32:14 +0200 - build 4797

1. 0001040: Main Usermenu & Console Command: "CLS & ECHO. & ipconfig /all & ECHO. & ECHO. & PAUSE" doesn't work.

drkns 25.09.2016 20:06:40 +0200 - build 4796

1. 0003255: Content of symbolic links not copied

2. 0003309: File associations - Ctrl-Up and Ctrl-Down do not move items

3. 0003310: PluginW.pas out of sync with plugin.hpp

4. 0003311: Incorrect QueryDosDevice call in MatchNtPathRoot (pathmix.cpp)

drkns 22.09.2016 02:17:12 +0200 - build 4795

1. An old bug related to at least 1.65 - possible stack overflow in main menu.

2. Refactoring.

drkns 18.09.2016 02:48:50 +0200 - build 4794

1. Workaround for VS bug. See connect #3103404 for details.

drkns 17.09.2016 22:13:26 +0200 - build 4793

1. constexpr.

2. longPathAware = true for Windows 10.

3. Refactoring.

drkns 15.09.2016 02:23:25 +0200 - build 4792

1. Correction of 4784.1.

2. Code analysis warnings.

drkns 13.09.2016 18:28:08 +0200 - build 4791

1. Crash in viewer when copying selected UTF-8 text.

2. Incorrect text/hex conversion in search dialog.

3. Crash after pressing End on radiobutton in dialog.

4. Editor screen would not refresh while scrolling it with Ctrl-Up/Down from "Find all" menu.

svs 13.09.2016 15:13:03 +0300 - build 4790

1. SQLite 3.14.2

drkns 12.09.2016 23:35:38 +0200 - build 4789

1. Correction of 4788.3.

2. Minor issues.

drkns 12.09.2016 19:23:16 +0200 - build 4788

1. Displaying a dialog while loading a plugin could leave console caption empty.

2. DM_SETTEXT during DN_INITDIALOG would reset 'unchanged' in input string fields.

3. Global replacement __int64 -> long long and other refactoring.

drkns 11.09.2016 18:53:56 +0200 - build 4787

1. 0003299: starting from 3.0.4784 x86 a new association would not be saved after editing

drkns 11.09.2016 04:28:53 +0200 - build 4786

1. 0003294: Empty combo box line

2. Correction of DIF_EDITOR processing in dialogs.

3. Minor issues.

drkns 09.09.2016 23:40:13 +0200 - build 4785

1. After 4778, WindowMode was broken.

drkns 08.09.2016 23:08:42 +0200 - build 4784

1. Refactoring.

2. TinyXML-2 4.0.1.

shmuel 06.09.2016 09:16:24 +0200 - build 4783

1. For recording/modifying/deleting keyboard macros with Ctrl.Ctrl. :
   a) Existing stationary macros bound on the same combination (area,key) are equated to
      built-in Far keyboard combinations, i.e. Far doesn't ask for them to be deleted or redefined.
   b) The behavior for existing keyboard macros hasn't been changed.

drkns 05.09.2016 20:21:32 +0200 - build 4782

1. Forum: copying didn't work after Ctrl+L Tab Ctrl+L.

zg 05.09.2016 19:25:21 +0200 - build 4781

1. forum: If FCTL_GETUSERSCREEN is called while a dialog is shown (same for a menu or help),
   then the dialog stays in clipboard for some reason.

zg 05.09.2016 12:27:54 +0200 - build 4780

1. continuation of 4777.

drkns 05.09.2016 00:52:20 +0200 - build 4779

1. It happens that there are plugins which assume that Message can be passed nullptr instead of "".

2. GCC warnings.

drkns 04.09.2016 23:49:35 +0200 - build 4778

1. Refactoring of keyboard.cpp. Dropped much copypasta. Miracles are possible.

2. Correction of displaying of clock at start.

3. 4777 could crash on certain windows close.

zg 04.09.2016 21:21:02 +0200 - build 4777

1. refactoring of the window manager.

zg 04.09.2016 15:37:13 +0200 - build 4776

1. do not redraw lists and open combo boxes if dialog redrawing is disabled.

drkns 03.09.2016 18:19:14 +0200 - build 4775

1. Crash after certain manipulations with plugin panels.

2. A leak.

zg 01.09.2016 17:39:45 +0200 - build 4774

1. 0003288: ShowTotalSize for Plugin.

drkns 01.09.2016 01:21:07 +0200 - build 4773

1. Continuation of 4772.

drkns 31.08.2016 03:08:55 +0200 - build 4772

1. Rethinking the concept of exception handling again.

zg 29.08.2016 19:46:17 +0200 - build 4771

1. FSF.FarNameToInputRecord would fill KeyEvent.uChar.UnicodeChar incorrectly for keys like "AltShift8".

drkns 25.08.2016 14:55:58 +0200 - build 4770

1. Add proper validation for configuration parameters so that checks are not scattered all over the code.

2. Editor.Set second parameter is now optional (-1 by default).

shmuel 25.08.2016 14:24:34 +0200 - build 4769

1. Another correction of 4767.

shmuel 25.08.2016 13:53:19 +0200 - build 4768

1. Correction of 4767.

shmuel 25.08.2016 13:27:23 +0200 - build 4767

1. MacroAPI: Editor.Set(0) call would set the tabulation length to zero which caused a crash.

drkns 25.08.2016 00:57:25 +0200

1. Continue headers validation.

drkns 24.08.2016 18:08:24 +0200 - build 4766

1. Correction of exception processing.

2. After 4709, changing of the console size with "mode x, y" did not work.

drkns 23.08.2016 11:20:47 +0200 - build 4765

1. Viewer search in UTF8 files was broken.

2. Viewer regex search was broken.

drkns 22.08.2016 22:01:40 +0200

1. GCC 6.

drkns 22.08.2016 11:43:23 +0200

1. Regular headings in all cpp/hpp files.

2. A script is added for validation of #1.

drkns 20.08.2016 14:01:57 +0200 - build 4764

1. Correction of 4757.1.

drkns 19.08.2016 09:45:27 +0200 - build 4763

1. Correction of 4762.

drkns 18.08.2016 22:11:54 +0200 - build 4762

1. Continuation of 0003274.

drkns 18.08.2016 21:15:20 +0200 - build 4761

1. Correction of 4760.1.

drkns 18.08.2016 02:34:26 +0200 - build 4760

1. 0003274: Changing keyboard layout with Ctrl-Shift in input fields incorrectly denotes the beginning of field modification
   Processing FEDITLINE_CLEARFLAG moved partially to EditControl.

2. Other minor refactoring.

svs 17.08.2016 20:23:57 +0300 - build 4759

1. SQLite 3.14.1

drkns 15.08.2016 09:23:14 +0200 - build 4758

1. More paranoid options for GCC.

drkns 14.08.2016 15:28:56 +0200 - build 4757

1. Refactoring for everything encoding related.

2. -flto for GCC. Suddenly Far.exe lost ~750 K of size.

drkns 13.08.2016 17:07:34 +0200 - build 4756

1. Another correction of 4747.

svs 09.08.2016 10:31:09 +0300 - build 4755

1. SQLite 3.14.0

drkns 08.08.2016 23:38:23 +0200 - build 4754

1. Refactoring.

drkns 07.08.2016 21:59:50 +0200 - build 4753

1. Adapters were broken after 4747.

drkns 07.08.2016 15:01:50 +0200 - build 4752

1. A couple of optimizations for clipboard processing.

drkns 06.08.2016 14:56:47 +0200 - build 4751

1. Correction of processing of incorrect hex strings in dialogs.

2. Exception diagnostics was broken in one of previous builds.

drkns 04.08.2016 22:16:44 +0200 - build 4750

1. Correction of 4748.

drkns 03.08.2016 23:30:06 +0200 - build 4749

1. %1, %2, %3... are replaced with {0}, {1}, {2} in code and language files...
   If you had your own lng then you have to replace those by yourself.

drkns 02.08.2016 22:18:59 +0200 - build 4748

1. Refactoring.

drkns 30.07.2016 21:27:07 +0200 - build 4747

1. Refactoring.

zg 30.07.2016 20:43:15 +0200 - build 4746

1. [Wishes 0002857]: Recognize pressing combinations of multiple modifiers.

drkns 29.07.2016 01:34:39 +0200 - build 4745

1. File panels would re-read their content for some reason (with all the side effects like sudden change of current directory of the process) on window redraw
   which could happen anytime in general.

drkns 23.07.2016 12:48:09 +0200 - build 4744

1. Do not reset text color for inner FCTL_GETUSERSCREEN calls.

drkns 16.07.2016 13:51:54 +0200 - build 4743

1. Sometimes, with a bit of luck, call for editor after using a panel plugin could cause crash.

drkns 09.07.2016 22:56:35 +0200 - build 4742

1. Ansi plugins with insufficiently good resources could fail to load.

drkns 09.07.2016 01:21:52 +0200 - build 4741

1. Another bug at the same place.

drkns 08.07.2016 22:07:58 +0200 - build 4740

1. Incorrect processing of backspace in local user menu.

drkns 08.07.2016 09:12:06 +0200 - build 4739

1. 0003265: "cd \ " does not work in command line

drkns 06.07.2016 23:04:32 +0200 - build 4738

1. Coverity warnings.

drkns 06.07.2016 00:46:21 +0200 - build 4737

1. Refactoring.

drkns 03.07.2016 21:15:27 +0200 - build 4736

1. Temporary files could be deleted prematurely.

drkns 03.07.2016 19:11:29 +0200 - build 4735

1. Crash in viewer search under certain circumstances.

drkns 03.07.2016 18:07:21 +0200 - build 4734

1. Refactoring.

drkns 02.07.2016 15:10:30 +0200 - build 4733

1. 0003261: Crash on ф: in command line

drkns 01.07.2016 01:13:59 +0200 - build 4732

1. Refactoring.

drkns 30.06.2016 10:25:43 +0200 - build 4731

1. Continue experimental changes in launcher.

drkns 29.06.2016 21:51:02 +0200 - build 4730

1. Continue experiments:
   - allow FCTL_<G|S>ETUSERSCREEN nested calls.
   - support for FCTL_SETUSERSCREEN without prior FCTL_GETUSERSCREEN (it worked before).

drkns 29.06.2016 09:41:59 +0200 - build 4729

1. 'Protection' from nested calls in FCTL_<G|S>ETUSERSCREEN.

2. Minor issues.

drkns 27.06.2016 22:43:25 +0200 - build 4728

1. Continue experimental changes in launcher.

drkns 27.06.2016 00:46:22 +0200 - build 4727

1. Continue experimental changes in launcher.
   Ctrl-G and User Menu multiline commands should work better now.

shmuel 26.06.2016 16:37:24 +0200 - build 4726

1. Extend Panel.SetCustomSortMode() function capabilities.

drkns 24.06.2016 23:19:28 +0200 - build 4725

1. Forum: administrative rights indicator stays on screen at program launch for some reason.

drkns 24.06.2016 01:39:45 +0200 - build 4724

1. Continuation of 4723 - exception for ShiftEnter and support for 'run as'.

drkns 24.06.2016 01:15:01 +0200 - build 4723

1. Highly experimental feature: built-in associations are applied to command line.

drkns 23.06.2016 22:46:27 +0200 - build 4722

1. Correction of 4710.

drkns 23.06.2016 21:09:03 +0200 - build 4721

1. New parameter: far:config -> System.Executor.Comspec defining the command processor used (%comspec% by default).

2. System.Executor.ComspecArguments and System.Executor.ComspecCondition support environment variables.

drkns 21.06.2016 21:33:36 +0200 - build 4720

1. Continuation of 4712.

2. gcc warning.

drkns 20.06.2016 00:20:17 +0200 - build 4719

1. Variables in ExcludeCmds would not expand when used in autocompletion.

drkns 20.06.2016 00:15:19 +0200 - build 4718

1. #0003257: (far 3.0.4700.x64) Exception in Viewer when searching HEX values

t-rex 19.06.2016 21:15:20 +0200 - build 4717

1. Mantis#2467: Endless regular expression replace in editor

2. Broken build for VC2015 update 3 for some reason (it appears to be a bug in the latter one)

drkns 18.06.2016 18:09:29 +0200 - build 4716

1. Correction of 4715.

drkns 18.06.2016 13:55:55 +0200 - build 4715

1. Forum: incorrect drawing of clock according to regional settings.

drkns 18.06.2016 12:52:50 +0200 - build 4714

1. Forum: hard link icons on passive panel disappear after copying or moving.

drkns 18.06.2016 11:51:33 +0200 - build 4713

1. Workaround for a bug of leaving the fullscreen mode in Windows 10.

drkns 17.06.2016 22:38:32 +0200 - build 4712

1. Partial rollback of previous experiments with console modes.

2. Extend WindowMode: add two StickyX parameters (true by default) and StickyY (false by default)
   defining which axes the size has to adjust to (and, respectively, where the scrollbars must not be).

drkns 17.06.2016 17:44:53 +0200 - build 4711

1. A couple of bugs for WindowMode.

drkns 17.06.2016 15:12:33 +0200 - build 4710

1. Restore compatibility with Win2k.

w17 16.06.2016 19:27:33 +0300 - build 4709

1. Again, the correction of 4697.
   Track Win10 full screen mode switching with "[ ] Wrap text output on resize" console setting
   Restore the original size of console buffer on exit
   ConEmu should not break for System.WindowMode = false

zg 15.06.2016 22:27:05 +0200 - build 4708

1. forum: ShiftEnd and ShiftHome slow work in panels.

drkns 14.06.2016 18:31:09 +0200 - build 4707

1. System associations having bat or cmd as "associated program" would start in separate window.

drkns 13.06.2016 19:32:18 +0200 - build 4706

1. Forum: an issue with panels in Fullscreen view

zg 12.06.2016 21:04:46 +0200 - build 4705

1. visual issues with mouse scrolling in editor after 4685.

drkns 12.06.2016 16:32:43 +0200 - build 4704

1. 0003254 again:
   - System.Executor.ComspecCondition is empty by default and built-in logic is used (<>|& are outside the quotes like before).
   - inner RegExp is used because std::regex implementations in supported compilers are far from good (especially in gcc).

drkns 12.06.2016 14:55:52 +0200 - build 4703

1. 0003254: Far 3.0 build 4700-4702 crashes on long file lists (!&)

drkns 11.06.2016 22:55:07 +0200 - build 4702

1. Another correction of launcher.

drkns 11.06.2016 20:05:25 +0200 - build 4701

1. Refactoring.

drkns 10.06.2016 23:49:57 +0200 - build 4700

1. Refactoring.

drkns 09.06.2016 01:50:33 +0200 - build 4699

1. Once more #0003223: Add System.Executor.ComspecCondition parameter defining when a command should be run via comspec.

w17 08.06.2016 21:15:44 +0300 - build 4698

1. Correction of 4697 - do not try to switch Win10 full-screen mode off, do nothing on Alt-F9 for it.

w17 08.06.2016 17:25:01 +0300 - build 4697

1. Try to handle Win10 full-screen mode correctly.

zg 08.06.2016 15:46:48 +0200 - build 4696

1. correction of 4676.

zg 02.06.2016 01:51:47 +0200 - build 4695

1. forum: If a macro is being written in dialog (press Ctrl.) then the record indicator does not appear at once,
   only after additional key press.

drkns 01.06.2016 22:51:16 +0200 - build 4694

1. Forum: Menu.Id in dialogs could cause crash.

2. So not save farmenu.ini after Alt-F4 to keep broken menu files.

drkns 25.05.2016 20:16:03 +0200 - build 4693

1. For [x] Cursor at the end, replacement to a string containing \t worked incorrectly in editor.

zg 24.05.2016 13:58:55 +0200 - build 4692

1. correction of 4685.

zg 24.05.2016 00:30:32 +0200 - build 4691

1. correction of 4685.

drkns 23.05.2016 18:05:10 +0200 - build 4690

1. Correction of launcher function.

svs 23.05.2016 15:51:37 +0300 - build 4689

1. SQLite 3.13.0

drkns 22.05.2016 21:51:25 +0200 - build 4688

1. 0003245: Crash after Shift-F2 in User Menu

2. Refactoring.

drkns 21.05.2016 20:30:22 +0200 - build 4687

1. On #0003244 - show clock according to OS regional settings.

zg 21.05.2016 11:27:47 +0200 - build 4686

1. forum: severe slowdown for UNDO/REDO in editor.

2. slowdown for built-in replace after 4673.

zg 21.05.2016 04:45:34 +0200 - build 4685

1. forum: Measure execution time for CtrlAltEnd at the beginning of %FARHOME%\changelog file.

2. slow ECTL_INSERTTEXT after 4673.

3. gcc warning.

drkns 20.05.2016 21:57:30 +0200 - build 4684

1. 0003099: FMENU_CHANGECONSOLETITLE flag may not work in Menu function

drkns 20.05.2016 21:16:12 +0200 - build 4683

1. #0003243 user menu items in which .cmd is invoked now start in separate window.

drkns 19.05.2016 19:03:12 +0200 - build 4682

1. Correction of 4679.

zg 19.05.2016 18:08:09 +0200 - build 4681

1. artifacts on altf9 in a combo box.

drkns 19.05.2016 01:35:59 +0200 - build 4680

1. Correction of 4679.

drkns 19.05.2016 00:40:27 +0200 - build 4679

1. Continue launcher experiments:
   - launch type (console with waiting / silent with no waiting) is now defined for system associations too.
   - System.Executor.BatchType is gone, everything should work automatically.

zg 18.05.2016 19:37:11 +0200 - build 4678

1. under certain conditions the cursor position in current line was incorrect after ECTL_DELETESTRING.

drkns 17.05.2016 20:41:13 +0200 - build 4677

1. Refactoring - add some const.

zg 17.05.2016 13:03:38 +0200 - build 4676

1. correction 4673 for ECTL_SETPOSITION.

drkns 16.05.2016 22:55:36 +0200 - build 4675

1. Another correction for launcher.

drkns 15.05.2016 22:00:35 +0200 - build 4674

1. Correction of 4668.

zg 15.05.2016 17:37:36 +0200 - build 4673

1. remove window drawing lock.

zg 15.05.2016 00:33:49 +0200 - build 4672

1. forum: symbols "бюжэхъё" are not entered in "fast find" window.

drkns 13.05.2016 00:33:18 +0200 - build 4671

1. Correction of processing exceptions for gcc.

2. Additional information in exceptions thrown manually (function, file, line).

3. Refactoring.

drkns 11.05.2016 23:59:21 +0200 - build 4670

1. Correction of processing DM_GETDIALOGINFO.

2. Warnings.

3. Remove unused #include.

drkns 10.05.2016 22:45:32 +0200 - build 4669

1. Copy progress indication is slightly redone.
   In theory, all drawing bugs should be fixed.
   In reality, anything is possible as usual.

2. Missing standard headers in some *.hpp.

drkns 10.05.2016 18:04:22 +0200 - build 4668

1. Forum: Enter on an office document in panels makes Far wait for the document close.

drkns 09.05.2016 15:17:11 +0200 - build 4667

1. clang warnings.

2. A couple of minor issues.

zg 09.05.2016 14:00:08 +0200 - build 4666

1. correction of 4638.1: Dlg.* in opened combo box.

zg 08.05.2016 13:27:59 +0200 - build 4665

1. correction of 4638.1: the macro area for combo box is "Dialog".

2. publish WTYPE_COMBOBOX window type. ACTL_GETWINDOWINFO returns the handle of parent dialog in Id.

drkns 08.05.2016 01:12:06 +0200 - build 4664

1. Correction of 4663.2.

2. Raise the level of warnings for third party libraries.

drkns 07.05.2016 17:45:49 +0200 - build 4663

1. Correction of total deletion indicator calculation.

2. Refactoring.

drkns 04.05.2016 23:22:57 +0200 - build 4662

1. After 4435 the expansion of variables did not work in directory creation dialog.

2. Refactoring.

drkns 04.05.2016 10:20:21 +0200 - build 4661

1. Correction of 4656.2.

2. A pair of minor issues.

drkns 03.05.2016 16:58:07 +0200 - build 4660

1. Correction of 4656.2.

drkns 03.05.2016 13:51:34 +0200 - build 4659

1. 0003229: Removing mounted VHDX files from the drive menu makes file locked

drkns 03.05.2016 11:28:32 +0200 - build 4658

1. 0003228: Shell command CD does not find a path in case of the line ending with a space character

drkns 02.05.2016 19:51:44 +0200 - build 4657

1. Forum: Execute in FAR command line: notepad %FARHOME%\changelog and get "The system cannot find the path specified." error

2. Refactoring.

drkns 02.05.2016 12:23:29 +0200 - build 4656

1. 0003227: Folders would not open in explorer with Shift+Enter

2. FCTL_GETUSERSCREEN / FCTL_SETUSERSCREEN must be working more correctly now.

3. Refactoring.

drkns 30.04.2016 20:54:00 +0200 - build 4655

1. 0003225: Freeze on "close" button press from modal editor

drkns 30.04.2016 15:16:06 +0200 - build 4654

1. Continue fixing the launcher.

drkns 29.04.2016 19:13:57 +0200 - build 4653

1. Forum: nightly build does not find itself when starting FAR from FAR command line.

drkns 29.04.2016 17:31:01 +0200 - build 4652

1. Continuation of 4646 - remove unnecessary window locks.

drkns 29.04.2016 16:10:52 +0200 - build 4651

1. Continuation of 4648.

drkns 29.04.2016 13:55:48 +0200 - build 4650

1. And once more.

drkns 29.04.2016 10:36:00 +0200 - build 4649

1. Correction of 4644.

drkns 29.04.2016 09:32:30 +0200 - build 4648

1. Continuation of 4631 - restore System.ShowCheckingFile functioning.

drkns 28.04.2016 19:43:18 +0200 - build 4647

1. Continuation of 4631.

drkns 28.04.2016 19:06:43 +0200 - build 4646

1. Continuation of 4631 - remove unnecessary window locks.

drkns 28.04.2016 16:52:55 +0200 - build 4645

1. Correction of 4644.

drkns 28.04.2016 16:47:33 +0200 - build 4644

1. Continuation of experimental changes in launcher:
   - System.Executor.NotQuotedShell and System.Executor.ComSpecParams are removed. Hovewer, there is now System.Executor.ComspecArguments managing both keys and quotes.
     The default value is compatible with cmd.exe - /S /C "{0}" where {0} is replaced with the executed command.
     For bash replace it to -c '{0}', for tcc - to -c {0}
   - (partially) #0003223: when passing to comspec there was unwrapped more than needed.

2. Use std::atomic<T> instead of Interlocked*().

zg 28.04.2016 13:20:04 +0200 - build 4643

1. hotkey did not work in combo box for current item.

drkns 28.04.2016 10:40:27 +0200 - build 4642

1. Correction of 4631.

drkns 26.04.2016 22:50:38 +0200 - build 4641

1. Correction of 4635: show "remaining:" when copying a single file and refresh it with the same frequency as for speed.

zg 26.04.2016 16:23:31 +0200 - build 4640

1. there was an opportunity to choose "Also ask on R/O files" in copy dialog.

2. correction of sending DN_INPUT/DN_CONTROLINPUT for an open combo box.

3. remove strange behavior restoring old list position if DN_LISTHOTKEY is processed.

zg 26.04.2016 03:41:23 +0200 - build 4639

1. remove unused code.

zg 25.04.2016 23:43:02 +0200 - build 4638

1. grabber did not work if a combo box was open.

2. DM_SETCOMBOBOXEVENT returned garbage.

drkns 24.04.2016 11:15:15 +0200 - build 4637

1. Correction of 4633.

drkns 24.04.2016 10:02:26 +0200 - build 4636

1. Correction of 4635.

drkns 23.04.2016 19:19:54 +0200 - build 4635

1. Copying progress indicator is displayed as "%done% / %total%".

2. Refactoring.

drkns 23.04.2016 02:03:50 +0200 - build 4634

1. Forum: lua:far.Message"aaa". The console caption is not restored after closing the console.

drkns 23.04.2016 01:59:07 +0200 - build 4633

1. Refactoring.

shmuel 23.04.2016 00:03:37 +0200 - build 4632

1. Experimental: speeding up ECTL_INSERTSTRING (about 50 times faster).

drkns 20.04.2016 22:42:13 +0200 - build 4631

1. Invocation of dialogs via main menu did not set correct console caption.

drkns 20.04.2016 17:33:13 +0200 - build 4630

1. Refactoring.

zg 20.04.2016 13:21:24 +0200 - build 4629

1. correction of 4628.

zg 20.04.2016 02:44:24 +0200 - build 4628

1. remove deferred sorting of color areas in editor.

w17 20.04.2016 01:39:19 +0300 - build 4627

1. Fix 4492.

drkns 19.04.2016 22:42:16 +0200 - build 4626

1. gcc build fix.

2. Refactoring.

svs 19.04.2016 18:18:01 +0300 - build 4625

1. SQLite 3.12.2

w17 19.04.2016 13:18:14 +0300 - build 4624

1. Correction of 4622.

drkns 16.04.2016 01:21:23 +0200 - build 4623

1. Refactoring and renamings.

w17 14.04.2016 16:24:08 +0300 - build 4622

1. M#3183: Panel FreeInfo, TotalInfo - add options for human-readable format (e.g. "1.375 T" free space)
   Ctrl-Shift-S (M#3089) now also affects displaying of total size and free space in file panel.
   The Panel.Info.ShowBytes -> Panel.ShowBytes parameter has changed

zg 14.04.2016 00:25:20 +0200 - build 4621

1. 0003213: Editor redraw time is proportional to the file size for some reason.

zg 13.04.2016 23:39:18 +0200 - build 4620

1. 0003212: Freeze on ShowHelp/DialogRun call after VCTL_QUIT/ECTL_QUIT.

svs 11.04.2016 10:16:53 +0300 - build 4619

1. SQLite 3.12.1

drkns 08.04.2016 16:05:19 +0200 - build 4618

1. Forum: "Memory corruption somewhere leading to rare crashes."

drkns 06.04.2016 23:43:12 +0200 - build 4617

1. And once more.

drkns 06.04.2016 22:42:14 +0200 - build 4616

1. Fix of fix of 4564.

drkns 06.04.2016 19:41:18 +0200 - build 4615

1. Forum: ANSI plugins lost the file panel cursor (4602).

drkns 06.04.2016 19:17:59 +0200 - build 4614

1. Correction of 4425.

w17 06.04.2016 18:13:35 +0300 - build 4613

1. Fix 4564.

w17 06.04.2016 13:29:38 +0300 - build 4612

1. M#3200: Inconsistent behavior for Ctrl+F on "regular folder" and on ".."
   [R]Ctrl+[[R]Alt+]F; on ".." now do not add the trailing '\'

drkns 05.04.2016 21:49:33 +0200 - build 4611

1. Under certain circumstances, search in plugin panel would crash the app.

2. A pair of minor issues.

drkns 03.04.2016 14:37:41 +0200 - build 4610

1. Once more 4609.1.

2. A pair of minor issues.

drkns 03.04.2016 00:05:57 +0200 - build 4609

1. Forum: "For some time now file descriptions have been case dependent".

drkns 31.03.2016 10:00:26 +0200 - build 4608

1. Correction of 4603. Do not show "?" if the owner is undefined.

2. Other minor refactoring.

drkns 29.03.2016 19:15:04 +0200 - build 4607

1. Correction of 4603. Pass the mentioned items to plugins only if they already have been read.

drkns 27.03.2016 20:33:46 +0200 - build 4606

1. Refactoring.

drkns 26.03.2016 23:33:54 +0200 - build 4605

1. Correction of 4603.

drkns 26.03.2016 21:56:52 +0200 - build 4604

1. Suppress querying of the rights on highlighting.

drkns 26.03.2016 21:16:07 +0200 - build 4603

1. Continuation of 4602. Ask for additional information on files when it is needed. This is related to:
   - the number of hard links
   - the number of streams
   - the size of streams
   - owner
   - content data
   This means that including of this stuff must not slow down displaying of folders unless it is the criterion of sorting.

drkns 26.03.2016 01:03:37 +0200 - build 4602

1. Highlighting is applied to files in panel when it is needed.
   The effect must be noticeable on big number of groups and/or files.

drkns 25.03.2016 10:08:48 +0200 - build 4601

1. Correction of 4599.

drkns 25.03.2016 01:21:22 +0200 - build 4600

1. Correction of 4574.

drkns 24.03.2016 23:40:39 +0200 - build 4599

1. 0003201: Message returns value less by 1 than expected

drkns 24.03.2016 23:04:54 +0200 - build 4598

1. Ask for name & password for cd \\server\share

w17 24.03.2016 20:32:59 +0300 - build 4597

1. Correction of 4596. Revert switching for inactive Info panel.

w17 24.03.2016 17:14:32 +0300 - build 4596

1. Correction of 4595. Switching only if info panel is active.

w17 24.03.2016 16:14:28 +0300 - build 4595

1. Continuation of 4590, 4594 switching with Ctrl-Shift-S.

w17 24.03.2016 14:55:56 +0300 - build 4594

1. Continuation of 4590.
   Configuration if size display mode: Panel.Info.ShowBytes (default=false); switch with Ctrl-S. 

drkns 24.03.2016 02:05:31 +0200 - build 4593

1. Crash on +/- key press in info panel if the viewer has been opened there.

drkns 23.03.2016 20:31:08 +0200 - build 4592

1. Forum: Illogical behavior on network volume removal

w17 23.03.2016 17:59:00 +0300 - build 4591

1. M#3089: Minor fix of info panel (Ctrl+L)

w17 22.03.2016 13:55:04 +0300 - build 4590

1. Continuation of 4587 -- EOPT_SHOWSCROLLBAR; VCTL_GETINFO: VOPT_SHOWxxx, VOPT_QUICKVIEW.

drkns 22.03.2016 08:27:45 +0200 - build 4589

1. Correction of 4585.

drkns 21.03.2016 17:11:49 +0200 - build 4588

1. Macro ARRAYSIZE -> constexpr std::size

shmuel 21.03.2016 16:05:35 +0200 - build 4587

1. ECTL_GETINFO: EOPT_SHOWTITLEBAR and EOPT_SHOWKEYBAR flags are added into EDITOR_OPTIONS enumeration.

drkns 21.03.2016 15:31:02 +0200 - build 4586

1. Continuation of 4584.

drkns 20.03.2016 11:57:40 +0200 - build 4585

1. Continuation of 4584.

drkns 20.03.2016 00:41:42 +0200 - build 4584

1. Remove hacks used widely for VS2010 support.

drkns 19.03.2016 23:19:41 +0200

1. Given that our German users aren't happy with "#0003145: New German translation", I'm reverting it to the previous version.
   Only previously untranslated strings are picked from #0003145 now.

drkns 18.03.2016 18:03:45 +0200

1. Build requires VC++ 2015 / GCC 5.

drkns 18.03.2016 12:00:11 +0200 - build 4583

1. Continuation of 4582 - sort without expansion of FileListItem structure which is already big.
   Also, it may be a little faster.

shmuel 17.03.2016 18:18:54 +0200 - build 4582

1. Custom panel sorting modes would corrupt inner FileListItem structures
   (this happened in Far builds with GCC 5.2 or 5.3).
   Custom sorting algorithm had to be changed, now there is no direct memory manipulation.

drkns 14.03.2016 23:51:08 +0200 - build 4581

1. Revert ACTL_REDRAWALL behavior before 4545.

shmuel 14.03.2016 11:39:07 +0200 - build 4580

1. On "Sort by" menu display (CtrlF12) the cursor is set to the current sorting mode.

svs 14.03.2016 10:33:31 +0300 - build 4579

1. SQLite 3.11.1

shmuel 13.03.2016 21:45:25 +0200 - build 4578

1. Correction of 4577.

shmuel 13.03.2016 01:35:20 +0200 - build 4577

1. In Panel.LoadCustomSortMode function, parameter table can contain an optional field
   'Condition' (a function). This function can be used for example in interactive mode
   to change sorting parameters or to cancel sorting.

drkns 12.03.2016 16:37:16 +0200 - build 4576

1. 0003194: Strange behavior on insertion * and ? into command line, up to crash

2. 0003195: Incorrect substitution of file/folder names containing spaces with "Append first matched item" option on

3. 0003196: Autocompletion of executable file names from %PATH% proposed with no quotes even for files containing spaces in their names

shmuel 11.03.2016 18:57:02 +0200 - build 4575

1. FCTL_GETPANELINFO set SortMode value for custom sorting by 1 more than actual.

drkns 10.03.2016 00:22:16 +0200 - build 4574

1. Menu.Show("\2qwe\n\4asd") showed items without first characters.

2. user menu got rid of fancy logic turning any incorrect hotkey into F1.

3. Correction of 829.2 - substitute FILE_FLAG_POSIX_SEMANTICS for TRUNCATE_EXISTING too.

4. Other minor refactoring.

drkns 08.03.2016 13:23:22 +0200 - build 4573

1. 0003189: Far 3.0 crash if command line format string contains "(%)"

2. 0003190: Autocompletion list is not shown if "Append first matched item" option is on

drkns 05.03.2016 03:19:56 +0200 - build 4572

1. Correction of 4568.

2. Refactoring.

drkns 04.03.2016 22:49:36 +0200 - build 4571

1. VC2015 build fix.

drkns 04.03.2016 22:12:43 +0200 - build 4570

1. Handling of descriptions is redone a bit - now the files undergo less changes on update.

2. Other refactoring.

drkns 03.03.2016 21:29:48 +0200 - build 4569

1. Correction of 4568.

drkns 03.03.2016 02:14:30 +0200 - build 4568

1. Refactoring.

zg 01.03.2016 00:16:46 +0200 - build 4567

1. under some conditions it is impossible to abort directory size scanning in qview.

drkns 29.02.2016 22:23:24 +0200 - build 4566

1. Correction of 4565.

drkns 28.02.2016 20:01:24 +0200 - build 4565

1. When detaching the console (Ctrl+Shift+Tab) copy the aliases from the old one to the new one.

drkns 27.02.2016 18:05:26 +0200 - build 4564

1. Refactoring.

2. Some renamings.

w17 26.02.2016 19:47:29 +0300 - build 4563

1. Experimental: M#2983: Far3, calculation of the size of a folder on remote computer, the bug with links
   ALL traversed real directories are written to std::set VisitedDirs.
   This is done intentionally. At first, is does not need taking lots of subtleties into account, at second,
   if ScanTree allows skipping folders then in my opinion there's no other way.
   However feel free to optimize it of course.

drkns 25.02.2016 18:04:48 +0200 - build 4562

1. 0003187: Symlink to a network folder does not work after editing the target folder in attributes dialog

svs 24.02.2016 09:40:36 +0300 - build 4561

1. SQLite 3.11.0

drkns 23.02.2016 19:46:47 +0200 - build 4560

1. 0003185: Panel in unsorted mode is showing the first file/folder as the last

drkns 20.02.2016 22:01:11 +0200 - build 4559

1. gcc build fix.

drkns 20.02.2016 21:53:30 +0200 - build 4558

1. Continuation of 4548: uniform processing of all exceptions.

drkns 20.02.2016 15:56:08 +0200 - build 4557

1. Continuation of 4548: display more correct stack on x86, show source file/line in stack and in main dialog.

2. Consider also forward slash in UnquoteExternal().

w17 20.02.2016 15:03:22 +0300 - build 4556

1. Correction of 4523. Consider "D:\Path Name"\ in UnquoteExternal()

drkns 20.02.2016 04:16:03 +0200 - build 4555

1. Continuation of 4548: load pdb only if it's needed.

drkns 19.02.2016 21:58:30 +0200 - build 4554

1. Correction of 4552.

2. VC2015 warning.

w17 19.02.2016 22:31:34 +0300 - build 4553

1. Correction of 4552, fix VS2010 build.

drkns 19.02.2016 00:08:34 +0200 - build 4552

1. One more time on Alt+F8 in viewer:
   - %, h, 0x etc. in line no longer change the stored mode;
   - d specifier mentioned in help did not work.
     The funny thing is it couldn't work because, for example, 1234d is a valid hex number.
     Therefore the 'm' modifier is now used for explcit specification "this is a decimal".
   - all modifiers (except for %) now also work for specification of the left position.
   - Ok/Cancel buttons are added to the dialog.

drkns 17.02.2016 19:43:48 +0200 - build 4551

1. After 4525, command text was displayed with wrong color in user screen.

drkns 14.02.2016 20:45:46 +0200 - build 4550

1. Instead of "Language data is incorrect or damaged" show "filename.lng: language data is incorrect or damaged" to avoid guessing the file.

2. Text of all exceptions inherited from std::exception is considered to be UTF-8.

drkns 14.02.2016 13:00:58 +0200 - build 4549

1. Restore XML import error message.

2. Latest TinyXML-2.

3. SQLite 3.10.2.

drkns 13.02.2016 16:59:45 +0200 - build 4548

1. Messages on exceptions are added a "Stack" button.
   Far.pdb is needed to get it work correctly.

2. Refactoring.

drkns 12.02.2016 23:30:30 +0200 - build 4547

1. Refine Ctrl+F10 blocking logic in editor/viewer: now it is blocked only for modal windows.

drkns 10.02.2016 23:21:06 +0200 - build 4546

1. Refactoring. Shorten code in the manager a bit.

drkns 09.02.2016 22:33:44 +0200 - build 4545

1. Refactoring.

drkns 08.02.2016 01:30:51 +0200 - build 4544

1. After 4320, selection sometimes worked incorrectly after Ctrl-A.

drkns 07.02.2016 18:30:10 +0200 - build 4543

1. Switching to a column with Alt-F8 in viewer did not work if the first parameter was specified in percents (example from help).

2. Come refactoring. %another mantra about bad influence of one letter variables to you karma%.

3. Warnings.

drkns 06.02.2016 04:01:40 +0200 - build 4542

1. 0003169: panels disappear after start of external editor

drkns 05.02.2016 21:26:41 +0200 - build 4541

1. Correction of 4525.

drkns 05.02.2016 09:41:13 +0200 - build 4540

1. Forum: Cursor disappears in launched external console applications.

drkns 03.02.2016 19:25:05 +0200 - build 4539

1. Move the hack for M#2922 to a more suitable place and simplify it.

w17 03.02.2016 17:48:03 +0300 - build 4538

1. Correction of 4537.

w17 03.02.2016 16:10:50 +0300 - build 4537

1. M#2922: symbolic link to an executable file creates a separate console after launch

drkns 03.02.2016 09:11:50 +0200 - build 4536

1. Restore behavior of selection in dialogs as it was up to 4484.

drkns 02.02.2016 22:19:45 +0200 - build 4535

1. Forum: start of far /v or far /e with active auto-saving garbled panel settings.

drkns 02.02.2016 21:34:08 +0200 - build 4534

1. Correction of 4525 for non-trivial launch conditions.

drkns 02.02.2016 21:17:56 +0200 - build 4533

1. Adaptation of grabber to 4526.

drkns 02.02.2016 19:55:16 +0200 - build 4532

1. Forum: Editor.SetStr was broken in one of builds 4482-4484

drkns 02.02.2016 09:55:00 +0200 - build 4531

1. Command line was not updated after deleting an item from completion list.

drkns 01.02.2016 23:00:10 +0200 - build 4530

1. Optimization of 4525 for System.WindowMode = true

2. System.WindowMode is now true by default for:
   - this is good;
   - testing is needed.

w17 01.02.2016 16:53:33 +0300 - build 4529

1. M#3161: Extend GoTo (AltF8)

drkns 01.02.2016 10:34:36 +0200 - build 4528

1. Continuation of 4525.

drkns 01.02.2016 03:16:02 +0200 - build 4527

1. Continuation of 4525.

drkns 01.02.2016 01:11:06 +0200 - build 4526

1. Report goes that after 4516 middle mouse button worked odd in panels.

drkns 31.01.2016 22:59:13 +0200 - build 4525

1. 0002900: Menu from a list file: trouble with calls from User menu
   Half of launcher is rewritten, a lot of bugs is fixed, possibly new ones are made.

2. System.Executor.SilentExternal is gone.

3. Enter with panels hidden now scrolls output as in cmd.

w17 29.01.2016 21:57:57 +0300 - build 4524

1. Fix 4484. aka M#3162: Text disappear in viewer

w17 29.01.2016 16:55:57 +0300 - build 4523

1. Continuation of 4521.
   Now "D:\Path Name"\ is the global feature - that's the way QuoteSpace() works.

w17 27.01.2016 23:06:51 +0300 - build 4522

1. Experimental: language files customization without editing generated 'native' .lng files

   Instructions:
   1) create full versions of language files with lng.generator.exe, new builds contain them.
   2) create own file containing changes for needed languages

   The name of the file is <Original>.custom, for ex. FarRus.lng.custom, FarEng.lng.custom
   The file is searched in %FARHOME% and %FARPROFILE% (both 2 files can be created)

   The file must contain lines like these:
   MessageId = "Modified Text"
   for example:
   MListFileSize = " %1 bytes in %2 files, %3 folders "
   The needed MessageId can be found in the original file, it has the following form:
   //[MessageId]
   "Original text"
   //[MListFileSize]
   " Bytes: %1, files: %2, folders: %3 "
   The same format is also allowed in .lng.custom files.
   //[MListFileSize]
   " %1 bytes in %2 files, %3 folders "

w17 26.01.2016 14:09:42 +0300 - build 4521

1. M#3011: Ctrl+Enter works wrong for ".." for case if path have spaces
   "D:\Path Name\" --> "D:\Path Name"\ 

drkns 26.01.2016 09:43:57 +0200 - build 4520

1. Correction of 4516.

2. Forum: excessive redraw of associations menu.

drkns 26.01.2016 02:19:36 +0200 - build 4519

1. Correction of 4516.

drkns 26.01.2016 00:15:06 +0200 - build 4518

1. Forum: Repeated file view with F3 renders differently

drkns 24.01.2016 20:10:32 +0200 - build 4517

1. A couple of corrections to 4516.

drkns 24.01.2016 14:35:53 +0200 - build 4516

1. Attempt to open two info or qview panels via main menu crashes Far.
   The cause is common - the instance of panel is destroyed in its own call context.
   Further placing of 'delaydestroy' has no sense, so panel ownership logic is redone.
   Now there is no lots of unclear raw pointers referring to anything.
   Each panel is a smart pointer and lives as much as it is needed.
   Weird bugs are possible as usual.

2. Continue moving code away from panel.cpp to more suitable places to get the tail less wag the dog.
   Even more weird bugs are expected.

3. Other refactoring.

drkns 22.01.2016 09:52:55 +0200 - build 4515

1. Forum: mf.clip(5) and mf.clip(5,0) no longer switch the clipboard

svs 18.01.2016 17:22:16 +0300 - build 4514

1. SQLite 3.10.1

drkns 17.01.2016 23:48:17 +0200 - build 4513

1. Refactoring. Code for drive change menu moved from panel.cpp to a separate file.

2. Command execution with Ctrl-G could cause unnecessary autocompletion in command line.

drkns 16.01.2016 11:46:23 +0200 - build 4512

1. 0002953: When the tree3.far cache file exists, calling the tree dialog (Alt-F10) crashes Far manager
   Panel class is a big pile of mess, it contains everything and the kitchen sink.

drkns 15.01.2016 23:27:57 +0200 - build 4511

1. 0003153: Start next grabber session in the same mode as previous one (block/stream)

drkns 15.01.2016 10:04:34 +0200 - build 4510

1. Non-system copy function worked incorrectly on sparse files with block size more than 4 GB.

drkns 14.01.2016 22:05:38 +0200 - build 4509

1. 0003151: Go to new line when shifting grabber block in stream mode

svs 12.01.2016 22:10:42 +0300 - build 4508

1. SQLite 3.10.0

drkns 11.01.2016 19:50:50 +0200 - build 4507

1. Continuation of 4506.1.

drkns 10.01.2016 17:18:42 +0200 - build 4506

1. Grabber is added a stream selection mode. The modes are switched with spacebar.
   Copying to clipboard tries to concatenate lines broken by wrapping, correctness of the result is not guaranteed.

2. Grabber mode can be cancelled with F10.

3. Some translation for English help.

4. A couple of minor issues.

drkns 08.01.2016 16:54:54 +0200 - build 4505

1. 003148: Copying a few lines in FAR editor followed by pasting garbles the content

drkns 08.01.2016 14:47:08 +0200 - build 4504

1. A little black magic for VS2015 build to work in Win2k.

drkns 04.01.2016 14:00:46 +0200 - build 4503

1. Continuation of 4502.1.

2. Correction of 4431.

drkns 03.01.2016 21:18:13 +0200 - build 4502

1. Continue refactoring of clipboard.

2. Fix clip(3) and clip(4) malfunction.

drkns 01.01.2016 16:05:03 +0200 - build 4501

1. Apply 4496 to vertical blocks.

2. Always write the size of data.

drkns 01.01.2016 15:07:30 +0200 - build 4500

1. Remove vertical block duplication in clipboard.

2. Refactoring.

zg 31.12.2015 20:03:12 +0200 - build 4499

1. crash in GetPluginDirList. already freed memory was returned.

2. gcc warning.

drkns 30.12.2015 17:05:27 +0200 - build 4498

1. Continuation of 3596. More paranoid handling of adapters.

drkns 30.12.2015 10:59:13 +0200 - build 4497

1. TinyXML-2 v3.0.0.

2. A couple of issues.

w17 29.12.2015 13:10:24 +0300 - build 4496

1. Copy/paste text containing '\0' in editor. When copied text contains zero characters,
   an additional 4 byte block containing the length of the text is created.
   The block type is 'Notepad++ binary text length', it must be compatible with notepad++ Paste Special.

drkns 28.12.2015 17:59:08 +0200 - build 4495

1. %farlocalproflie%\PluginsData was not created automatically, which could lead to consequences.

drkns 28.12.2015 16:32:20 +0200 - build 4494

1. Correction of 4493.

drkns 28.12.2015 15:28:08 +0200 - build 4493

1. Refactoring.

w17 27.12.2015 11:08:48 +0300 - build 4492

1. M#3142: Text insertion from Borland IDE is broken

drkns 25.12.2015 21:54:47 +0200

1. 0003145: New German translation

drkns 22.12.2015 09:38:41 +0200 - build 4491

1. Forum: Open the attached file in editor and press End to crash FAR.

2. #0003143: Arrow movements add space characters in editor

drkns 21.12.2015 20:25:07 +0200 - build 4490

1. Refactoring, continuation of 4484.

drkns 21.12.2015 08:13:52 +0200 - build 4489

1. And more.

drkns 20.12.2015 19:10:39 +0200 - build 4488

1. And more.

drkns 20.12.2015 16:47:03 +0200 - build 4487

1. Another correction of 4484.1.

drkns 20.12.2015 16:20:08 +0200 - build 4486

1. Refactoring, continuation of 4484.

drkns 20.12.2015 03:05:03 +0200 - build 4485

1. Correction of 4484.1.

drkns 19.12.2015 21:59:59 +0200 - build 4484

1. Refactoring. Massive reworking in input lines and therefore the editor. Consequences are expected.

2. Continuation of 4473 according to users' wishes: buttons insert new text into cursor position instead of replacing everything.

zg 19.12.2015 14:36:32 +0200 - build 4483

1. remove duplicate conversion of INPUT_RECORD to FarKey and vice versa.

drkns 19.12.2015 14:07:47 +0200 - build 4482

1. 0003137: A typo in Far.exe -? output
   Actually the output is correct, the error is in another place.

drkns 18.12.2015 19:39:04 +0200 - build 4481

1. Another correction of 4473.

w17 18.12.2015 13:24:46 +0300 - build 4480

1. Experimental: M#1910: "Add to archive" hotkey does not wok in Temporary Panel.

drkns 17.12.2015 21:32:47 +0200 - build 4479

1. Correction of 4473: Selection takes the whole string in absence of a block.

drkns 17.12.2015 20:56:42 +0200 - build 4478

1. User menu composed entirely of separators caused AV.

zg 16.12.2015 22:53:06 +0200 - build 4477

1. assert on alt-65536 input in editor.

drkns 16.12.2015 20:53:34 +0200 - build 4476

1. Another correction of 4473.

drkns 16.12.2015 19:48:28 +0200 - build 4475

1. Continuation of 4473 according to users' wishes.

drkns 16.12.2015 11:48:50 +0200 - build 4474

1. Correction of 4473.

drkns 16.12.2015 00:42:39 +0200 - build 4473

1. 'Editor settings - [x] Pick up the word' option deleted.
   Instead there are [ Word ] and [ Selection ] buttons right in search dialog which insert the written into the line.
   Selection takes only the first line of the block. It takes a word if there is no block.

2. DlgBuilder calculated vertical coordinates incorrectly for two columns of different size.

3. Refactoring.

drkns 12.12.2015 18:50:14 +0200

1. Whole source code is now utf-8.

2. Add include guards to *.hpp as gcc cannot into #pragma once for files with BOM. /o

drkns 12.12.2015 15:41:11 +0200 - build 4472

1. Forum: If volume types are hidden (Ctrl-1) then del does not remove subst volume.

drkns 11.12.2015 22:58:53 +0200 - build 4471

1. 0003131: Disappearing checkboxes for codepages checked in "Using codepage" menu

drkns 11.12.2015 22:02:06 +0200 - build 4470

1. Forum: if a single group is given as a search string then substrings in replace string are treated as metacharacters up to $1

drkns 11.12.2015 21:24:01 +0200 - build 4469

1. Crash on regex replace.

drkns 09.12.2015 20:28:43 +0200 - build 4468

1. debug & gcc.

2. syslog & gcc.

drkns 08.12.2015 00:25:17 +0200 - build 4467

1. Refactoring.

2. Some more on 4461.

shmuel 07.12.2015 21:04:04 +0200 - build 4466

1. M#3129: Several lines get merged to one

drkns 07.12.2015 21:03:09 +0200 - build 4465

1. Correction of 4461.

drkns 04.12.2015 00:24:07 +0200 - build 4464

1. Refactoring.

2. Warnings.

3. GCC build fix.

drkns 01.12.2015 20:24:11 +0200 - build 4463

1. Return the workaround for a bug in kernel32::GetFinalPathNameByHandleW lost in 2155.

drkns 30.11.2015 22:18:30 +0200 - build 4462

1. Refactoring.

2. Ukrainian translation from Vlad Lozynskyi.

drkns 27.11.2015 13:40:00 +0200 - build 4461

1. 0003124: Persistent network connections are not restored when started from another account.

drkns 26.11.2015 08:49:29 +0200 - build 4460

1. Correction of 4459.

drkns 23.11.2015 21:40:04 +0200 - build 4459

1. Refactoring.

drkns 21.11.2015 02:26:19 +0200 - build 4458

1. In some cases, selection of words in editor with mouse clicks could create several selection blocks.

shmuel 17.11.2015 14:41:37 +0200 - build 4457

1. Function FSF.FarInputRecordToName given some values of its 1st argument would not
   return until console input entered.

drkns 15.11.2015 11:59:17 +0200 - build 4456

1. Continuation of 4455.

drkns 15.11.2015 01:37:43 +0200 - build 4455

1. It happens that Far already can be built with clang. Some related changes in preprocessor macros.

svs 07.11.2015 00:28:32 +0300 - build 4454

1. SQLite 3.9.2

drkns 01.11.2015 19:04:35 +0200 - build 4453

1. Refactoring, VS15 warnings and other issues.

drkns 01.11.2015 18:59:48 +0200 - build 4452

1. For the future: split FindFiles into two separate classes: UI and search.

drkns 31.10.2015 13:07:10 +0200 - build 4451

1. 0003077: Exception in search in alternate streams

shmuel 28.10.2015 19:12:06 +0200 - build 4450

1. Minor refactoring in macro system.

w17 27.10.2015 19:36:48 +0300 - build 4449

1. Continuation of 4448. Do not crash in STACK_OVERFLOW handler, minidump shows the correct place of stack overflow.

w17 27.10.2015 17:39:42 +0300 - build 4448

1. Experimental: Minidump save button (%FARPROFILE%\Far.mdmp) in processing of SEHException.

drkns 27.10.2015 01:26:44 +0200 - build 4447

1. 0003026: FindFiles access violation exception

drkns 26.10.2015 09:25:44 +0200 - build 4446

1. Status line format string moved to lng.

drkns 24.10.2015 11:59:47 +0200 - build 4445

1. 0003053: Highlighting of files with >1 hard links slows down the panels on network volumes
   Add checking of FS name for OS which do not support FILE_SUPPORTS_HARD_LINKS.

drkns 24.10.2015 02:29:09 +0200 - build 4444

1. 0002520: Incorrect text of system error

2. 0003089: Minor edits in info panel (Ctrl+L) (partially).

drkns 24.10.2015 01:21:54 +0200 - build 4443

1. Some renamings to fix VS2015 warnings.

drkns 24.10.2015 00:04:08 +0200 - build 4442

1. Forum: show the number of folders in current panel.

2. Warnings.

w17 20.10.2015 16:21:53 +0300 - build 4441

1. M#3100: Crash on search in invalid ZIP archive
   Treatment for symptoms.

svs 19.10.2015 10:31:45 +0300 - build 4440

1. SQLite 3.9.1

drkns 18.10.2015 13:18:18 +0200 - build 4439

1. Carriage return was incorrectly processed in editor for codepages where it differed from 0x0d / 0x0a (EBCDIC etc.)

drkns 17.10.2015 14:35:10 +0200 - build 4438

1. Refactoring.

svs 16.10.2015 12:33:02 +0300 - build 4437

1. Mantis#0003062: FSF.CopyToClipboard+FCT_COLUMN desynchronizes clipboard
   For FCT_STREAM SetClipboard is used which clears the clipboard by itself.
   For FCT_COLUMN SetClipboardFormat(FCF_VERTICALBLOCK_UNICODE) is used which does not clear the clipboard and adds the data instead, so OEM is left intact.

   <ACHTUNG!>
   	SetClipboardFormat just adds the vertical block data to an existing content.
   </ACHTUNG!>

svs 15.10.2015 16:40:58 +0300 - build 4436

1. Mantis#0003061: FSF.CopyToClipboard + FCT_COLUMN: vertical blocks compatible with third-party applications
   Support for vertical blocks "Borland IDE Block Type" and "MSDEVColumnSelect" along with "FAR_VerticalBlock_Unicode".

   FAR adds new types to clipboard only for copying a vertical block.
   In clipboard:
     "FAR_VerticalBlock_Unicode" "native" FAR block
     "Borland IDE Block Type" block contains 1 byte 0x02
     "MSDEVColumnSelect"      block contains 0 bytes.
     The data itself is contained in "CF_UNICODETEXT".

   FAR accepts these types when pasting into the editor so it inserts vertical block.

svs 15.10.2015 13:15:19 +0300 - build 4435

1. Mantis#0003070: DI_EDIT+DIF_EDITEXPAND: variables are expanded too early
   "Expansion" takes place only if dialog procedure has returned TRUE.

svs 14.10.2015 17:41:39 +0300 - build 4434

1. SQLite 3.9.0

2. Mantis#0003033: Defect in drawing a frame in DI_TEXT+DIF_SEPARATORUSER

drkns 12.10.2015 18:26:07 +0200 - build 4433

1. another correction of 4431.

w17 12.10.2015 14:00:11 +0300 - build 4432

1. correction of 4431.

drkns 11.10.2015 16:04:27 +0200 - build 4431

1. Refactoring.

drkns 02.10.2015 09:36:40 +0200 - build 4430

1. 0003080: Alternate editor/viewer in FindFile results: temporary files will be deleted on FindFile closing. This should give enough time for external editor to open temporary file.

drkns 29.09.2015 21:44:11 +0200 - build 4429

1. Forum: "Something has happened to network volume deletion messages after 4424"

2. The path is displayed in subst volume disconnection confirmation dialog.

3. Minor fixes.

drkns 29.09.2015 09:06:03 +0200 - build 4428

1. gcc build fix

2. Refactoring.

drkns 26.09.2015 21:44:35 +0200 - build 4427

1. 0003093: "Drive" dialog (Alt-F1,Alt-F2) is not closed on Esc key press if the current panel directory is UNC path

2. Refactoring.

drkns 24.09.2015 22:50:09 +0200 - build 4426

1. Do not lose entered text when scrolling through history in command line.

2. Refactoring.

3. Warnings.

drkns 23.09.2015 02:45:20 +0200 - build 4425

1. Refactoring.

drkns 21.09.2015 19:19:19 +0200 - build 4424

1. Correction of 4423.1.

drkns 18.09.2015 22:40:33 +0200 - build 4423

1. Now we accept //these/paths too.

2. GCC build fix

3. Refactoring.

drkns 17.09.2015 22:04:20 +0200 - build 4422

1. Refactoring.

drkns 17.09.2015 20:59:50 +0200 - build 4421

1. Correction and simplification of environment variables auto-update logic.

svs 17.09.2015 19:11:41 +0300 - build 4420

1. Correction of build 4419 to match the planned logic (see the help)

svs 17.09.2015 19:04:05 +0300 - build 4419

1. Mantis#0003078: Configuration editor *marks some parameters as modified even in a new profile
   Only about "System.CopyBufferSize".

svs 10.09.2015 10:31:11 +0300 - build 4418

1. Mantis#0003055: ID missing for file deletion dialog, unable to check.

    DeleteWipeId                     = {9C054039-5C7E-4B04-96CD-3585228C916F}  --> Dlg.Id
    Main dialog for wiping of files/folders

    DeleteRecycleId                  = {85A5F779-A881-4B0B-ACEE-6D05653AE0EB}  --> Dlg.Id
    Main dialog for deleting of files/folders to recycle bin

    DeleteFileFolderId               = {85A5F779-A881-4B0B-ACEE-6D05653AE0EB}  --> Dlg.Id
    Main dialog for deleting of files/folders

    The next ones are various warnings on removing/wiping:

    DeleteLinkId                     = {B1099BC3-14BD-4B22-87AC-44770D4189A3}  --> Dlg.Id
    "Remove link" dialog

    DeleteFolderId                   = {4E714029-11BF-476F-9B17-9E47AA0DA8EA}  --> Dlg.Id
    Folder removal dialog
    (System.DeleteToRecycleBin = false)

    DeleteFolderRecycleId            = {A318CBDC-DBA9-49E9-A248-E6A9FF8EC849}  --> Dlg.Id
    Dialog for deleting a folder to recycle bin
    (System.DeleteToRecycleBin = true)

    WipeFolderId                     = {E23BB390-036E-4A30-A9E6-DC621617C7F5}  --> Dlg.Id
    Dialog for wiping a folder

    DeleteAskDeleteROId              = {8D4E84B3-08F6-47DF-8C40-7130CD31D0E6}  --> Dlg.Id
    ReadOnly file deletion confirmation

    DeleteAskWipeROId                = {6792A975-57C5-4110-8129-2D8045120964}  --> Dlg.Id
    ReadOnly file wiping confirmation

    WipeHardLinkId                   = {5297DDFE-0A37-4465-85EF-CBF9006D65C6}  --> Dlg.Id
    Warning on wiping a file with multiple hard links

    RecycleFolderConfirmDeleteLinkId = {26A7AB9F-51F5-40F7-9061-1AE6E2FBD00A}  --> Dlg.Id
    Warning on a folder containing symbolic links and data loss after cleaning the recycle bin
    so the links have to be deleted (see MRecycleFolderConfirmDeleteLink?)

    CannotRecycleFileId              = {52CEB5A5-06FA-43DD-B37C-239C02652C99}  --> Dlg.Id
    Could not delete file to recycle bin

    CannotRecycleFolderId            = {BBD9B7AE-9F6B-4444-89BF-C6124A5A83A4}  --> Dlg.Id
    Could not delete folder to recycle bin


svs 08.09.2015 17:50:24 +0300 - build 4417

1. Mantis#0002905: Assign GUID to "Apply command" dialog (CtrlG)

    ApplyCommandId                   = {044EF83E-8146-41B2-97F0-404C2F4C7B69}  --> Dlg.Id
    "Apply command" dialog (CtrlG)


w17 08.09.2015 16:09:18 +0300 - build 4416

1. Correction of 4414 -typo

w17 08.09.2015 12:29:00 +0300 - build 4415

1. Continuation of 4392, 4394 (M#2951)
   Remove traces of Tree from command menu and keybar.

svs 07.09.2015 16:06:23 +0300 - build 4414

1. Mantis#0003084: Add GUIDs

    DescribeFileId                   = {D8AF7A38-8357-44A5-A44B-A595CF707549}  --> Dlg.Id
    Description edit dialog (CtrlZ)

    SelectDialogId                   = {29C03C36-9C50-4F78-AB99-F5DC1A9C67CD}  --> Dlg.Id
    Set file selection dialog (Add)
    
    UnSelectDialogId                 = {34614DDB-2A22-4EA9-BD4A-2DC075643F1B}  --> Dlg.Id
    Clear file selection dialog (Subtract)
    
    SUBSTDisconnectDriveError1Id     = {FF18299E-1881-42FA-AF7E-AC05D99F269C}  --> Dlg.Id
    SUBSTDisconnectDriveError2Id     = {43B0FFC2-70BE-4289-91E6-FE9A3D54311B}  --> Dlg.Id
    SUBST volumes removal error dialogs

    RemoteDisconnectDriveError1Id    = {C9439386-9544-49BF-954B-6BEEDE7F1BD0}  --> Dlg.Id
    RemoteDisconnectDriveError2Id    = {F06953B8-25AA-4FC0-9899-422FC1D49F7A}  --> Dlg.Id
    Network volumes disconnection error dialogs

    EjectHotPlugMediaErrorId         = {D6DC3621-877E-4BE2-80CC-BDB2864CE038}  --> Dlg.Id
    Flash drive removal error dialog

    VHDDisconnectDriveErrorId        = {B890E6B0-05A9-4ED8-A4C3-BBC4D29DA3BE}  --> Dlg.Id
    Virtual volume removal error dialog

    ChangeDriveCannotReadDiskErrorId = {F3D46DC3-380B-4264-8BF8-10B05B897A5E}
    Drive change error dialog


drkns 04.09.2015 21:47:21 +0200 - build 4413

1. Refactoring.

shmuel 04.09.2015 13:40:29 +0200 - build 4412

1. M#3083: Content column is not updated on panel mode switch

drkns 02.09.2015 21:13:07 +0200 - build 4411

1. 0003080: Alternate editor/viewer in FindFile results

drkns 29.08.2015 00:46:04 +0200 - build 4410

1. Refactoring

2. VC2015 warnings

3. Whole program optimization in VC Release builds

w17 15.08.2015 10:46:45 +0300 - build 4409

1. Correction of 4408

w17 15.08.2015 00:24:24 +0300 - build 4408

1. M#281: Automatic substitution of environment variables does not allow to use paths like C:\%AppData%

drkns 14.08.2015 22:33:52 +0200 - build 4407

1. 0003056: Marking files at the left panel "breaks" the panel separator

zg 31.07.2015 15:36:58 +0200 - build 4406

1. forum: when i search for files (any mask), choose one not in current folder, 
   press F4 and Ctrl-F10 in opened editor, the panels are shown.

svs 30.07.2015 00:03:25 +0300 - build 4405

1. SQLite 3.8.11.1

drkns 29.07.2015 23:25:17 +0200 - build 4404

1. Do not sort modified description files.

drkns 28.07.2015 23:15:06 +0200 - build 4403

1. Refactoring.

svs 28.07.2015 11:24:22 +0300 - build 4402

1. SQLite 3.8.11

shmuel 11.07.2015 02:20:25 +0200 - build 4401

1. M#3019: Number of custom columns is limited to 10 for plugin
   -> Now it is limited to 100 (C0...C99).

drkns 09.07.2015 00:39:19 +0200 - build 4400

1. Refactoring.

drkns 05.07.2015 19:19:57 +0200 - build 4399

1. Refactoring.

drkns 04.07.2015 21:54:54 +0200 - build 4398

1. After 4394.1, the search dialog crashed in some cases.
   Also, please do not use one- and two-character names for variables in source code for anything but indices.

drkns 02.07.2015 23:37:09 +0200 - build 4397

1. Forum: Strange behavior of F7/Shift-F7 search in editor

2. Warnings.

zg 28.06.2015 02:50:26 +0200 - build 4396

1. ACTL_SETCURRENTWINDOW, VCTL_QUIT and ECTL_QUIT are executed immediately.

2. ACTL_COMMIT does nothing and is left for compatibility reasons.

w17 26.06.2015 18:43:53 +0300 - build 4395

1. Cosmetic changes.

w17 25.06.2015 13:28:40 +0300 - build 4394

1. Items with DIF_CENTERGROUP|DIF_HIDDEN shall not take space in dialogs.

2. Continuation of 4392 -- when tree is switched off then its menu items and dialog buttons are not shown.

3. New far:config setting -- Editor.NewFileUnixEOL
   If True then new files use Unix line endings <LF>.

drkns 24.06.2015 22:13:33 +0200 - build 4393

1. Refactoring.

w17 15.06.2015 16:31:15 +0300 - build 4392

1. M#2951: Remove everything tree-related from far3
   Not dropped yet, just turned off by default.
   Tree fans can use Panel.Tree.TurnOffCompletely = False in far:config.

drkns 09.06.2015 00:59:20 +0200 - build 4391

1. Mouse click action in autocompletion menu was different from Enter key press.

drkns 06.06.2015 23:50:38 +0200 - build 4390

1. More correct solution for 4388.

drkns 05.06.2015 00:28:50 +0200 - build 4389

1. Correction of 4387.3.

drkns 04.06.2015 23:42:07 +0200 - build 4388

1. VC10.

drkns 04.06.2015 21:34:47 +0200 - build 4387

1. More paranoid settings for gcc warnings.

2. In some previous version there was broken check for presence of certain functions in OS. It could influence other parts.

3. Refactoring.

zg 03.06.2015 21:49:26 +0200 - build 4386

1. 0003001: BookmarkManager script functionality broken in nightly builds.

drkns 03.06.2015 20:24:43 +0200 - build 4385

1. 0003000: problem with copying screen with /ag key

zg 29.05.2015 23:39:54 +0200 - build 4384

1. 0002997: Improper sorting after Compare Folders.

zg 29.05.2015 19:12:18 +0200 - build 4383

1. FARLANG is assigned an empty value for a clean profile.

svs 21.05.2015 07:33:01 +0300 - build 4382

1. SQLite 3.8.10.2

drkns 18.05.2015 22:39:06 +0200 - build 4381

1. Warnings mix:
   - for vc, suppression of warnings moved to a separate file
   - -Wextra for gcc.

2. Refactoring.

zg 16.05.2015 04:38:48 +0200 - build 4380

1. 0002994: GUID for User Menu dialogs invoked with !?<title>?<init>!.

drkns 15.05.2015 21:52:32 +0200 - build 4379

1. Correction of 4376.

2. Minor issues.

drkns 15.05.2015 00:03:45 +0200 - build 4378

1. Refactoring.

drkns 14.05.2015 08:41:28 +0200 - build 4377

1. Correction of 4364.

drkns 14.05.2015 00:00:00 +0200 - build 4376

1. Refactoring.

zg 10.05.2015 02:14:51 +0200 - build 4375

1. 0002991: Dynamic selection mark in panels.

svs 09.05.2015 23:17:24 +0300 - build 4374

1. SQLite 3.8.10.1

drkns 08.05.2015 18:51:45 +0200 - build 4373

1. Error in file size calculation at copying with ADS taken into account.

drkns 08.05.2015 01:29:05 +0200 - build 4372

1. 0002990: Viewer crashed if opened from temporary editor

svs 07.05.2015 20:33:44 +0300 - build 4371

1. SQLite 3.8.10

drkns 07.05.2015 16:23:58 +0200 - build 4370

1. Displaying the number of processed bytes in copying progress dialog.

drkns 06.05.2015 22:16:11 +0200 - build 4369

1. And once more.

drkns 06.05.2015 20:26:51 +0200 - build 4368

1. And once more.

drkns 06.05.2015 17:29:36 +0200 - build 4367

1. A couple of corrections in 4366.

drkns 06.05.2015 16:39:28 +0200 - build 4366

1. Forum: Autocompletion of environment variables in command line

2. far:config: Editor.WordDiv option is renamed to System.WordDiv.

3. Refactoring.

drkns 04.05.2015 14:51:59 +0200 - build 4365

1. Correction of 4364.

drkns 04.05.2015 14:42:35 +0200 - build 4364

1. Forum: Crash in editor during text replace done with [x] Pick up the word
   In addition, the algorithm of word search in a line is slightly redone.

drkns 01.05.2015 21:11:56 +0200 - build 4363

1. Refactoring.

zg 30.04.2015 01:15:07 +0200 - build 4362

1. refactoring: processing of keypresses.

drkns 26.04.2015 13:40:02 +0200 - build 4361

1. Continuation of 4356.

drkns 26.04.2015 03:26:55 +0200 - build 4360

1. Correction of 4356.

drkns 26.04.2015 01:04:53 +0200 - build 4359

1. Continuation of 4356.

zg 26.04.2015 00:40:10 +0200 - build 4358

1. correction of 4353.2: Releasing of a modifier may be interpreted as BreakKey for menu.

drkns 25.04.2015 23:44:26 +0200 - build 4357

1. Correction of 4356.

drkns 25.04.2015 22:27:47 +0200 - build 4356

1. Refactoring.

zg 23.04.2015 12:54:15 +0200 - build 4355

1. correction of 4352 for FarInputRecordToName.

zg 23.04.2015 02:01:09 +0200 - build 4354

1. correction of 4345: xlat malfunction in editor.

zg 22.04.2015 21:26:13 +0200 - build 4353

1. DM_SETMOUSEEVENTNOTIFY is renamed to DM_SETINPUTNOTIFY.

2. DN_INPUT now receives all console events.

zg 22.04.2015 14:23:46 +0200 - build 4352

1. correction of 4337: FAR responds to modifiers release. 

drkns 15.04.2015 22:47:32 +0200 - build 4351

1. 0002872: Do not break the codepage of FarMenu.ini

2. Related to #1 refactoring.

w17 14.04.2015 15:03:44 +0300 - build 4350

1. Rollback of 4324+, unnecessary feature.

drkns 13.04.2015 14:09:29 +0200 - build 4349

1. History could contain duplicate items (bug in sqlite_unicode.c)

zg 13.04.2015 13:27:28 +0200 - build 4348

1. correction of 4337: ralt does not switch the menu filter on.

drkns 13.04.2015 10:40:22 +0200 - build 4347

1. Correction of 4309.

drkns 13.04.2015 09:52:11 +0200 - build 4346

1. Correction of 4345.

drkns 12.04.2015 22:26:53 +0200 - build 4345

1. Refactoring.

drkns 12.04.2015 21:02:09 +0200 - build 4344

1. Based on http://forum.farmanager.com/viewtopic.php?f=9&t=9034:
   - Experimental: add support for Unicode in SQLite, now work with DB can be case insensitive.
   - Storing of position in viewer/editor is case insensitive.
   - For this to work correctly history.db has to be removed or updated according to the instruction in the topic above.
   - Inform us if it matters anywhere but storing positions in viewer/editor.

zg 12.04.2015 19:46:28 +0200 - build 4343

1. correction of 4332: changing codepage in editor.

drkns 12.04.2015 15:18:07 +0200 - build 4342

1. Forum: far /import crash

2. Refactoring.

drkns 11.04.2015 23:04:41 +0200 - build 4341

1. Refactoring.

2. Warnings.

zg 10.04.2015 13:29:09 +0200 - build 4340

1. correction of 4337: selection reset while editing.

2. numlock, capslock, scrolllock removed the 'Unchanged' flag in edit fields.

3. gcc warnings.

zg 10.04.2015 01:25:50 +0200 - build 4339

1. incorrect initialization of a dialog item for nonzero FarDialogItem.MaxLength.

svs 09.04.2015 06:54:08 +0300 - build 4338

1. SQLite 3.8.9

zg 09.04.2015 03:05:55 +0200 - build 4337

1. processing of CtrlAltShift is isolated.

drkns 05.04.2015 19:07:30 +0200 - build 4336

1. Refactoring. Some renaming and moving of some functions.

drkns 03.04.2015 20:55:27 +0200 - build 4335

1. 0002980: Malfunction of "Code pages" menu.

zg 03.04.2015 14:10:08 +0200 - build 4334

1. correction of 4330.

zg 03.04.2015 13:55:43 +0200 - build 4333

1. correction of 4332.

zg 03.04.2015 02:57:53 +0200 - build 4332

1. 0002979: Lossless editing of any files in UTF-8 mode.

drkns 02.04.2015 23:15:07 +0200 - build 4331

1. Refactoring.

2. Plugins menu would not be invoked from command line completion menu.

zg 02.04.2015 16:15:43 +0200 - build 4330

1. forum: Get the contents of command line with a plugin from user menu.

w17 01.04.2015 20:26:38 +0300 - build 4329

1. 'Find file' word search worked incorrectly if a word was at the end of a block.

shmuel 29.03.2015 20:49:04 +0200 - build 4328

1. Correction of 4261.

drkns 28.03.2015 16:51:12 +0200 - build 4327

1. Refactoring.

w17 26.03.2015 13:57:16 +0300 - build 4326

1. Correction of 4324

w17 26.03.2015 13:51:15 +0300 - build 4325

1. Correction of 4324

w17 25.03.2015 13:23:12 +0300 - build 4324

1. Experimental: Continuation of 3717 (M#2208: Store the folder a command was issued in).
   A new configuration parameter: System.PerFolderCmdHistory.
   The default is false, if true then duplicate commands are written into history
   if the folders of launch are different. The duplicate commands are not shown in standard FAR history.

drkns 21.03.2015 16:50:29 +0200 - build 4323

1. Copying of text from edit fields could trigger assertions.

zg 21.03.2015 16:47:45 +0200 - build 4322

1. remove an easter egg from valentin. for example, if the following magic set of letters was entered in the command line:
   lua:far.InputRecordToName ({EventType=far.Flags.KEY_EVENT,KeyDown=true,RepeatCount=1,VirtualKeyCode=45,VirtualScanCode=82,UnicodeChar=0,ControlKeyState=258})
   the grabber was invoked.

zg 21.03.2015 00:32:43 +0200 - build 4321

1. remove FARMACRO_KEY_EVENT.

2. temporary correction of 4318 for shift/alt/ctrl keypresses.

drkns 20.03.2015 09:36:40 +0200 - build 4320

1. Continuation of 4309.

drkns 19.03.2015 22:55:49 +0200 - build 4319

1. Correction of 4280.

zg 19.03.2015 19:12:19 +0200 - build 4318

1. refactoring: processing of keypresses.

w17 19.03.2015 13:08:26 +0300 - build 4317

1. M#2971: Crash on use of a regular expression with large number of groups

zg 19.03.2015 00:34:46 +0200 - build 4316

1. refactoring: processing of keypresses.

drkns 18.03.2015 22:06:40 +0200 - build 4315

1. Continuation of 4309.

zg 18.03.2015 16:13:08 +0200 - build 4314

1. correction of 4309: a block of undefined type was selected with ctrla in editor.

zg 18.03.2015 15:36:39 +0200 - build 4313

1. correction of 4305: ProcessEditorInputW stopped to receive key release messages.

drkns 18.03.2015 08:59:33 +0200 - build 4312

1. Syncronization objects were uninitialized in some cases.

drkns 18.03.2015 08:18:21 +0200 - build 4311

1. Correction of 4309.

drkns 17.03.2015 23:32:39 +0200 - build 4310

1. 0002970: Issues with window caption refresh

drkns 17.03.2015 22:42:42 +0200 - build 4309

1. Continue breaking of the editor. Bugs possible.

zg 17.03.2015 18:48:44 +0200 - build 4308

1. correction of 4306.

drkns 17.03.2015 09:46:47 +0200 - build 4307

1. 0002969: ProcessViewerEventW does not receive messages about QuickView closed

zg 17.03.2015 00:30:18 +0200 - build 4306

1. forum: problems with EF_OPENMODE_USEEXISTING.

zg 15.03.2015 03:02:46 +0200 - build 4305

1. ProcessEditorInput is not sent KEY_IDLE and KEY_NONE pseudo-keys.

w17 12.03.2015 17:40:22 +0300 - build 4304

1. Correction of 4302.

drkns 11.03.2015 20:07:31 +0200 - build 4303

1. Correction of 4298.

w17 11.03.2015 15:50:45 +0300 - build 4302

1. Remove query for privilege escalation for file viewed from flash drive with NTFS on Win Server 2008 R2 SP1

w17 11.03.2015 13:20:04 +0300 - build 4301

1. Correction of 4279.

drkns 09.03.2015 23:54:31 +0200 - build 4300

1. Correction of 4298.

zg 09.03.2015 20:27:35 +0200 - build 4299

1. typo in 4298.

drkns 09.03.2015 19:35:06 +0200 - build 4298

1. Refactoring.

shmuel 09.03.2015 19:09:39 +0200 - build 4297

1. M#2966: Incorrect insertion of vertical block at the end of file.

drkns 09.03.2015 16:57:18 +0200 - build 4296

1. Correction of 4294.

shmuel 09.03.2015 00:15:32 +0200 - build 4295

1. M#2965: Insertion of a vertical block strips last characters in each line.

drkns 08.03.2015 19:08:46 +0200 - build 4294

1. Refactoring.

drkns 08.03.2015 10:38:08 +0200 - build 4293

1. 0002963: FAR crash while opening a file in incorrect encoding

2. A couple of "corrections".

drkns 08.03.2015 03:59:24 +0200 - build 4292

1. fsf.sprintf/fsf.snprintf worked incorrectly (in fact, too correctly) in GCC.

2. CoUninitialize was called earlier than expected.

drkns 05.03.2015 23:52:10 +0200 - build 4291

1. Refactoring.

2. CoInitializeEx was broken in one of previous builds.

zg 05.03.2015 12:02:34 +0200 - build 4290

1. always load plugins with LoadLibrary* in order to increase DLL ref counter.

zg 05.03.2015 05:31:29 +0200 - build 4289

1. correction of 4248: leave old DM_SETTEXT behavior in wrapper.

zg 05.03.2015 03:31:02 +0200 - build 4288

1. 0002959: FCTL_SETPANELDIRECTORY redraws screen at wrong moments.

drkns 04.03.2015 02:57:17 +0200 - build 4287

1. Correction of 4280.2.

drkns 03.03.2015 22:47:29 +0200 - build 4286

1. 0002957: Undo cancels added line but it remains after file save

2. Expand main menu with Up key.

drkns 02.03.2015 22:15:32 +0200 - build 4285

1. Correction of 4280.1.

drkns 01.03.2015 16:17:34 +0200 - build 4284

1. Strange things could happen after some manipulations with QuickView.

zg 01.03.2015 13:12:22 +0200 - build 4283

1. 0002956: FAR crash on start after exit with quick view panel visible.

drkns 01.03.2015 02:12:37 +0200 - build 4282

1. Correction of 4280.2.

drkns 01.03.2015 00:58:19 +0200 - build 4281

1. Correction of 4280.1.

drkns 28.02.2015 23:56:47 +0200 - build 4280

1. FCTL_SETPANELDIRECTORY now returns 0 on failure and does not show dialogs.

2. Refactoring. Expect some bugs in editor.

w17 27.02.2015 14:35:20 +0300 - build 4279

1. M#2954: Switch to Viewer (F6) loses current position when "Save file position" is OFF

svs 25.02.2015 19:08:58 +0300 - build 4278

1. SQLite 3.8.8.3

drkns 23.02.2015 19:43:02 +0200 - build 4277

1. Correction of 4275.

2. Continuation of 4276.

drkns 21.02.2015 11:14:06 +0200 - build 4276

1. Incorrect expansion of paths C:path.

drkns 21.02.2015 09:54:33 +0200 - build 4275

1. Refactoring.

shmuel 21.02.2015 00:52:00 +0200 - build 4274

1. Refactoring.

shmuel 20.02.2015 17:58:57 +0200 - build 4273

1. Refactoring.

zg 20.02.2015 01:01:34 +0200 - build 4272

1. correction of 4262: when something caused quickview redraw in VE_READ, FAR crashed.

shmuel 19.02.2015 16:30:33 +0200 - build 4271

1. M#2950: InputRecordToName returns a character of code 1: ☺

w17 18.02.2015 23:36:18 +0300 - build 4270

1. M#2949: HEX search problem -- fix 4208

svs 14.02.2015 10:29:41 +0300 - build 4269

1. SQLite 3.8.8.2

w17 13.02.2015 16:24:23 +0300 - build 4268

1. M#2540: Viewer Search always starts from the beginning of the file 

2. Default Viewer.PersistentBlocks = true

zg 09.02.2015 02:06:46 +0200 - build 4267

1. ACTL_WAITKEY returns 0 in accordance with the documentation.

w17 08.02.2015 16:36:15 +0300 - build 4266

1. M#2935: <Symlink> to files not showing

2. M#2934: Errors in HEX mode in search dialogs

w17 04.02.2015 15:35:47 +0300 - build 4265

1. Correction of 4262

w17 04.02.2015 14:10:08 +0300 - build 4264

1. Correction of 4263

w17 03.02.2015 20:32:45 +0300 - build 4263

1. Viewer autoupdate if ACTL_SYNCHRO or far.Timer() are present (M#2532)

w17 03.02.2015 17:43:09 +0300 - build 4262

1. Incorrect display of the text of a modified file after switching to viewer.

shmuel 03.02.2015 01:42:54 +0200 - build 4261

1. Plugins API: FSF.FarClock standard function is added - same as Far.UpTime in macros,
   but in microseconds and with microsecond resolution. The documentation to be done.

w17 02.02.2015 13:38:18 +0300 - build 4260

1. Fixes in viewer:
   -a couple of minor bugs/typos
   -0x0 <=> 0xffff hack and consequences of its refactoring
   Experimental - Shift+MouseClick selects arbitrary text, the beginning/end
   Continuing M#2540 - regular expression search is not fixed yet

drkns 01.02.2015 17:25:54 +0200 - build 4259

1. Replacement with regular expressions can use named groups now.

drkns 30.01.2015 19:26:48 +0200 - build 4258

1. 0002708: Regexp "^(.*?\-\-)" != "^(.*?\-{2})"
   Rollback 4257 and fix 3295.

w17 30.01.2015 19:39:58 +0300 - build 4257

1. M#0002708: Regexp "^(.*?\-\-)" != "^(.*?\-{2})"
   Return #define MINSTEP(cmp) - /a*?ca/ "abca" which works

svs 26.01.2015 15:43:08 +0300 - build 4256

1. Crash in debug FAR build on "__FARKEY_ToName(-1)" call.
   In KeyToTextImpl() the expression "KeyText[0]=(wchar_t)(Key&0xFFFF);" caused an invalid character...

drkns 24.01.2015 09:09:05 +0200 - build 4255

1. Correction of 4254.2.

drkns 22.01.2015 23:13:47 +0200 - build 4254

1. Show volume labels from registry if the physical ones do not exist.

2. "Fix" loading of plugins with non-standard placement of dependent dll.

3. Do not close quick search on focus lose for OS newer than XP/2k3.

4. Refactoring.

shmuel 22.01.2015 13:21:30 +0200 - build 4253

1. Refactoring.

shmuel 21.01.2015 23:58:16 +0200 - build 4252

1. Refactoring.

shmuel 21.01.2015 16:51:57 +0200 - build 4251

1. Refactoring.

zg 20.01.2015 23:11:38 +0200 - build 4250

1. correction of 4248 for non-editable controls.

svs 20.01.2015 23:19:32 +0300 - build 4249

1. SQLite 3.8.8.1

zg 20.01.2015 03:18:09 +0200 - build 4248

1. 0002912: DM_SETTEXT, DM_GETTEXT in dialogs do not allow handle strings containing '\0'.

svs 19.01.2015 23:46:37 +0300 - build 4247

1. SQLite 3.8.8

drkns 19.01.2015 20:24:15 +0200 - build 4246

1. Correction of displaying of file deletion progress bar.

shmuel 18.01.2015 20:58:13 +0200 - build 4245

1. Data for content columns of the same name but different plugins are concatenated.

shmuel 17.01.2015 23:30:07 +0200 - build 4244

1. Refactoring.

drkns 17.01.2015 23:10:50 +0200 - build 4243

1. 0002908: Exception after attempt of displaying a description for incorrect Descript.ion

drkns 17.01.2015 16:00:16 +0200 - build 4242

1. Continuation of 4241.

1. Support for compilation with Intel C++ 14.

drkns 17.01.2015 09:38:11 +0200 - build 4241

1. Race condition in far /?

2. Correction of 4232.

3. Refactoring.

zg 16.01.2015 00:46:37 +0200 - build 4240

1. correction for altf9 in quick search.

svs 14.01.2015 12:54:28 +0300 - build 4239

1. F1 shows "MiscCmd" help screen in grabber (Alt-Ins).
   Selection of an area is not cancelled on help window close.

shmuel 11.01.2015 20:00:05 +0200 - build 4238

1. Refactoring.

drkns 09.01.2015 19:25:37 +0200 - build 4237

1. 0002849: ProcessSynchroEventW is called for DMODE_NOPLUGINS.

zg 09.01.2015 01:10:36 +0200 - build 4236

1. incorrect redrawing of panels after filter menu close.

zg 09.01.2015 00:44:51 +0200 - build 4235

1. ACTL_REDRAWALL now redraws everything.

drkns 08.01.2015 22:22:57 +0200 - build 4234

1. Refactoring.

2. VS2015 warnings.

drkns 04.01.2015 19:27:27 +0200 - build 4233

1. Refactoring.

drkns 03.01.2015 12:36:25 +0200 - build 4232

1. Refactoring.

zg 02.01.2015 13:56:19 +0200 - build 4231

1. 0002896: Assign a GUID to the panel filter editing dialog.

drkns 30.12.2014 18:01:40 +0200 - build 4230

1. Use std::regex for inner path parser.
   Minimal gcc version is now 4.9.

drkns 27.12.2014 15:13:59 +0200 - build 4229

1. 0002845: Wrong Handling of "exclamation marks" in Menu item "!?<title>?<init>!"

zg 26.12.2014 18:50:17 +0200 - build 4228

1. sometimes fast search in panels was not redrawn correctly.

drkns 24.12.2014 22:53:03 +0200 - build 4227

1. Continuation of #0002893 - privilege escalation is added.

drkns 22.12.2014 22:53:05 +0200 - build 4226

1. 0002893: Cannot unmount iso, vhd, vhdx

svs 22.12.2014 15:31:42 +0300 - build 4225

1. Tree. Shift-F10 and Alt-F10 did not work in copy/move dialogs

2. Tree. Video artifacts (m_ModalMode has changed from "yes/no" to "0..2" for some time now).

svs 22.12.2014 13:24:20 +0300 - build 4224

1. Corrections on TREEFILE_PROJECT (Mantis#0000186)

drkns 21.12.2014 15:02:37 +0200 - build 4223

1. Experimental: alternative solution for a problem of "open with" in launcher.

drkns 20.12.2014 14:21:00 +0200 - build 4222

1. Correction of 4221.

drkns 20.12.2014 14:12:21 +0200 - build 4221

1. Settings import error.

2. Writing failure of tree3.far on exit could freeze the app.

3. Refactoring.

zg 18.12.2014 17:04:23 +0200 - build 4220

1. Issues with filenames starting with ゝ character.

drkns 16.12.2014 09:27:11 +0200 - build 4219

1. 0002887: Far Manager v3.0 build 4218 x64 (2014-12-16) crash after Ctrl-F in panels (get a full path)

drkns 16.12.2014 00:02:43 +0200 - build 4218

1. And one more time.

drkns 15.12.2014 21:16:06 +0200 - build 4217

1. Correction of 4216.

drkns 15.12.2014 19:31:52 +0200 - build 4216

1. A couple if issues in 4214.

svs 15.12.2014 13:05:37 +0300 - build 4215

1. Mantis#0002878: Object.CheckHotkey

shmuel 15.12.2014 00:18:36 +0200 - build 4214

1. Experimental: C0 column is removed, now there is arbitrary quantity of plugin content columns.
   Types (or names) of columns are set in panel modes in angle brackets, for example: <Foo>,<Bar>.

drkns 14.12.2014 21:32:16 +0200 - build 4213

1. Refactoring.

shmuel 13.12.2014 17:58:08 +0200 - build 4212

1. MacroControl(MCTL_ADDMACRO) with given Callback function did not work in GCC build of FAR.

svs 09.12.2014 21:54:12 +0300 - build 4211

1. SQLite 3.8.7.4

zg 07.12.2014 17:27:25 +0200 - build 4210

1. correction of 4208: crash of some panel ansi plugins.

zg 07.12.2014 15:51:43 +0200 - build 4209

1. correction of 4208: files in encoding 1200 and 1201 were opened in viewer in dump mode.

drkns 06.12.2014 19:29:13 +0200 - build 4208

1. Refactoring.

zg 06.12.2014 01:05:54 +0200 - build 4207

1. rollback of 4203.2, 4204.

shmuel 04.12.2014 20:53:25 +0200 - build 4206

1. Correction of 3680.

w17 03.12.2014 14:41:20 +0300 - build 4205

1. M#2211: GUI context menu cannot be closed by pressing Esc button
   EMenu is called on button release

zg 03.12.2014 03:56:49 +0200 - build 4204

1. experimental. continuation of 4203. support for C1-C9 columns.

zg 30.11.2014 11:55:22 +0200 - build 4203

1. after switching from a mode with no custom column to a mode with the custom column it displayed nothing.

2. experimental. post-processing of data returned by plugins for custom column with the help of LuaMacro plugin.

zg 29.11.2014 02:37:27 +0200 - build 4202

1. correction of 4137.

zg 20.11.2014 16:25:43 +0200 - build 4201

1. FAR crashed when a plugin returned nullptr in KeyBarLabel.Text.

zg 20.11.2014 13:22:03 +0200 - build 4200

1. correction of 4197.

zg 20.11.2014 04:03:52 +0200 - build 4199

1. correction of 4197: do not update plugin panels.

zg 20.11.2014 03:14:13 +0200 - build 4198

1. correction of 4197.

zg 20.11.2014 03:03:40 +0200 - build 4197

1. sometimes the panels could be reread but not redrawn.

drkns 20.11.2014 01:07:04 +0200 - build 4196

1. Change of text color calculation in panels, see http://forum.farmanager.com/viewtopic.php?p=125730.

zg 20.11.2014 00:43:18 +0200 - build 4195

1. content search in files worked only for the first 32 kilobytes.

svs 19.11.2014 14:51:39 +0300 - build 4194

1. SQLite 3.8.7.2

drkns 16.11.2014 23:30:38 +0200 - build 4193

1. A couple of issues.

drkns 16.11.2014 17:10:47 +0200 - build 4192

1. DWORD -> size_t mix.

drkns 16.11.2014 15:04:03 +0200 - build 4191

1. Forum: msgbox('""','""') does not output quotes

2. Refactoring.

shmuel 14.11.2014 14:32:36 +0200 - build 4190

1. mf.waitkey worked incorrectly when called not from a macro.

drkns 12.11.2014 23:34:04 +0200 - build 4189

1. Do not hide sizes for any types of reparse points.

w17 12.11.2014 17:19:14 +0300 - build 4188

1. Correction of 4174.3

drkns 11.11.2014 23:09:00 +0200 - build 4187

1. "Delete symbolic links" option is transformed to a warning in the process of deletion.

w17 11.11.2014 16:30:33 +0300 - build 4186

1. Correction of 4185

w17 11.11.2014 15:50:30 +0300 - build 4185

1. Quick/Diz Viewer Keybar corrections

drkns 10.11.2014 20:11:52 +0200 - build 4184

1. "Create folders in uppercase" option is removed.

drkns 10.11.2014 19:31:00 +0200 - build 4183

1. 4180 once more.

zg 10.11.2014 19:23:23 +0200 - build 4182

1. correction of 4061.1.

zg 10.11.2014 19:00:49 +0200 - build 4181

1. rollback of 4177.

2. parser for editor's altf8 input line is rewritten.

3. correction of positioning with altf8 in lines containing tabulation characters.

drkns 10.11.2014 18:50:48 +0200 - build 4180

1. "System settings/Create folders in uppercase" option did not work.

w17 10.11.2014 18:14:28 +0300 - build 4179

1. Correction of 4122.1

w17 10.11.2014 17:24:43 +0300 - build 4178

1. Correction of 4122.1

zg 10.11.2014 16:08:11 +0200 - build 4177

1. altf8 in editor moved to the given line even if it was cancelled.

drkns 09.11.2014 02:12:34 +0200 - build 4176

1. GCC.

drkns 09.11.2014 00:34:51 +0200 - build 4175

1. Correction of 4174.

drkns 08.11.2014 23:16:10 +0200 - build 4174

1. Refactoring.

2. In some cases the key bar was not updated on editor open.

3. Add information on IO_REPARSE_TAG_FILE_PLACEHOLDER (Windows 8.1 OneDrive).

zg 07.11.2014 12:33:42 +0200 - build 4173

1. forum:
   The following command called from editor's user menu
   lua: far.Message("from lua")
   when a dialog is shown, makes the last editor line be highlighted with black.

zg 07.11.2014 03:22:43 +0200 - build 4172

1. each screen object has now its parent window.

drkns 06.11.2014 15:56:10 +0200 - build 4171

1. Forum: Excepton occured: bad allocation

zg 05.11.2014 16:44:44 +0200 - build 4170

1. correction of 4047 for plugin panels:
   Open .7z file containing folders on a panel, set the cursor on it and press CtrlQ, the following is shown:
   Folders          0
   Files            0
   Files size       0
   Allocated size   0 (0%)

drkns 02.11.2014 13:15:16 +0200 - build 4169

1. More corrections of 4167.

drkns 02.11.2014 11:38:28 +0200 - build 4168

1. Correction of 4167.

drkns 02.11.2014 00:53:53 +0200 - build 4167

1. Refactoring.

drkns 02.11.2014 00:38:57 +0200 - build 4166

1. Correction of 4164.2.

svs 30.10.2014 09:39:35 +0300 - build 4165

1. SQLite 3.8.7.1

drkns 29.10.2014 21:40:58 +0200 - build 4164

1. Do not crash if there is not enough memory to open a file in editor.

2. A couple of minor issues.

w17 29.10.2014 18:50:54 +0300 - build 4163

1. Show the number of the codepage in editor transcoding problems warning.

w17 28.10.2014 16:39:44 +0300 - build 4162

1. FFILEEDIT_CODEPAGECHANGEDBYUSER/editor, CodePageChangedByUser/viewer are commented out.

w17 28.10.2014 10:06:51 +0300 - build 4161

1. Continuing 4150.

w17 27.10.2014 12:45:51 +0300 - build 4160

1. Continuing 4150.

zg 26.10.2014 16:39:00 +0200 - build 4159

1. removed original method of redrawing a window by sending it 'gotfocus'.

zg 25.10.2014 21:39:01 +0200 - build 4158

1. editor drawing optimization.

w17 25.10.2014 21:18:26 +0400 - build 4157

1. Again 4150.

zg 25.10.2014 18:45:48 +0200 - build 4156

1. excessive redrawing of edit controls is removed.

w17 22.10.2014 17:54:51 +0400 - build 4155

1. Another correction of 4150.

2. Capability of setting hte list of codepages when switching with F8 in editor/viewer.
   far:config Editor.F8CPs
   far:config Viewer.F8CPs
   The default empty line leaves the old ANSI/OEM behavior.

drkns 22.10.2014 00:04:44 +0200 - build 4154

1. Correction of 4145.

w17 21.10.2014 15:02:24 +0400 - build 4153

1. Correction of correction of 4150.

w17 21.10.2014 14:25:48 +0400 - build 4152

1. Correction of 4150.

drkns 20.10.2014 21:17:09 +0200 - build 4151

1. #0002841: FAR freeze

w17 20.10.2014 14:12:09 +0400 - build 4150

1. File encoding change with reread in editor has to work via API.

2. On automatic recognition of file encoding in editor (ShiftF8)
   if the file contains only ASCII codes then the default codepage is substituted
   (or ACP if the default one is Unicode).

shmuel 20.10.2014 00:54:08 +0200 - build 4149

1. M#2838: Glitches on display after macro completion.

drkns 19.10.2014 08:47:14 +0200 - build 4148

1. Correction of 4145.

zg 19.10.2014 03:03:18 +0200 - build 4147

1. some useless code is removed.

zg 19.10.2014 02:28:21 +0200 - build 4146

1. again, tabulation and coloring problems in editor.

drkns 19.10.2014 00:25:12 +0200 - build 4145

1. Refactoring.

zg 19.10.2014 00:10:02 +0200 - build 4144

1. correction of 4141.

2. an old bug, ECTL_GETINFO called from EE_REDRAW returned incorrect LeftPos.

svs 18.10.2014 11:00:19 +0400 - build 4143

1. SQLite 3.8.7

w17 18.10.2014 06:15:54 +0300 - build 4142

1. correction of 4135

zg 18.10.2014 02:39:46 +0200 - build 4141

1. 0002835: Glitches if the content is shifted to the left.

drkns 17.10.2014 23:22:14 +0200 - build 4140

1. #0002839: Incorrectly associated names of attributes

zg 17.10.2014 14:01:23 +0200 - build 4139

1. correction of 4137.

zg 17.10.2014 04:06:40 +0200 - build 4138

1. ACTL_GETWINDOWINFO returns all windows in current z-order.

zg 17.10.2014 03:27:45 +0200 - build 4137

1. correction of 4134: copy-paste is removed, all highlighting areas are actually deleted.

zg 17.10.2014 01:30:31 +0200 - build 4136

1. if an already opened file was being opened in editor from search then the qeuery was displayed incorrectly.

2. gcc warning.

w17 16.10.2014 02:20:55 +0300 - build 4135

1. M#2829: Empty screen in viewer wnhen the file is rewritten

shmuel 16.10.2014 00:05:23 +0200 - build 4134

1. ECF_AUTODELETE flag is added. If EditorControl(ECTL_ADDCOLOR) function has set the flag,
   then the added highlighting region will be deleted by FAR automatically right before next
   EE_REDRAW event sent to plugins.

drkns 14.10.2014 22:24:10 +0200 - build 4133

1. Incorrect error code displayed on tree3.far writing failure.

drkns 13.10.2014 19:25:09 +0200 - build 4132

1. Forum: "Starting from 4062, the performance of regular expressions execution has decreased significantly."

drkns 11.10.2014 19:53:46 +0200 - build 4131

1. #0002827: The size of groups list does not decrease after deletion of file highlighting groups

2. Attribures in panels, dialogs, search results and filter menu follow now in the same order.

3. Configuration of search result columns worked incorrectly.

4. Refactoring.

drkns 09.10.2014 01:53:12 +0200 - build 4130

1. Correction of 4129.

2. Remove unused code.

drkns 08.10.2014 19:55:41 +0200 - build 4129

1. #0002781: Exception under VS2013 debugger

2. GCC warnings.

drkns 08.10.2014 09:50:10 +0200 - build 4128

1. #0002824: Assertion: list iterator not decrementable

drkns 01.10.2014 20:07:16 +0200 - build 4127

1. Another couple of corrections in Message.

2. Refactoring.

drkns 30.09.2014 23:55:34 +0200 - build 4126

1. Continuation of 4125.

2. Correction of 4122.1.

drkns 30.09.2014 21:08:57 +0200 - build 4125

1. 0002811: Broken Message with FMSG_ALLINONE flag

drkns 29.09.2014 21:27:31 +0200 - build 4124

1. Correction of 4122.1

drkns 29.09.2014 14:09:13 +0200 - build 4123

1. Flags support is added to external DialogBuilder.

drkns 27.09.2014 15:33:27 +0200 - build 4122

1. Support for additional buttons is added to external DialogBuilder.

2. Support for lists is added to internal DialogBuilder.

drkns 27.09.2014 14:25:43 +0200 - build 4121

1. Continuation of 4120.

drkns 26.09.2014 19:23:14 +0200 - build 4120

1. Refactoring of Message: separate lines from buttons.

drkns 22.09.2014 19:59:11 +0200 - build 4119

1. Forum: Broken addition of a file from a panel to the command line if autocompletion is active in the command line.

drkns 22.09.2014 19:21:31 +0200 - build 4118

1. #0002804: PN_CHECKMASK does not recognize incorrect regular expressions in 3.0.4117

drkns 21.09.2014 15:58:34 +0200 - build 4117

1. Optimization of make_vector.

zg 21.09.2014 13:35:14 +0200 - build 4116

1. correction of 4109.2: crash on viewer open if there was info panel opened in panels on a folder
   with no description, or a quick view for a folder.

drkns 21.09.2014 11:46:25 +0200 - build 4115

1. Macros for emulation of variadic templates are placed separately, improved and used instead of manual copy-pasting everywhere it is needed.

drkns 20.09.2014 21:26:14 +0200 - build 4114

1. Continuation of 4112.

drkns 20.09.2014 17:53:05 +0200 - build 4113

1. VC10 fix.

drkns 20.09.2014 17:14:32 +0200 - build 4112

1. Correction of 4111.

2. Incorrect error position on regexp compilation.

3. Show text and position of regexp compilation error.

drkns 20.09.2014 17:00:20 +0200 - build 4111

1. Named groups in regular expressions. Library level yet.

drkns 19.09.2014 23:47:55 +0200 - build 4110

1. Split common.hpp to components.

2. Build failure in gcc 4.8.1.

zg 19.09.2014 02:15:54 +0200 - build 4109

1. VE_CLOSE is sent to quick view and info panel before the viewer is deleted.

2. viewer and editor are not deleted during processing of all events.

3. events from inactive editors and viewers could be lost before been received by plugins.

drkns 19.09.2014 01:29:27 +0200 - build 4108

1. Somewhere between 4008 and 4012 the regular expressions were slightly broken.

drkns 16.09.2014 23:49:54 +0200 - build 4107

1. Refactoring.

drkns 14.09.2014 18:38:33 +0200 - build 4106

1. Asynchronous DB service thread handles were not closed in time and could accumulate endlessly.

drkns 14.09.2014 14:42:05 +0200 - build 4105

1. Refactoring.

drkns 14.09.2014 10:47:27 +0200 - build 4104

1. Correction of 4100.

drkns 14.09.2014 02:11:01 +0200 - build 4103

1. Correction of 4101.

zg 14.09.2014 01:46:47 +0200 - build 4102

1. correction of 4100: double DialogRun call.

2. on file reopen in editor, a window was deleted from the window manager which had not been added there previously.

drkns 14.09.2014 00:44:51 +0200 - build 4101

1. Correction of 4100.

drkns 13.09.2014 22:50:49 +0200 - build 4100

1. Memory was not freed after unsuccessful switching from editor to viewer.
   There is no sense in adding another hack, so the window owner logic is redone.
   Now there is no windows on stack, no windows deleted by the manager, no manual setting of deletion method,
   no manual checking for creation success, no manual deletion on failures etc.
   Each window is a smart pointer and lives as long as needed.
   Bizarre bugs are possible as usual.

drkns 12.09.2014 00:57:26 +0200 - build 4099

1. Support for FILE_ATTRIBUTE_INTEGRITY_STREAM and FILE_ATTRIBUTE_NO_SCRUB_DATA attributes.

zg 11.09.2014 00:27:32 +0200 - build 4098

1. ViewerControl did not work for QuickView and Info panels if the real ViewerID was given.

2. correction of processing of VCTL_REDRAW and ECTL_REDRAW.

drkns 11.09.2014 00:07:10 +0200 - build 4097

1. All functions provided to plugins are marked as noexcept and wrapped into try/catch,
   because throwing exceptions outside does not lead to anything good.

2. A couple of issues.

drkns 09.09.2014 21:16:03 +0200 - build 4096

1. Correction of 4096.

drkns 09.09.2014 18:04:46 +0200 - build 4095

1. Correction of 4072.1.

zg 09.09.2014 00:56:39 +0200 - build 4094

1. fix for editor coloring problems when the left coordinate is not zero.

zg 08.09.2014 19:55:01 +0200 - build 4093

1. correction of 4090.

2. double check of modality is removed.

zg 08.09.2014 15:12:38 +0200 - build 4092

1. forum: EE_CLOSE is not generated on F6 in the editor.

2. correction of 4091 for the clock.

3. refactoring.

zg 08.09.2014 13:10:44 +0200 - build 4091

1. when a window is redrawn, all windows above are also redrawn.

zg 07.09.2014 23:51:48 +0200 - build 4090

1. FAR crash on ACTL_SETCURRENTWINDOW call from plugins menu without consequent ACTL_COMMIT.

zg 07.09.2014 22:53:05 +0200 - build 4089

1. forbiddance of starting a non-modal editor/viewer applies not only modal editor/viewer,
   but also any modal window.

zg 05.09.2014 12:17:12 +0200 - build 4088

1. correction of 4083 for ACTL_GETWINDOWINFO.

zg 05.09.2014 01:51:10 +0200 - build 4087

1. check for repeated adding of a window to the window manager.

zg 04.09.2014 23:56:47 +0200 - build 4086

1. correction of 4083: incorrect handling of f6 in editor/viewer.

zg 04.09.2014 23:49:46 +0200 - build 4085

1. the current editor/viewer is now detected dynamically.

zg 04.09.2014 12:52:38 +0200 - build 4084

1. all pure modal windows must now be inherited from Modal class.

2. correction of z-order for modal windows.

3. a typo.

zg 04.09.2014 04:07:18 +0200 - build 4083

1. non-modal windows have z-order now.

zg 03.09.2014 23:18:26 +0200 - build 4082

1. correction of 4061.1.

drkns 03.09.2014 21:57:15 +0200 - build 4081

1. A couple of issues.

shmuel 03.09.2014 16:14:57 +0200 - build 4080

1. Continuation of 4077.

shmuel 03.09.2014 12:14:17 +0200 - build 4079

1. Refactoring of 4077.

drkns 03.09.2014 09:45:11 +0200 - build 4078

1. Correction of 4076.

shmuel 03.09.2014 01:22:09 +0200 - build 4077

1. M#2705: Far.GetConfig (replaces Far.Cfg_Get).

drkns 03.09.2014 00:57:03 +0200 - build 4076

1. Checks for copying upper than root are removed. Now this situation is treated as copying to the root. As a consequence:

2. 0002784: Crash on manual input of network folder address for copying.

3. Correction of path root extraction logic. It seems to be corrected everywhere, but there may be surprises.

drkns 02.09.2014 09:20:13 +0200 - build 4075

1. Correction of 4072.1.

zg 01.09.2014 15:56:02 +0200 - build 4074

1. 0002786: Freeze on Far Manager close if some edited files have left opened.

2. unnecessary volatile is removed.

drkns 31.08.2014 17:22:50 +0200 - build 4073

1. 0002785: Crash on attempt to call the archive creation dialog (shift+F1)

2. Refactoring.

drkns 30.08.2014 20:27:40 +0200 - build 4072

1. Refactoring.

2. Forum: the filename in viewer caption line is displayed without the full path.

3. Forum: cannot return to the end of the list with Ctrl-Shift-Tab.

4. Folder tree processed F5 incorrectly.

drkns 30.08.2014 14:02:22 +0200 - build 4071

1. Continuing renamings: Frame is window now, because it actually is.

2. Refactoring.

3. 0002781: Exception under the VS2013 debugger

drkns 27.08.2014 22:20:03 +0200 - build 4070

1. Access rights getting/setting errors can now be skipped while copying.

2. On transcoding errors the editor was trying to reload a yet inexisting file.

3. Refactoring.

shmuel 27.08.2014 21:21:19 +0200 - build 4069

1. Continuation of 4068.

shmuel 26.08.2014 21:08:48 +0200 - build 4068

1. MCTL_LOADALL supports explicit definition of paths for macro files loading.

drkns 25.08.2014 00:30:14 +0200 - build 4067

1. Correction of 4064.

drkns 24.08.2014 18:51:17 +0200 - build 4066

1. Refactoring.

drkns 23.08.2014 22:57:24 +0200 - build 4065

1. Mistype in 3542 which lead to invisibility of directories ".?" under some circumstances.

2. clang warning.

drkns 23.08.2014 17:09:59 +0200 - build 4064

1. A big pack of renamings: get rid of name collisions and related warnings from analyzers and VS 14.

svs 21.08.2014 15:07:45 +0400 - build 4063

1. SQLite 3.8.6

drkns 21.08.2014 02:09:09 +0200 - build 4062

1. As it turned out, the current regex implementation is not thread safe.
   As a consequence, it could crash in a bizarre way if something was done during the search. Especially in debug.
   Trying to fix.

zg 21.08.2014 01:26:03 +0200 - build 4061

1. Launch of modal windows is redone.

2. viewer is not removed during VE_GOTFOCUS/VE_KILLFOCUS processing.

drkns 21.08.2014 00:45:30 +0200 - build 4060

1. Remove some misconception from help.?pp.

2. Add some asserts and const-ness.

2. Other refactoring.

zg 19.08.2014 22:40:41 +0200 - build 4059

1. simplify setting the current macro area.

zg 18.08.2014 20:22:56 +0200 - build 4058

1. correction of 4011: regexp search crashed on (?=pattern) and (?!pattern).

zg 18.08.2014 19:26:05 +0200 - build 4057

1. correction of 4053: when an incorrect (missing in the name) character is typed after a few correct characters 
   then the fast search line is cleared.

zg 17.08.2014 23:36:15 +0200 - build 4056

1. crash on drawing the shadow of a dialog beyond the screen limits.

drkns 17.08.2014 21:15:50 +0200 - build 4055

1. The support for elevation getting the amount of full/free volume size.

drkns 17.08.2014 00:53:51 +0200 - build 4054

1. Correction of 4052.

zg 16.08.2014 22:08:40 +0200 - build 4053

1. fast search in panels - the real window.

drkns 16.08.2014 20:39:09 +0200 - build 4052

1. Move the processing of unnecessary keys out of the window manager.

drkns 16.08.2014 15:31:44 +0200 - build 4051

1. 0002763: Buffer scrolling function does not work with Numpad keys

drkns 16.08.2014 15:25:55 +0200 - build 4050

1. 0002765: "functional key bar" is hidden in panels but shown on Ctrl-Alt-Shift.

drkns 16.08.2014 15:16:54 +0200 - build 4049

1. 0002766: search does not work if a comma exists in the folder name.

drkns 16.08.2014 15:00:36 +0200 - build 4048

1. Forum: a plugin exports a file via GetFiles on F4 key press but the file is not imported back after file save and exit from editor.

drkns 16.08.2014 14:49:31 +0200 - build 4047

1. 0002768: Quick view – wrong plugin area

drkns 16.08.2014 01:21:40 +0200 - build 4046

1. Refactoring.

zg 12.08.2014 01:30:09 +0200 - build 4045

1. forum: MCTL_GETAREA in horizontal menu returns now MACROAREA_OTHER (instead of MACROAREA_MAINMENU).

2. refactoring.

drkns 11.08.2014 23:51:38 +0200 - build 4044

1. In /e and /v modes plugins got control before full initialization of the manager.

drkns 11.08.2014 20:24:09 +0200 - build 4043

1. Continuation of 4039.

drkns 10.08.2014 19:54:12 +0200 - build 4042

1. Continuation of 4040.

drkns 10.08.2014 11:18:55 +0200 - build 4041

1. Continuation of 4039 and 4040.

drkns 10.08.2014 00:47:12 +0200 - build 4040

1. Refactoring.

drkns 09.08.2014 17:31:49 +0200 - build 4039

1. Going on with the window system.
   Now the userscreen visible under panels is the separate window.

2. Refactoring.

drkns 06.08.2014 18:59:06 +0200 - build 4038

1. Correction of 4036.

drkns 06.08.2014 09:01:30 +0200 - build 4037

1. Forum: In 4036 the commands disappeared from screen which were invoked from the command line

drkns 05.08.2014 22:59:59 +0200 - build 4036

1. Refactoring.

drkns 04.08.2014 19:57:16 +0200 - build 4035

1. More thorough error processing when starting a supplementary process with Elevation.

2. If the attributes dialog is shown for a drive letter then show the corresponding volume name.

drkns 02.08.2014 14:47:23 +0200 - build 4034

1. Information on DFS resources was not always displayed correctly.

drkns 01.08.2014 21:36:24 +0200 - build 4033

1. 0002445: Copying of encrypted (EFS) files

drkns 31.07.2014 22:45:46 +0200 - build 4032

1. Cppcheck warnings.

drkns 31.07.2014 00:18:41 +0200 - build 4031

1. More Clang.

drkns 30.07.2014 21:07:46 +0200 - build 4030

1. Correction of 4018.2.

drkns 29.07.2014 21:22:25 +0200 - build 4029

1. The first attempt of compilation with Clang. Of course it failed, but something revealed:
   - a couple of silly bugs in editor;
   - unused variables;
   - viewer search tried to replace \xffff with \0 in searched text for some reason.

2. A couple of minor issues.

drkns 26.07.2014 15:29:52 +0200 - build 4028

1. For the sake of abstract perfectness, compiling hook_wow64 as C++.

drkns 25.07.2014 23:09:46 +0200 - build 4027

1. Refactoring.

zg 25.07.2014 13:55:39 +0200 - build 4026

1. correction of 4025 for ACTL_GETWINDOWTYPE.

2. correction of 4025 for the editor.

zg 25.07.2014 12:40:09 +0200 - build 4025

1. correction of 3981.

drkns 24.07.2014 23:19:41 +0200 - build 4024

1. On codepage detection, Unicode is selected only if the text is definitely unlike ASCII.
   This must decrease the number of false detections of Unicode (and thus increase the number of false detections of ASCII).

zg 24.07.2014 12:53:54 +0200 - build 4023

1. correction of 4020: activation of the last item in the horizontal menu with shift-f10 and activation of the menu with the mouse did not work.

zg 24.07.2014 01:40:17 +0200 - build 4022

1. correction of 4020: do not show window list in the horizontal menu and the grabber.

zg 24.07.2014 00:20:25 +0200 - build 4021

1. unused code removed in window manager.

zg 23.07.2014 23:11:32 +0200 - build 4020

1. the horizontal menu and the grabber are now real windows.

2. Close the grabber on console resize insted of crashing.

3. gcc warning.

drkns 23.07.2014 19:55:47 +0200 - build 4019

1. Built-in copy function buffer size is now 32 K instead of 64.

drkns 23.07.2014 03:30:09 +0200 - build 4018

1. Correction of 3978.

2. Weird autobinding of hotkeys in menu. Could have missed something.

drkns 22.07.2014 23:18:52 +0200 - build 4017

1. Continuation of 4015:
   - restore attempts of stack overflow handling.

drkns 22.07.2014 20:15:47 +0200 - build 4016

1. 0002741: ECTL_CLEARSESSIONBOOKMARKS causes a crash

drkns 22.07.2014 01:04:14 +0200 - build 4015

1. Exception mix:
   - handle std::exception when calling plugins
   - invoking the debugger worked incorrectly
   - refactoring

drkns 21.07.2014 21:28:10 +0200 - build 4014

1. One more homemade linked list down.

svs 21.07.2014 11:49:01 +0400 - build 4013

1. Mantis#0002743: ECTL_SETTITLE lacks matching ECTL_GETTITLE
     ECTL_GETTITLE
     Get editor caption.
     Param1 - buffer size in characters, allocated by the plugin for the data.
     Param2 points to a buffer allocated by the plugin for the editor caption.
     The function returns required buffer size in characters, including trailing zero.
     If Param2 = NULL, or Param1 is less than the required size, the function just returns the required size. 

zg 20.07.2014 23:32:48 +0200 - build 4012

1. correction of 4003.

drkns 20.07.2014 21:59:46 +0200 - build 4011

1. Refactoring.

drkns 19.07.2014 20:04:59 +0200 - build 4010

1. Refactoring.

drkns 19.07.2014 13:01:14 +0200 - build 4009

1. Correction of std::make_unique emulation: parameters were passed by value.

zg 18.07.2014 01:59:14 +0200 - build 4008

1. correction of 4006.

drkns 18.07.2014 01:49:25 +0200 - build 4007

1. Obtaining of bookmarks did not work in editor. For a long time already.

zg 18.07.2014 01:06:52 +0200 - build 4006

1. on editor close inside EE_READ event, the editor is deleted only after this event processing finished.

2. on viewer close inside EE_READ event, the viewer is deleted only after this event processing finished.

zg 17.07.2014 02:44:33 +0200 - build 4005

1. 0002734: Dialogs broken.
   an ancient bug is revealed: on inactive window close the active window disappears.

2. editor and viewer could corrupt the memory under certain conditions.

shmuel 16.07.2014 18:15:38 +0200 - build 4004

1. Addition to LuaMacro plugin's access to the screen buffer.

zg 16.07.2014 01:13:27 +0200 - build 4003

1. forum: incorrect console caption when calling the macrobrowser via Plugin.Menu.

zg 15.07.2014 21:39:44 +0200 - build 4002

1. forum: crash in ACTL_GETWINDOWINFO.

shmuel 14.07.2014 20:56:15 +0200 - build 4001

1. Plugin.Menu(), Plugin.Config() and Plugin.Command() return false on failure.

drkns 14.07.2014 14:39:33 +0200 - build 4000

1. 0002709: Query for administrator privileges may be invisible if called from a macro

zg 13.07.2014 14:50:01 +0200 - build 3999

1. correction of 3992: dialogs were shown onlyl one time after creation.

drkns 13.07.2014 14:24:22 +0200 - build 3998

1. Interface.FormatNumberSeparators option now has string type.

2. SmallerTypeCheck is switched on in debug build.

3. Refactoring.

drkns 12.07.2014 20:33:45 +0200 - build 3997

1. Correction of 3996 and a couple of issues.

drkns 12.07.2014 14:18:49 +0200 - build 3996

1. /set:<parameter>=<value> option is added which allows for redefinition of main settings (see far:config).

drkns 12.07.2014 09:45:28 +0200

1. Support for lists in external DialogBuilder.

zg 11.07.2014 22:11:38 +0200 - build 3995

1. correction of 3993: EE_READ was not called in viewer if it was opened with +/-.

zg 11.07.2014 19:21:21 +0200 - build 3994

1. correction of 3981 for the horizontal menu.

zg 10.07.2014 22:54:11 +0200 - build 3993

1. VE_READ is called when the viewport is fully constructed.

zg 10.07.2014 20:54:25 +0200 - build 3992

1. correction of 3981.

zg 10.07.2014 15:49:53 +0200 - build 3991

1. correction of 3985: ECTL_GETINFO and ECTL_GETBOOKMARKS did not work in EE_CLOSE.

zg 10.07.2014 13:54:25 +0200 - build 3990

1. on file reopen in editor a wrong frame could be closed. even panels could.

drkns 10.07.2014 09:14:35 +0200 - build 3989

1. An ancient bug, which revealed itself in recent crashes on exit:
   - do not close handles awaited by WaitForMultipleObjects.

zg 10.07.2014 03:05:00 +0200 - build 3988

1. correction of 3981: /v key did not work.

2. correction of 3986: crash on exit.

drkns 09.07.2014 22:10:05 +0200 - build 3987

1. Refactoring.

zg 09.07.2014 21:38:08 +0200 - build 3986

1. Rare crash during reopening a file in editor.

2. Sequential opening/closing of editor via API could hang.

3. correction of 3981.

zg 09.07.2014 15:36:33 +0200 - build 3985

1. forum: "ACTL_GETWINDOWTYPE and ACTL_GETWINDOWINFO don't work when called from EE_CLOSE/VE_CLOSE".

zg 09.07.2014 12:47:11 +0200 - build 3984

1. correction of 3981: sometimes on windows close other unexpected windows were activated.

drkns 09.07.2014 00:54:24 +0200 - build 3983

1. Refactoring.

zg 08.07.2014 21:06:45 +0200 - build 3982

1. correction of 3981.

zg 08.07.2014 13:53:39 +0200 - build 3981

1. refactoring of window manager. now there is a common queue for messages.
   with the queue now one can run any code asynchronously.
   an example can be found in implementation of EE_READ.

svs 07.07.2014 13:58:08 +0400 - build 3980

1. EMenu was always called with OPEN_LEFTDISKMENU

drkns 06.07.2014 15:24:29 +0200 - build 3979

1. Refactoring.

drkns 04.07.2014 22:46:04 +0200 - build 3978

1. Inner utf8 -> utf16 convertor processed 4-byte characters incorrectly.

drkns 03.07.2014 19:16:23 +0200 - build 3977

1. Correction of 3869.

drkns 03.07.2014 00:19:44 +0200 - build 3976

1. Support for combined lists in DialogBuilder.

drkns 02.07.2014 23:55:43 +0200 - build 3975

1. Interface of Thread class is brought slightly closer to standard: now it accepts anything, not only uint(void*).

drkns 01.07.2014 19:49:09 +0200 - build 3974

1. Continuation of 3970, a couple of issues.

drkns 01.07.2014 15:43:01 +0200 - build 3973

1. Continuation of 3970. Initialization of imports on demand.

drkns 01.07.2014 12:29:19 +0200 - build 3972

1. Continuation of 3970.

drkns 01.07.2014 00:43:59 +0200 - build 3971

1. VS14 presumes that %s is char* which is technically correct but breaks everything.
   A good reason for wiping *printf, and for now let's define _CRT_STDIO_LEGACY_WIDE_SPECIFIERS.

drkns 30.06.2014 19:07:38 +0200 - build 3970

1. Refactoring.

drkns 29.06.2014 19:09:47 +0200 - build 3969

1. Refactoring.

2. Removed unused code from tvar.?pp.

zg 29.06.2014 16:27:02 +0200 - build 3968

1. 0002723: ECTL_GETINFO does not work when invoking an editor from an editor

drkns 28.06.2014 02:43:22 +0200 - build 3967

1. Refactoring.

drkns 27.06.2014 19:53:08 +0200 - build 3966

1. Restore broken GCC build.

2. GCC warning.

3. Refactoring.

svs 26.06.2014 14:23:24 +0400 - build 3965

1. Mantis#0002692: No way to cancel an operation launched from a macro
   Rollback of build 3963 until better times. Bugs spotted.

w17 26.06.2014 00:16:21 +0400 - build 3964

1. Another correction of 3956.
   It still does not work via Plugin API.

2. M#2540: Viewer Search always starts from the beginning of the file
   INCOMPLETED!

svs 25.06.2014 11:17:19 +0400 - build 3963

1. Mantis#0002692: No way to cancel an operation launched from a macro
   Let's comment it and watch.

w17 25.06.2014 00:16:56 +0400 - build 3962

1. Correction of 3960.

drkns 24.06.2014 19:41:46 +0200 - build 3961

1. Correction of 3958.

w17 24.06.2014 20:02:53 +0400 - build 3960

1. M#2706: Errors not processed while converting to UTF-7

w17 23.06.2014 14:41:05 +0400 - build 3959

1. Correction of 3956.

drkns 21.06.2014 15:51:25 +0200 - build 3958

1. On launch via 'Far.exe /p%FARPROFILE%\Plugins' the plugins were not loaded.

drkns 20.06.2014 20:12:27 +0200 - build 3957

1. If the plugin panel contains items with FILE_ATTRIBUTE_REPARSE_POINT attributes, treat them as symlinks.

w17 20.06.2014 13:46:02 +0400 - build 3956

1. Experimental. M#2684: A possibility of changing the codepage on file reread

drkns 19.06.2014 09:33:50 +0200 - build 3955

1. A potential problem in SyncedQueue and a couple of fixes in Thread and MultiWaiter in order to improve readability.

drkns 19.06.2014 08:46:39 +0200 - build 3954

1. In 3842, launcher failed in some cases.

zg 18.06.2014 10:56:30 +0200 - build 3953

1. after 3895, alt-d did not work in editor.

w17 16.06.2014 23:43:57 +0400 - build 3952

1. M#2708: Regexp "^(.*?\-\-)" != "^(.*?\-{2})"

shmuel 10.06.2014 11:38:11 +0200 - build 3951

1. Correction of 3949.

shmuel 10.06.2014 00:45:54 +0200 - build 3950

1. When LuaMacro plugin was unloaded due to an exception the manual macro recording was not disabled immediately.

drkns 09.06.2014 22:12:24 +0200 - build 3949

1. Support for VS 14 (CTP), with warnings so far.

shmuel 08.06.2014 22:47:12 +0200 - build 3948

1. Refactoring.

svs 07.06.2014 11:16:01 +0400 - build 3947

1. SQLite 3.8.5

shmuel 06.06.2014 21:35:19 +0200 - build 3946

1. Refactoring.

drkns 06.06.2014 19:00:44 +0200 - build 3945

1. far:ver -> far:about

shmuel 06.06.2014 16:21:30 +0200 - build 3944

1. far /m disables initial loading of macros only, later the macros can be
   loaded in any possible manner.

w17 06.06.2014 12:37:17 +0400 - build 3943

1. ver -> far:ver

drkns 05.06.2014 20:51:49 +0200 - build 3942

1. Forum: error of autofilter creation, if the name of a file contains ,;

w17 05.06.2014 16:23:29 +0400 - build 3941

1. M#2250: Text in 1251 is not shown in an UTF8 file
   The codepage can be changed on file open, if the current codepage does not allow the file be shown without loss of information.

drkns 05.06.2014 01:06:34 +0200 - build 3940

1. FAR crash while deleting a custom panel view mode, if it was set on a passive panel.

2. Also, CtrlShiftEnter is added - set view mode of a passive panel.

drkns 04.06.2014 20:11:04 +0200 - build 3939

1. And more.

shmuel 04.06.2014 13:52:16 +0200 - build 3938

1. Correction of 3925.

drkns 03.06.2014 17:35:54 +0200 - build 3937

1. Another couple of bugs in 3934.

drkns 03.06.2014 09:15:51 +0200 - build 3936

1. A couple of bugs in 3934.

drkns 03.06.2014 03:21:08 +0200 - build 3935

1. GCC.

drkns 03.06.2014 02:42:03 +0200 - build 3934

1. Random refactoring.

2. Far processes 'ver' command showing its own version, versions of used libraries and installed plugins.

drkns 03.06.2014 02:16:43 +0200 - build 3933

1. 0002687: Codepages menu: --Other-- separator disappears

shmuel 02.06.2014 18:15:07 +0200 - build 3932

1. Refactoring.

shmuel 02.06.2014 00:17:53 +0200 - build 3931

1. Refactoring.

shmuel 31.05.2014 17:30:49 +0200 - build 3930

1. Refactoring.

shmuel 30.05.2014 23:19:36 +0200 - build 3929

1. Correction of 3925.

shmuel 30.05.2014 21:32:26 +0200 - build 3928

1. Correction of 3925 (memory leak).

shmuel 29.05.2014 13:38:28 +0200 - build 3927

1. Correction of 3825 (DI_FIXEDIT).

shmuel 28.05.2014 16:10:23 +0200 - build 3926

1. Correction of 3925.

shmuel 28.05.2014 13:00:02 +0200 - build 3925

1. Experimental: M#2674: Return of the panel handle when working from a macro.

shmuel 26.05.2014 20:22:56 +0200 - build 3924

1. Completion of refactoring started in 3896.

shmuel 26.05.2014 18:44:24 +0200 - build 3923

1. Continuation of 3896.

shmuel 25.05.2014 21:13:55 +0200 - build 3922

1. Continuation of 3896.

shmuel 25.05.2014 18:15:52 +0200 - build 3921

1. Continuation of 3896.

w17 25.05.2014 10:20:35 +0400 - build 3920

1. Another correction of 3913
   MLF_HOLDTARGET flag is added to plugin.h

shmuel 24.05.2014 20:04:56 +0200 - build 3919

1. Fix for nested macros.

shmuel 24.05.2014 17:25:47 +0200 - build 3918

1. Continuation of 3896.

w17 24.05.2014 14:16:12 +0400 - build 3917

1. Correction of 3913

drkns 24.05.2014 12:11:56 +0200 - build 3916

1. "Fix" symlinks back so far.

drkns 24.05.2014 10:03:45 +0200 - build 3915

1. 0002686: Debug build crashes in editor

shmuel 23.05.2014 19:52:03 +0200 - build 3914

1. Continuation of 3896.

w17 23.05.2014 15:50:39 +0400 - build 3913

1. M#2675: Symlink is created only with an absolute path. There is no possibility of specifying a relative path

shmuel 23.05.2014 01:44:13 +0200 - build 3912

1. Continuation of 3896.

shmuel 21.05.2014 23:35:44 +0200 - build 3911

1. Continuation of 3896.

shmuel 21.05.2014 18:07:34 +0200 - build 3910

1. Continuation of 3896.

drkns 18.05.2014 17:19:57 +0200 - build 3909

1. Rollback of 3908.1 until better times.

drkns 18.05.2014 16:22:09 +0200 - build 3908

1. Refactoring. Move out of macro.hpp everything that we can get by without.

2. GCC warning.

shmuel 17.05.2014 23:58:06 +0200 - build 3907

1. Continuation of 3896.

drkns 17.05.2014 14:43:09 +0200 - build 3906

1. Crash after selection of black&white color scheme.

zg 16.05.2014 14:27:13 +0200 - build 3905

1. after 3895 selection keys did not work in the command line.

drkns 15.05.2014 23:57:23 +0200 - build 3904

1. The search can now figure out the appropriate codepage.

drkns 15.05.2014 01:45:08 +0200 - build 3903

1. Correction of unicode text detection.

shmuel 15.05.2014 00:13:09 +0200 - build 3902

1. Continuation of 3896.

shmuel 14.05.2014 01:10:59 +0200 - build 3901

1. Correction of 3896 (FAR crash under some circumstances).

shmuel 13.05.2014 17:28:47 +0200 - build 3900

1. In 3896 the Plugin.Call return value was broken.

shmuel 13.05.2014 00:33:38 +0200 - build 3899

1. Continuation of 3896.

shmuel 12.05.2014 16:14:04 +0200 - build 3898

1. In 3896 the Plugin.Menu return value was broken.

zg 12.05.2014 13:39:44 +0200 - build 3897

1. 0002672: Incorrect processing of the clipboard.
   if an empty string was inserted, the selection flag was set, meanwhile the selection itself wasn't.

shmuel 12.05.2014 13:05:51 +0200 - build 3896

1. Refactoring of macro system.

zg 09.05.2014 00:19:23 +0200 - build 3895

1. refactoring of ProcessKey.

svs 08.05.2014 20:34:04 +0400 - build 3894

1. Mantis#0002669: GUID for the menu of all occurrences

    EditorFindAllListId         = {9BD3E306-EFB8-4113-8405-E7BADE8F0A59}  --> Menu.Id
    Editor. List of all known occurrences (F7 <All>).

w17 08.05.2014 16:17:06 +0400 - build 3893

1. M#2667: FAR crash on "[A-Z\\]+" regexp

drkns 07.05.2014 00:00:37 +0200 - build 3892

1. Incorrect work of sorting by file extensions for files with ':' in names.

drkns 05.05.2014 19:03:55 +0200 - build 3891

1. Correction of 3890.

drkns 05.05.2014 18:52:24 +0200 - build 3890

1. "title" command added an excessive space to the caption.

svs 05.05.2014 16:48:11 +0400 - build 3889

1. Correction of build 3888
   1. Hide the panels.
   2. title[Enter] --> watch " - Far 3.0.3888 x86 Administrator" in caption, i.e. panel folder is not shown.

svs 05.05.2014 12:38:16 +0400 - build 3888

1. Mantis#0002523: 'title' command does not work with hodden panels

shmuel 04.05.2014 02:08:54 +0200 - build 3887

1. Rollback of 3885.

drkns 03.05.2014 19:13:31 +0200 - build 3886

1. Search by all codepages did not work in x64.

2. Codepages for search can be selected from the whole list.

3. Capability for search in files NOT containing the given text is added.

4. ADS search option moved to the main dialog.

5. CollectFiles hidden option is removed.

6. Refactoring.

shmuel 03.05.2014 17:51:18 +0200 - build 3885

1. Experimental:
   Before command line processing FAR passes it to LuaMacro plugin which calls global function
   ProcessFarCommandLine(CmdLine) if it exists. If it does not exist or if it returns
   false/nil/nothing then FAR continues command line processing. If a string is returned then FAR processes
   it as the new value of command line. If true is returned then further processing of command line by FAR is cancelled.

zg 02.05.2014 03:16:49 +0200 - build 3884

1. rollback of 3883.

zg 01.05.2014 12:28:01 +0200 - build 3883

1. 0002657: Incorrect functioning on change of the last line of a file from a plugin.

svs 28.04.2014 16:43:42 +0400 - build 3882

1. For Mantis#2562.
   - mixture of ECC_* and XC_* is removed
   - XC_ALREADY_EXISTS, XC_OPEN_NEWINSTANCE and XC_RELOAD are added.
   - in FileEditor, correction of return codes depending on EF_OPENMODE_*
   - in API::Editor, new return codes have not been introduced yet (the MANTIS_0002562 macro is the limitation);
     there is probability of broken plugins ("archive" ones) which accept only EEC_OPEN_ERROR, EEC_MODIFIED and EEC_NOT_MODIFIED.
     (although... EEC_LOADING_INTERRUPTED is already "functioning" :-))

svs 28.04.2014 15:11:54 +0400 - build 3881

1. Mantis#0002663: Far crash when a modal dialog is shown from VE_Read viewer event handler
     FileViewer::Init(...NamesList *ViewNamesList,..)
     {
     ...
     (1) if (!View.OpenFile(strName,TRUE))
     ...
         if (ViewNamesList)
     (2)    View.SetNamesList(*ViewNamesList);

     At (1), ViewNamesList is still alive. At (2) it is already dead.
     Crash follows (that's natural, because "Editor" object is already destroyed)

2. Crash for DI_*BOX with X1==X2==0 and existing caption.
   Information for console caption is taken from the corresponding dialog item, as usual,
   but the text of such an item is not shown.

shmuel 28.04.2014 00:58:52 +0200 - build 3880

1. Correction of build 3770:
   lua:far.Show(...) showed one argument (nil) instead of none.

shmuel 26.04.2014 17:43:33 +0200 - build 3879

1. Continuation of 3878, docs updated:
   -- "language" flags in FARKEYMACROFLAGS (MacroSendMacroText, MacroAddMacro, MacroExecuteString structures).
   -- commands lm:post2 and lm:check2 in LuaMacro plugin.

shmuel 25.04.2014 21:32:52 +0200 - build 3878

1. Support for MoonScript in plugins API (docs are not updated yet).

svs 23.04.2014 14:14:46 +0400 - build 3877

1. Attempt to leave a network share with .. to servers level invokes Emenu's context menu.
   http://forum.farmanager.com/viewtopic.php?p=118299#p118299

drkns 22.04.2014 22:16:51 +0200 - build 3876

1. Editor.FileSizeLimitHi parameter is removed.

2. GUIDs of luamacro, arclite, netbox moved to config.

svs 22.04.2014 18:52:29 +0400 - build 3875

1. Mantis#0002651: TechInfo #52: Saved???/HistoryCount

2. Crash if the size of System.ShowStatusInfo configuration string is less than the number of sections in InfoPanel

drkns 20.04.2014 17:14:22 +0200 - build 3874

1. Refactoring.

w17 19.04.2014 22:47:13 +0400 - build 3873

1. A bit more persistent persistent blocks in command line and dialog edit fields.

w17 18.04.2014 13:07:22 +0400 - build 3872

1. M#1465: Command line/dialog editors do not take plugin-made selection into account

drkns 18.04.2014 10:43:09 +0200 - build 3871

1. "Любимые кодовые страницы" -> "Избранные кодовые страницы".

drkns 17.04.2014 20:06:46 +0200 - build 3870

1. In 3868, virtual and subst drives detach confirmations were broken.

drkns 17.04.2014 19:24:04 +0200 - build 3869

1. More correct recognition of UTF8 / UTF16LE / UTF16BE.

svs 17.04.2014 11:00:21 +0400 - build 3868

1. GUIDs

    DisconnectDriveId           = {A1BDBEB1-2911-41FF-BC08-EEBC44040B50}  --> Dlg.Id
    Dialog "Disconnect network drive" (Del on a network drive in drive selection menu).

    SUBSTDisconnectDriveId      = {75554EEB-A3A7-45FD-9795-4A85887A75A0}  --> Dlg.Id
    Dialog "Substituted disk deletion"

    VHDDisconnectDriveId        = {629A8CA6-25C6-498C-B3DD-0E18D1CC0BCD}  --> Dlg.Id
    Dialog "Virtual disk detaching"

    ChangeDriveModeId           = {F87F9351-6A80-4872-BEEE-96EF80C809FB}  --> Dlg.Id
    Dialog "Change Drive Menu Options"


drkns 15.04.2014 22:31:59 +0200 - build 3867

1. Transition with +/- in viewer was broken in 3857.

svs 15.04.2014 12:37:20 +0400 - build 3866

1. Mantis#0002647: DM_SETFOCUS works incorrectly with presence of an item with DIF_NOFOCUS
    Before focus change, force DIF_FOCUS flag cleared for all items.

2. Mantis#0002608: Editor function: possiblility of the already loaded file is not always taken into account

    If the file is already opened, then repeated modal opening shows a message
    "already loaded. How to open this file?" with two buttons "{ New instance }" and "[ Cancel ]".
    API: from EF_OPENMODE_* modes, support only EF_OPENMODE_QUERY, EF_OPENMODE_NEWIFOPEN and
    EF_OPENMODE_BREAKIFOPEN (i.e. the buttons "New instance" and "Cancel").

    (partial solution so far)

3. GUIDs
    EditorReloadModalId         = {D6F557E8-7E89-4895-BD75-4D3F2C30E382}  --> Dlg.Id
    Editor. Warning dialog about repeated opening of already opened file in modal editor
    (for non-modal ones - GUID==EditorReloadId)

    EditorCanNotEditDirectoryId = {CCA2C4D0-8705-4FA1-9B10-C9E3C8F37A65}  --> Dlg.Id
    Editor. Warning on attempt of directory editing

    EditorFileLongId            = {E3AFCD2D-BDE5-4E92-82B6-87C6A7B78FB6}  --> Dlg.Id
    Editor. Warning on exceeding the size of the edited file (see Editor.FileSizeLimit and Editor.FileSizeLimitHi settings)

    EditorFileGetSizeErrorId    = {6AD4B317-C1ED-44C8-A76A-9146CA8AF984}  --> Dlg.Id
    Editor. Cannot get the size of the edited file (if Editor.FileSizeLimit and Editor.FileSizeLimitHi are set)


drkns 13.04.2014 12:41:13 +0200 - build 3865

1. Continuation of 0002645.

drkns 12.04.2014 19:15:45 +0200 - build 3864

1. Continuation of 0002645.

2. EditorF7Rules option is removed for consistency.

drkns 12.04.2014 14:26:37 +0200 - build 3863

1. 0002591: Time is not set in file attributes dialog.

drkns 12.04.2014 13:29:05 +0200 - build 3862

1. 0002645: Repeated search (ShiftF7) works incorrectly with "Cursor at end" option

2. 0002646: Repeated search (ShiftF7) moves the cursor if nothing is found

zg 11.04.2014 16:02:53 +0200 - build 3861

1. gcc warnings.

drkns 11.04.2014 08:32:40 +0200 - build 3860

1. Correction of 3859.1.

drkns 10.04.2014 22:20:10 +0200 - build 3859

1. The number of !?<title>?<init>! constructions in user menu is now unlimited.

2. Also, Ok and Cancel buttons have been added.

3. In some cases data were written beyond the bounds of a buffer in input fields.

drkns 10.04.2014 09:18:34 +0200 - build 3858

1. A typo in 3857.

drkns 09.04.2014 22:19:59 +0200 - build 3857

1. If during file/directory deletion process someone had deleted it earlier, do not show errors like "file not found", consider the job done.

2. In viewer opened from the rewrite dialog, transition on Add/Subtract works.

3. In editor, reverse search did not work for "Cursor at end".

4. Debug target did not build - DN_ACTIVATEAPP was not removed completely in 3856.

5. Refactoring.

zg 09.04.2014 17:49:08 +0200 - build 3856

1. DN_ACTIVATEAPP is removed. use DN_INPUT+FOCUS_EVENT instead.

svs 09.04.2014 09:11:50 +0400 - build 3855

1. Mantis#0001722: excessive DN_EDITCHANGE with false information

   Details:

   1. On dialog start "this" editor line has FEDITLINE_CLEARFLAG flag set (gray characters).
      At the moment of a character entered (insertion of clearing of an input field) FEDITLINE_CLEARFLAG is reset and
      the line is cleared. The dialog procedure coniders it as "PtrData point to an empty line".
      Next DN_EDITCHANGE is passed with the same data that have been entered.


   2. unchanged _technically_ is like a selected text, the difference is that information (DN_EDITCHANGE)
      on a deleted block for the selected text is not sent to the dialog procedure.


svs 07.04.2014 16:26:57 +0400 - build 3854

1. Mantis#0001470: Edit-box: "Unchanged" state appears after it has been reset already

2. Mantis#0001464: Edit-controls - reset 'unchanged', if the plugin changes the cursor position
   'Unchanged' state is now reset also for DM_SETSELECTION and DM_SETCURSORPOS.

3. DN_ACTIVATEAPP "publishing".
   DN_ACTIVATEAPP event (0x3FFF/16383) is passed to the dialog procedure when Far Manager console window becomes active ot inactive.
   Param1 = 1 - the window got input focus
            0 - the window became inactive
   Param2 = 0
   Return = 0

4. Publishing some "ancient" flags from EDITOR_FLAGS (EF_OPENMODE_*)
    EF_OPENMODE_MASK         = 0x00000000F0000000ULL,
      Mask for EF_OPENMODE_*
    EF_OPENMODE_QUERY        = 0x0000000000000000ULL,
      Query user in case of the file open in editor
    EF_OPENMODE_NEWIFOPEN    = 0x0000000010000000ULL,
      Open the file in a new editor if it is already open
    EF_OPENMODE_USEEXISTING  = 0x0000000020000000ULL,
      Switch to a file opened in the editor
    EF_OPENMODE_BREAKIFOPEN  = 0x0000000030000000ULL,
      Cancel the file opening operation if it is opened in an editor
    EF_OPENMODE_RELOADIFOPEN = 0x0000000040000000ULL,
      Reopen the file if it is already opened in an editor.

   fileedit.hpp::FEOPMODEEXISTFILE are removed, EDITOR_FLAGS are used instead.


svs 07.04.2014 11:56:50 +0400 - build 3853

1. Mantis#0002641: Panel with buttons is not updated during search
   DMODE_NEEDUPDATE flag is added - "update the whole dialog instead of a specific item when it is possible".

   The solution closes the ticket.
   To get rid of the kludge the core has to be "slightly" changed...
   ...to introduce a message queue (for example, Frame: std::vector<Message*> MsgQueue) with consequences.

2. Bug: Incorrect drawing of search results dialog (Alt-F7) on console size change.
   'Bottom' coordinate of dialog items did not change.

drkns 05.04.2014 12:56:05 +0200 - build 3852

1. M#2639:  When starting smth from a panel (with the empty command line), command aliases must not apply

2. In 3819 mouse wheel control of the panel cursor was broken.

svs 04.04.2014 16:50:40 +0400 - build 3851

1. Mantis#0002615: A method of identification of drop-down history lists is needed

   One GUID for all histories in edit fields:

    SelectFromEditHistoryId  = {4406C688-209F-4378-8B7B-465BF16205FF}  --> Dlg.Id

w17 04.04.2014 16:07:24 +0400 - build 3850

1. M#2637: broken sorting by file creation date in panels

svs 04.04.2014 11:39:31 +0400 - build 3849

1. SQLite 3.8.4.3

drkns 04.04.2014 00:30:15 +0200 - build 3848

1. Refactoring.

svs 03.04.2014 21:49:06 +0400 - build 3847

1. Mantis#0001301: Errors in processing DM_LISTUPDATE, DN_LISTCHANGE

   Processing of position changes in lists moved to VMenu class (DN_LISTHOTKEY and DN_LISTCHANGE)

   This is how it looks for hotkeys now:
   if(DN_LISTHOTKEY)
    if(DN_LISTCHANGE)
      changing the position

   Catching bugs :-)

drkns 30.03.2014 12:21:55 +0200 - build 3846

1. 0002628: Warning with incomprehensible choices

2. In 3843 keyboard control of combo boxes was broken.

drkns 29.03.2014 20:20:06 +0200 - build 3845

1. M#0002631: Buffer overflow displaying a file at the window and line width > 512 characters.

2. The new version of the universal charset detector.

3. Refactoring.

svs 27.03.2014 10:14:07 +0400 - build 3844

1. SQLite 3.8.4.2

svs 27.03.2014 09:09:23 +0400 - build 3843

1. Mantis#0001301: Errors on processing DM_LISTUPDATE, DN_LISTCHANGE

   DN_LISTCHANGE - docs contained incorrect description of the event (copy-paste from DN_EDITCHANGE).
   DI_LISTBOX missed the return of cursor position to its previous state if the dialog procedure returned 0.
   In DI_COMBOBOX - separate processing (vmenu.cpp), sending DN_LISTCHANGE message (and reacting on it) after displaying;
     in VMenu class, the presence of the "owner" (dialog) and a combo box (VMENU_COMBOBOX) was not taken into account when displaying.

drkns 23.03.2014 21:51:18 +0200 - build 3842

1. Refactoring.

shmuel 22.03.2014 21:27:21 +0200 - build 3841

1. Correction of 3838 (DM_GETDIALOGTITLE).

drkns 21.03.2014 20:28:49 +0200 - build 3840

1. Moving DN_DRAWDLGITEMDONE to a correct place.

svs 21.03.2014 16:28:10 +0400 - build 3839

1. Correction of DN_DRAWDLGITEMDONE
   The scheme is following:
      1. Drawing the whole dialog:
          DN_DRAWDIALOG
          DN_CTLCOLORDIALOG
          CountItem times {
            DN_DRAWDLGITEM
            DN_CTLCOLORDLGLIST
            DN_DRAWDLGITEMDONE
          }
          DN_DRAWDIALOGDONE

      2. Drawing a single item:
          DN_DRAWDLGITEM
          DN_CTLCOLORDLGLIST
          DN_DRAWDLGITEMDONE

2. Mantis#2511: ACTL_GETWINDOWINFO freezes on call for a dialog is another dialog has been present recently
   (from NightRoman)

svs 21.03.2014 13:59:21 +0400 - build 3838

1. Dialog API. Addition:

    DM_GETDIALOGTITLE message (67) allows to get the caption of the dialog.
      Param1 = 0
      Param2 = Pointer to FarDialogItemData structure
      Return = The size of the caption in characters, without trailing '\0'

    Far takes data for the dialog caption (including the caption of the console window) from
    the first 'text' (like DI_TEXT, DI_DOUBLEBOX, DI_SINGLEBOX items)
    or "list" (like DI_LISTBOX) available.
    If the dialog items array lacks at least one of these items then the caption is empty.


2. Dialog API. Addition:

    DN_DRAWDLGITEMDONE event (68) is sent at the end of dialog item drawing (pair DN_DRAWDLGITEM).
      Param1 = ID
      Param2 = 0
      Return = 0

    Earlier, DN_DRAWDIALOGDONE was always send to signal of the end of a single item redraw
    (the same as for drawing the whole dialog).

    Now:
      1. Drawing the whole dialog:
          DN_DRAWDIALOG
          DN_CTLCOLORDIALOG
          CountItem times {
            DN_DRAWDLGITEM
            DN_CTLCOLORDLGLIST
          }
          DN_DRAWDIALOGDONE

      2. Drawing a single item:
          DN_DRAWDLGITEM
          DN_CTLCOLORDLGLIST
          DN_DRAWDLGITEMDONE


3. Mantis#0002586: Events: there's no possibility to handle a combo box opening

   Dialog API. Addition:

   DN_DROPDOWNOPENED event (4119) is sent before Combobox or History open and after them close.
      Param1 = ID
      Param2 = 1 - opened, 0 - closed
      Return = 0

   Perhaps the correction of the place of call is necessary here.


svs 19.03.2014 16:17:34 +0400 - build 3837

1. Mantis#0000327: [X] Save bookmarks does not work without [X] Save file position

   The options have become independent, although:

   The variant without history.db redone.
   Now tables editorposition_history/viewerbookmarks_history depend on
   editorposition_history/viewerposition_history (the latter ones contain the filename).

   A record is made in editorposition_history/viewerposition_history if
   "save position" OR "save bookmark" are set.
   If "save bookmark" is set but "save position" is not, then the tables
   editorposition_history/viewerposition_history get zeros as information about position.

2. Makeup (UCase) for GUID

svs 18.03.2014 15:20:34 +0400 - build 3836

1. GUID for the login and password duery dialog.

    GetNameAndPasswordId  = {CD2AC546-9E4F-4445-A258-AB5F7A7800E0}  --> Dlg.Id

    It is shown (optionally) on opening a mapped volume from the drive selection menu.

2. Corrections in SysLog and some logging in dialogs.

3. <ACHTUNG!>

   DMODE_DRAWING dialog flag was cleared before sending DN_DRAWDIALOGDONE, in some cases it caused
   an endless loop in dialog drawing operation (with stack overflow and subsequent FAR crash).

   Clearing of DMODE_DRAWING flag moved to the end of DMODE_DRAWING Dialog::ShowDialog().

   </ACHTUNG!>


svs 14.03.2014 12:20:09 +0400 - build 3835

1. Mantis#0002613: GUIDs needed for drives and associations menu

    EditorSwitchUnicodeCPDisabledId = {15568DC5-4D6B-4c60-B43D-2040EE39871A} --> Dlg.Id
       "Unicode codepage switch is not supported" message
       It is shown on attempt of changing the codepage while editing an Unicode file (for example, codepage 1200).

2. Mantis#0002570: Processing of an incorrect value in the settings dialog
   DlgBuilder is provided with unsigned int values processing capability.

svs 13.03.2014 20:13:49 +0400 - build 3834

1. Mantis#0002613: GUIDs needed for drives and associations menu

    ChangeDiskMenuId      = {252CE4A3-C415-4b19-956B-83E2FDD85960}  --> Menu.Id
       Drive selection menu

    FileAssocMenuId       = {F6D2437C-FEDC-4075-AA56-275666FC8979}  --> Menu.Id
       Associations editing menu
    SelectAssocMenuId     = {D2BCB5A5-6B82-4eb5-B321-1AE7607A6236}  --> Menu.Id
       Associations list menu
    FileAssocModifyId     = {6F245B1A-47D9-41a6-AF3F-FA2C8DBEEBD0}  --> Dlg.Id
       Current association editing menu

drkns 13.03.2014 11:55:36 +0200 - build 3833

1. After 3819 the logical binding of the dialog items did not work.

zg 13.03.2014 02:20:45 +0200 - build 3832

1. 0002620: Stuck Shift key when sending ECTL_PROCESSINPUT.

svs 12.03.2014 16:03:57 +0400 - build 3831

1. SQLite 3.8.4.1

2. Mantis#0002619: Missing horizontal line in help
   The help markup is added the instruction:
     @=[Sym] (at the beginning of the line)
     Draws a horizontal line from "Sym" characters with the normal text color.
     The line is drawn onw the entire width of the Help window indented by one symbol from the left and from the right.
     If "Sym" is omitted, then the single horizontal line will be drawn (character code 0x2500).
     The rest of the line is ignored.

3. DIF_SEPARATORUSER did not work (at least for the horizontal separator)

svs 11.03.2014 10:24:41 +0400 - build 3830

1. Bug: Incorrect functioning of launch files from panels when the file name contains '@' at the beginning.
   For example, "@@@@howl_by_tomape.jpg" while proceeding inner functions is transformed to "@@@howl_by_tomape.jpg"
   I.e. "@" character at the beginning of the line treated as a silent mode flag, then the line is truncated by -1 character.

   Now: Enter on a file panel item skips the algorithm of '@' character definition at the beginning of the name.
        For '@@@@howl_by_tomape.jpg' in command line a warning will be issued that the file "@@@howl_by_tomape.jpg" does not exist.
        For '"@@@@howl_by_tomape.jpg"' (quoted name) the '@@@@howl_by_tomape.jpg' file will be launched.


svs 10.03.2014 22:56:53 +0400 - build 3829

1. SQLite 3.8.4

drkns 10.03.2014 19:37:56 +0200 - build 3828

1. "/rw" key renamed to "/ro-".

2. After 3821 the debug build detected false memory leak. It is better to avoid global std objects.

3. Placing NonCopyable, getting rid of some global objects and other refactoring.

drkns 10.03.2014 01:28:52 +0200 - build 3827

1. Another couple of drawing optimizations.

drkns 10.03.2014 01:08:07 +0200 - build 3826

1. A very old bug, introduced in 2.0.1077.
   In some cases the optimization worked not as expected and caused slowdown.

shmuel 09.03.2014 15:08:27 +0200 - build 3825

1. Forum: DI_FIXEDIT + DIF_HISTORY for lines longer than 2 characters.
   (The presence of DIF_HISTORY flag allowed input of 1 excessive character in input field).

shmuel 08.03.2014 23:07:41 +0200 - build 3824

1. Forum: FSF.TruncStr() returns incorrect result.

zg 08.03.2014 18:40:47 +0200 - build 3823

1. correction of 3821. for DM_GETFOCUS and DM_LISTADDSTR -1 is returned if there is no dialog.

drkns 07.03.2014 02:38:36 +0200 - build 3822

1. VC10 fix.

2. Warning.

zg 07.03.2014 02:13:56 +0200 - build 3821

1. 0002614: SendDlgMessage: fix for crash on invalid hDlg.

drkns 05.03.2014 22:41:01 +0200 - build 3820

1. 0002604: Translate in file menu Add, Subtract, Multiply...

drkns 04.03.2014 01:22:32 +0200 - build 3819

1. Forum: long to short names conversion did not work for file names longer than 255 characters.

2. Refactoring.

shmuel 02.03.2014 09:53:50 +0200 - build 3818

1. Custom sorting in panels: indication of current sorting mode would not be drawn on an empty panel in some cases.

shmuel 21.02.2014 18:11:56 +0200 - build 3817

1. M#0002607. Another correction.

svs 21.02.2014 08:05:46 +0400 - build 3816

1. Mantis#0002607. Correction.
   DM_SETITEMPOSITION returns false with wrong coordinates given.

svs 20.02.2014 21:33:03 +0400 - build 3815

1. Mantis#0002607: DM_SETITEMPOSITION causes FAR crash if Right < Left - 1

w17 19.02.2014 16:59:31 +0400 - build 3814

1. M#2605: Memory freed after editing

w17 18.02.2014 18:54:03 +0400 - build 3813

1. fix $#nn (from the forum)

drkns 17.02.2014 22:47:09 +0200 - build 3812

1. 0002603: Crash on FCTL_GETCURRENTPANELITEM called with PTYPE_QVIEWPANEL and PTYPE_INFOPANEL

2. Refactoring.

drkns 17.02.2014 00:03:05 +0200 - build 3811

1. Correction of 3810.

drkns 16.02.2014 19:18:25 +0200 - build 3810

1. Flags 0x10 and 0x20 were set incorrectly in Editor.State.

2. Incorrect change of UI language.

3. Refactoring.

drkns 15.02.2014 13:30:44 +0200 - build 3809

1. Third party libraries (UCD, sqlite, tinyxml) moved to thirdparty.

drkns 14.02.2014 19:33:07 +0200 - build 3808

1. 0002600: Far doesn't load plugins with the same dll-name

svs 14.02.2014 09:40:25 +0400 - build 3807

1. SQLite 3.8.3.1

drkns 13.02.2014 20:56:37 +0200 - build 3806

1. The size of copy buffer could not be less than 64 K.

2. Copying to nul did not use the system copy function.

drkns 13.02.2014 00:23:02 +0200 - build 3805

1. VC10.

drkns 13.02.2014 00:10:00 +0200 - build 3804

1. GCC build could crash when plugin was creating a dialog with a handler.

2. Now an error on language change does not cause the process terminate.

3. Refactoring.

shmuel 12.02.2014 18:00:50 +0200 - build 3803

1. Uninitialized state of "Size" checkbox in file filter creation dialog.

w17 11.02.2014 17:41:29 +0400 - build 3802

1. Correction of 3801

w17 11.02.2014 13:59:15 +0400 - build 3801

1. Long names in deletion dialog (from the forum)

drkns 08.02.2014 12:39:25 +0200 - build 3800

1. 0002577: Block shift does not work for one character line

zg 08.02.2014 03:38:56 +0200 - build 3799

1. correction of 3794:
   in editor, on code page change, any empty line causes a warning:
   "Editor contains characters, which cannot be correctly saved using selected codepage."

zg 06.02.2014 23:38:11 +0200 - build 3798

1. DM_GETDLGITEM returns the current list for DI_LISTBOX and DI_COMBOBOX items, instead of the list which
   they were initialized by at their creation.

w17 06.02.2014 01:14:29 +0400 - build 3797

1. vc++ 2010 fix

drkns 05.02.2014 20:45:24 +0200 - build 3796

1. Correction of 3794.

svs 05.02.2014 12:25:36 +0400 - build 3795

1. SQLite 3.8.3

drkns 05.02.2014 09:43:50 +0200 - build 3794

1. Analyzer warnings.

2. Refactoring.

drkns 03.02.2014 20:20:22 +0200 - build 3793

1. 0002593: Far Manager v3.0 build 3791 x86 (3792) block selection works incorrectly.

drkns 03.02.2014 08:35:23 +0200 - build 3792

1. Correction of 3791.

drkns 02.02.2014 17:48:43 +0200 - build 3791

1. Refactoring.

3. Overloading of new/delete is removed in Release and corrected in Debug.

3. PVS & cppcheck warnings.

drkns 31.01.2014 08:42:27 +0200 - build 3790

1. 0002588: After directory change in a dialog and Enter key press, the former directory is opened

drkns 29.01.2014 23:43:43 +0200 - build 3789

1. For the sake of perfectionism, do not query info on codepages till needed.

shmuel 29.01.2014 18:45:16 +0200 - build 3788

1. Refactoring in macro system.

zg 27.01.2014 21:37:49 +0200 - build 3787

1. 0002579: DM_GETTEXT returns garbage in some cases (LuaFAR)

drkns 27.01.2014 21:09:26 +0200 - build 3786

1. 0002578: Memory allocation issue when searching with a filter

zg 25.01.2014 04:09:09 +0200 - build 3785

1. 0002567: browsing an archive after search
   SetDirectoryW was passed a path with a trailing slash.

drkns 21.01.2014 22:47:59 +0200 - build 3784

1. 0002568: Exception on attempt of entering a string into fields designed for numeric values

w17 21.01.2014 23:14:25 +0400 - build 3783

1. M#2569: Incorrect functioning of AltM shortcut in Viewer settings dialog

shmuel 21.01.2014 19:26:55 +0200 - build 3782

1. Refactoring in macro system.

drkns 19.01.2014 23:03:16 +0200 - build 3781

1. #0002294: Unused code is removed.

drkns 19.01.2014 21:18:14 +0200 - build 3780

1. Correction of 3779.

drkns 19.01.2014 19:58:42 +0200 - build 3779

1. PVS & cppcheck warnings.

2. Refactoring.

drkns 19.01.2014 02:39:29 +0200 - build 3778

1. Refactoring.

shmuel 18.01.2014 20:50:43 +0200 - build 3777

1. Refactoring in macro system.

w17 17.01.2014 14:12:54 +0400 - build 3776

1. M#2557: Confirmation of multiple files deletion

   2 parameters added (far:config):

   a) Interface.DelHighlightSelected -- bool, default = true
   true -- taking the case when the list of items to delete differs from the item under the cursor.

   b) Interface.DelShowSelected -- int, default = 10
   Show names in multiple files deletion, but not more than the number specified,
   scaled to range 1..screen_length/2

   Old behavior = (false, 1)

drkns 17.01.2014 09:50:47 +0200 - build 3775

1. Correction of 3774.

drkns 16.01.2014 22:11:50 +0200 - build 3774

1. 0002565: Regression with privilege escalation and folder reading

2. Refactoring.

w17 15.01.2014 16:38:20 +0400 - build 3773

1. Continuation of b3771

shmuel 14.01.2014 19:24:08 +0200 - build 3772

1. Refactoring in macro system.

w17 14.01.2014 16:58:53 +0400 - build 3771

1. M#2556: Crash in Help if macro has lots of keys assigned

shmuel 14.01.2014 11:15:34 +0200 - build 3770

1. Refactoring in macro system.

w17 13.01.2014 00:08:49 +0400 - build 3769

1. M#2558: Undo does not take file save into account (from CyberShadow)

drkns 12.01.2014 13:24:37 +0200 - build 3768

1. Correction of 3767.

drkns 12.01.2014 00:21:01 +0200 - build 3767

1. Crash if there is no rights for writing to profile.

2. Unsupported plugins (for example, Far 2) could be considered as "correct" ones.

3. Refactoring.

shmuel 11.01.2014 23:43:43 +0200 - build 3766

1. M#2551: Object.Height/Width do not work in menu.

drkns 09.01.2014 00:20:44 +0200 - build 3765

1. Correction of 3752 for plugin panels.

drkns 08.01.2014 19:43:29 +0200 - build 3764

1. After 3751, hidden files on a plugin panel were shown incorrectly.

drkns 06.01.2014 17:13:09 +0200 - build 3763

1. Use OS version checks recommended by MS instead of deprecated GetVersionEx.

2. Use native thread_local in gcc.

drkns 05.01.2014 22:55:23 +0200 - build 3762

1. VC10.

drkns 05.01.2014 19:39:38 +0200 - build 3761

1. 0002553: Useless hotkeys F3/F4 in commands history (Alt-F8)

shmuel 05.01.2014 19:22:10 +0200 - build 3760

1. Refactoring of custom sorting.

drkns 03.01.2014 13:37:10 +0200 - build 3759

1. Continuation of 3756: allocations are removed, the code is slightly simplified.

drkns 03.01.2014 11:23:21 +0200 - build 3758

1. Correction of 3752.

t-rex 03.01.2014 11:08:14 +0200 - build 3757

1. Memory leak in 3756.

t-rex 03.01.2014 04:59:02 +0200 - build 3756

1. Fix for custom sorting, this is made ugly to pay attention on it.

drkns 03.01.2014 04:00:21 +0200 - build 3755

1. "Restore" custom sorting modes.

drkns 02.01.2014 18:06:05 +0200 - build 3754

1. Optimization of inner classes moving.

drkns 02.01.2014 04:33:52 +0200 - build 3753

1. Continuation of 3752.

drkns 02.01.2014 02:55:55 +0200 - build 3752

1. Optimization similar to 3401: each file panel item occupies about 200 bytes of memory less.

drkns 31.12.2013 16:06:31 +0200 - build 3751

1. Refactoring.

2. Correction of 3749.

3. ShiftF9 always forces settings save "with no heuristics nor optimization".

drkns 31.12.2013 03:05:45 +0200 - build 3750

1. F4 in mask groups menu crashed FAR.

drkns 31.12.2013 00:38:12 +0200 - build 3749

1. Refactoring.

drkns 30.12.2013 21:25:21 +0200 - build 3748

1. Refactoring.

drkns 26.12.2013 19:36:19 +0200 - build 3747

1. Correction of 3746.

drkns 26.12.2013 01:21:42 +0200 - build 3746

1. Refactoring.

drkns 21.12.2013 22:00:20 +0200 - build 3745

1. Correction of 3744.1.

drkns 21.12.2013 21:20:13 +0200 - build 3744

1. Refactoring.

2. Memory leaks when started with /v or /e keys.

drkns 15.12.2013 04:54:32 +0200 - build 3743

1. Correction of 3738.

drkns 13.12.2013 22:15:29 +0200 - build 3742

1. Correction of 3738.

svs 13.12.2013 12:06:12 +0400 - build 3741

1. Mantis#0002545: GUID for the plugin parameters menu

    PluginsConfigMenuId   =  {B4C242E7-AA8E-4449-B0C3-BD8D9FA11AED} --> Menu.Id

drkns 13.12.2013 09:23:31 +0200 - build 3740

1. Correction of 3738.

drkns 13.12.2013 01:21:33 +0200 - build 3739

1. VC10 fix.

drkns 13.12.2013 00:57:54 +0200 - build 3738

1. Refactoring.

drkns 09.12.2013 20:56:45 +0200 - build 3737

1. Files highlighting was broken in 3733.

w17 09.12.2013 14:03:54 +0400 - build 3736

1. Correction of 3678 (M#2496)

w17 09.12.2013 13:43:23 +0400 - build 3735

1. M#2543: incorrect functioning of Panel.SetPosIdx when panel filter is on

svs 09.12.2013 10:55:43 +0400 - build 3734

1. SQLite 3.8.2

drkns 08.12.2013 23:04:44 +0200 - build 3733

1. Refactoring.

svs 06.12.2013 14:31:24 +0400 - build 3732

1. Mantis#0002331: Hotkeys and/or GUIDs for Folder Shortcuts

    FolderShortcutsDlgId  = {DC8D98AC-475C-4f37-AB1D-45765EF06269} --> Dlg.Id
      Path editing dialog.
    FolderShortcutsMoreId = {601DD149-92FA-4601-B489-74C981BC8E38} --> Menu.Id
      The menu shown when more than one path is bound to a shortcut.
      Earlier, entered FolderShortcutsId was the menu of the common list of shortcuts (F9 c d).

2. SetId/GetId functions assigning a GUID to dialogs are added to DialogBuilder.

svs 05.12.2013 17:07:29 +0400 - build 3731

1. Mantis#0002537: a list with DIF_LISTNOBOX flag in dialog shows unusual scrolling
   ...similar behavior was for PgDn

svs 05.12.2013 14:43:33 +0400 - build 3730

1. SysLog. Output file is in UTF-8; correction of file open/close (with debug info on app close)

drkns 04.12.2013 20:32:29 +0200 - build 3729

1. Refactoring.

2. syslog used wrong *printf functions.

zg 29.11.2013 21:29:21 +0200 - build 3728

1. fg4bit and bg4bit switched places in import/export.

drkns 27.11.2013 22:00:17 +0200 - build 3727

1. 0002533: Xlat settings cannot be read on Far start

drkns 27.11.2013 21:13:16 +0200 - build 3726

1. 0002535: Crash when opening History in a small EditBox

drkns 26.11.2013 23:03:45 +0200 - build 3725

1. A couple of corrections in 3723.

drkns 25.11.2013 01:55:45 +0200 - build 3724

1. A couple of corrections in 3723.

drkns 24.11.2013 21:37:36 +0200 - build 3723

1. Refactoring.

2. Wiping unused code.

w17 21.11.2013 21:10:00 +0400 - build 3722

1. Exception on CtrlJ/C/F in panel when the cursor is on '..'

shmuel 21.11.2013 17:11:54 +0200 - build 3721

1. Correction of build 3708 (M#2440).

w17 20.11.2013 13:48:49 +0400 - build 3720

1. M#2527: Crash when restarting with rebuilding tree(fix b3673.2)

drkns 19.11.2013 21:18:07 +0200 - build 3719

1. 0002528: Crash when LCtrl8 panel mode is on

﻿svs 18.11.2013 15:42:46 +0400 - build 3718

1. Corrections on TREEFILE_PROJECT (Mantis#0000186)

w17 18.11.2013 11:37:28 +0400 - build 3717

1. Correction of 3713 (do not store duplicate commands from different folders)

shmuel 16.11.2013 17:17:31 +0200 - build 3716

1. Correction of 3713.

shmuel 16.11.2013 16:55:01 +0200 - build 3715

1. Correction of 3714.

shmuel 16.11.2013 14:54:12 +0200 - build 3714

1. An event type in added in Panel API: FE_CHANGESORTPARAMS.

w17 16.11.2013 03:05:43 +0400 - build 3713

1. M#2208: Memorize the folder a command was launched at (from fml2)

svs 15.11.2013 17:39:24 +0400 - build 3712

1. Corrections (some) on TREEFILE_PROJECT (Mantis#0000186)
   concerning network paths

svs 15.11.2013 15:35:21 +0400 - build 3711

1. Corrections (some) on TREEFILE_PROJECT (Mantis#0000186)
   Templates of tree files are changed:
    "LD.%D.%SN.tree"      the template of a tree file name for local volumes
    "ND.%D.%SN.tree"      the template of a tree file name for network volumes
    "NP.%SR.%SH.tree"     the template of a tree file name for network paths
    "RD.%SN.tree"         the template of a tree file name for removable drives
    "CD.%L.%SN.tree"      the template of a tree file name for CD/DVD/BD/etc drives

   <ACHTUNG>

   1. No need for /D TREEFILE_PROJECT - the project is in development. Testing only.
   2. Post your ideas and comments here - http://bugs.farmanager.com/view.php?id=186

   </ACHTUNG>

w17 13.11.2013 01:12:09 +0400 - build 3710

1. M#2524: Crash when renaming a file on Mac network drive.
   Experimental workaround for buggy OSX SMB.

w17 12.11.2013 20:11:28 +0400 - build 3709

1. M#2525: Incorrect clipping of edited file on Mac network drive
   Experimental workaround for buggy OSX SMB.

svs 11.11.2013 11:16:52 +0400 - build

1. Corrections in 'title' command help topic

2. References to print function (Alt-F5) are removed from help topics on editor and viewer, as there's no support for it in code.

shmuel 08.11.2013 18:47:05 +0200 - build 3708

1. M#2440: akey(1) and single modifier key press.

drkns 03.11.2013 01:25:39 +0200 - build 3707

1. 0002521: Far crash on 'My Documents' ANSI plugin start, since build 3506

shmuel 02.11.2013 21:39:35 +0200 - build 3706

1. Find file (AltF7): crash when searching on a non-file plugin panel.

drkns 31.10.2013 22:34:33 +0200 - build 3705

1. Far processes the "title" command.
   The argument string is used instead of standard console caption formatting logic until the end of the current session.
   If the string is omitted, default behavior is restored.

w17 31.10.2013 02:35:53 +0400 - build 3704

1. Continuation of 3703: pressing and holding a key cancels deletion

w17 30.10.2013 23:41:30 +0400 - build 3703

1. M#2419: Two almost identical confirmation dialogs for deletion of multiple files (from SEt)

w17 28.10.2013 06:51:10 +0400 - build 3702

1. Forum: 'Use sort groups' and 'Show selected first' cannot be forced on/off

drkns 26.10.2013 21:11:58 +0200 - build 3701

1. Refactoring.

drkns 25.10.2013 09:03:21 +0200 - build 3700

1. Correction of 3699.

drkns 24.10.2013 22:22:03 +0200 - build 3699

1. 0002517: Invalid line number supplied in "Go to position" dialog crashes Far Manager

w17 22.10.2013 22:30:45 +0400 - build 3698

1. M#2513: FAR crash on files with empty names (from SEt)

svs 18.10.2013 11:41:12 +0400 - build 3697

1. SQLite 3.8.1

w17 18.10.2013 00:23:12 +0400 - build 3696

1. Correction of 3300

drkns 07.10.2013 20:28:43 +0200 - build 3695

1. Forgotten lancet inside 3694.

drkns 07.10.2013 20:15:52 +0200 - build 3694

1. Once more on obtaining the caption of the console.

w17 07.10.2013 14:31:23 +0400 - build 3693

1. M#2505: duplication of Japanese characters after command run

drkns 06.10.2013 13:26:56 +0200 - build 3692

1. Entering some characters in the drive change dialog could cause AV.

drkns 04.10.2013 22:29:28 +0200 - build 3691

1. Another correction on CtrlZ in the editor.

2. Refactoring.

drkns 04.10.2013 14:12:40 +0200 - build 3690

1. Correction of 3654.

drkns 04.10.2013 12:40:35 +0200 - build 3689

1. Correction of 3659.

w17 04.10.2013 07:04:27 +0400 - build 3688

1. Forum:
   Issue #1. FAR starts with %temp% on one panel only, another one shows some old folder.
   Issue #2. Exiting FAR --> a blinking cursor is hidden in an original cmd window.

drkns 02.10.2013 12:44:54 +0200 - build 3687

1. Watch for date/time format change dynamically.

drkns 02.10.2013 11:23:30 +0200 - build 3686

1. For a date format beginning with the year it was shown without leading zero.

drkns 01.10.2013 18:51:46 +0200 - build 3685

1. Restore stripping of spaces when copying text from the screen.

2. Start with an empty console caption (start "" far.exe) caused crash.

w17 27.09.2013 18:12:55 +0400 - build 3684

1. M#2499: Exception while trying to search for a file in the viewer mode

2. Editor Clipboard paste fix.vc10

svs 26.09.2013 13:02:27 +0400 - build 3683

1. Policies are removed (Policies.DisabledOptions)

drkns 25.09.2013 00:08:15 +0200 - build 3682

1. 0002498: Filter cannot be disabled if there are same extensions with a different case

w17 25.09.2013 00:36:10 +0400 - build 3681

1. correction of 3680

drkns 24.09.2013 22:10:50 +0200 - build 3680

1. 0002497: If down arrow is pressed and held on any but last menu item then the cursor runs off the menu.

w17 23.09.2013 20:33:42 +0400 - build 3679

1. M#2495: [Folders history] In the absence of an appropriate plug-in history an empty string is shown.
   (from Denis)

w17 23.09.2013 19:54:36 +0400 - build 3678

1. M#2496: Disable hotkeys highlighting in history for its slowness on large number of items
   (from Denis)

shmuel 22.09.2013 20:02:30 +0200 - build 3677

1. Macros, experimental:
   - Plugin.Call() always works asyncronously, i.e. as before, after mmode(3,1) call.
   - If the syncronous mode is needed, use Plugin.SyncCall().
   - mmode(3,x) always returns 0 and does not influence anything.

drkns 22.09.2013 15:28:35 +0200 - build 3676

1. 0002492: Editor CtrlZ once more.

drkns 22.09.2013 15:24:17 +0200 - build 3675

1. 0002492: Editor CtrlZ

2. Refactoring.

shmuel 21.09.2013 11:50:29 +0200 - build 3674

1. Refactoring.

drkns 20.09.2013 23:50:03 +0200 - build 3673

1. Refactoring.

2. Folder tree manual update caused a crash.

drkns 20.09.2013 17:09:53 +0200 - build 3672

1. Refactoring.

w17 20.09.2013 16:53:54 +0400 - build 3671

1. vc10 build fix

drkns 20.09.2013 14:21:44 +0200 - build 3670

1. Correction of 3668.

drkns 20.09.2013 13:56:44 +0200 - build 3669

1. Refactoring.

drkns 19.09.2013 20:07:18 +0200 - build 3668

1. Refactoring.

drkns 19.09.2013 13:31:43 +0200 - build 3667

1. Correction of 3666.

drkns 19.09.2013 09:49:54 +0200 - build 3666

1. Correction of 3656.

2. gcc warnings.

drkns 19.09.2013 09:31:02 +0200 - build 3665

1. 0002490: Editor kills end of line since ver. 3659

shmuel 19.09.2013 00:01:45 +0200 - build 3664

1. M#2486: Enable Plugin.Call use in Condition.
   Plugin.SyncCall macrofunction added, see macroapi_manual.chm.

drkns 18.09.2013 23:15:01 +0200 - build 3663

1. Refactoring.

drkns 18.09.2013 18:43:08 +0200 - build 3662

1. Refactoring.

w17 18.09.2013 17:12:50 +0400 - build 3661

1. Correction of 3660 (from Denis)

w17 18.09.2013 13:23:02 +0400 - build 3660

1. M#2488: Special Symbols aren't shown in DialogTilte of "!?<title>?<init>!"
   Metasymbols replaced in the dialog caption (same as in the top level usermenu).

drkns 17.09.2013 20:50:44 +0200 - build 3659

1. Refactoring.

w17 17.09.2013 11:41:16 +0400 - build 3658

1. Forum: Malfunction of clipboard clear test

drkns 17.09.2013 00:07:58 +0200 - build 3657

1. Refactoring.

drkns 16.09.2013 21:51:26 +0200 - build 3656

1. Do not create directories in the profile if ReadOnlyConfig==true.

shmuel 16.09.2013 20:04:27 +0200 - build 3655

1. LuaMacro plugin is given the value of "ReadOnlyConfig" FAR option, so that it does not create
   directories nor create/change/delete files, when it is disabled.

drkns 16.09.2013 00:29:14 +0200 - build 3654

1. UCD wrapper is redone.
   UCD\nscore.h proved to contaminate global namespace with stuff like "#define typename"
   with predictable consequences, therefore it is removed from headers.

drkns 15.09.2013 21:06:55 +0200 - build 3653

1. Refactoring.

shmuel 15.09.2013 21:01:09 +0200 - build 3652

1. Refactoring.

w17 12.09.2013 21:07:14 +0400 - build 3651

1. M#2483: '&' modifiers do not work in main menu.

drkns 12.09.2013 14:23:24 +0200 - build 3650

1. 0002482: FAR crash on attempt of copying files with privilege elevation.

2. A couple of minor issues.

drkns 11.09.2013 23:06:23 +0200 - build 3649

1. Refactoring.

shmuel 10.09.2013 23:57:52 +0200 - build 3648

1. PluginPanelItemEx renamed to SortingPanelItem.

shmuel 10.09.2013 23:10:05 +0200 - build 3647

1. Custom panel sortings use PluginPanelItemEx structure instead of PluginPanelItem.
   (This is the breaking change, so check your code).

drkns 10.09.2013 20:40:20 +0200 - build 3646

1. Refactoring.

shmuel 10.09.2013 11:17:28 +0200 - build 3645

1. Custom panel sortings did not get 'ChangeTime' value.

2. GCC warnings.

shmuel 10.09.2013 10:43:17 +0200 - build 3644

1. Correction of 3643.

drkns 10.09.2013 09:48:29 +0200 - build 3643

1. Refactoring.

shmuel 08.09.2013 20:14:02 +0200 - build 3642

1. In 3641, sorting direction was broken when chosing a sorting mode via CtrlF12 menu on Enter press.

drkns 08.09.2013 17:30:27 +0200 - build 3641

1. Refactoring.

2. cppcheck warnings.

3. correction of "folder sorting by extension" mode.

drkns 06.09.2013 13:04:00 +0200 - build 3640

1. Forum: "Somewhere between 3597-3635 a crash is observed on attempt to call "Continue" of S&R plugin in editor."

shmuel 05.09.2013 22:41:24 +0200 - build 3639

1. Refactoring.

drkns 05.09.2013 13:47:00 +0200 - build 3638

1. A couple of corrections of 3636.

w17 05.09.2013 00:25:22 +0400 - build 3637

1. VC10 build fix.

2. -warnings.

drkns 04.09.2013 21:41:29 +0200 - build 3636

1. Refactoring.

2. cppcheck warnings.

shmuel 04.09.2013 19:31:48 +0200 - build 3635

1. Panel sorting menu (CtrlF12) also includes custom sorting modes if they exist.

w17 04.09.2013 12:57:16 +0400 - build 3634

1. Single-character plugin prefixes are allowed with the following restrictions:
   A-Z are prohibited;
   others are allowed if there is no volume with the same name in the system (checked with QueryDosDevice)

drkns 04.09.2013 00:06:16 +0200 - build 3633

1. When copying to several targets, the taskbar button blinked after each operation.

svs 03.09.2013 23:42:01 +0400 - build 3632

1. SQLite 3.8.0.2

shmuel 03.09.2013 14:58:38 +0200 - build 3631

1. If a plugin running from a macro called MCTL_EXECSTRING then after MCTL_EXECSTRING execution
   screen redrawing could be disabled, so the plugin was unable to display a menu.

2. Slightly refactoring.

shmuel 02.09.2013 11:19:10 +0200 - build 3630

1. FSF.CopyToClipboard() clears the clipboard if Data==NULL.

shmuel 02.09.2013 07:25:59 +0200 - build 3629

1. FSF.CopyToClipboard function did not copy empty strings.

zg 31.08.2013 04:12:54 +0200 - build 3628

1. forum: Crash on PCTL_GETPLUGININFORMATION call.

drkns 30.08.2013 22:53:31 +0200 - build 3627

1. Sending messages to a dialog before DialogRun call could cause a crash.

w17 29.08.2013 16:08:18 +0400 - build 3626

1. Correction of 3261, DialogBuilder update

drkns 29.08.2013 10:01:04 +0200 - build 3625

1. Incorrect handling of OPEN_FINDLIST call for ansi plugins.

t-rex 28.08.2013 20:06:09 +0200 - build 3624

1. Correction of 3621, using DialogBuilder.

t-rex 28.08.2013 16:35:28 +0200 - build 3623

1. Correction of 3621

2. sqlite 3.8.0

w17 28.08.2013 17:24:35 +0400 - build 3622

1. Correction of 3621

w17 28.08.2013 14:59:22 +0400 - build 3621

1. Error text wrapping in ChDiskDlg error dialog

shmuel 20.08.2013 20:54:52 +0200 - build 3620

1. Custom panel sortings are restored after FAR restart if setup was saved,
   provided that appropriate Panel.LoadCustomSortMode() calls are done in the process of macros loading.
   Restoring is done after macros loading is complete, before autostarting macros run.

t-rex 19.08.2013 14:09:16 +0200 - build 3619

1. $ at the end of the replace string in regexp search inserted \x00 instead of being ignored.

drkns 18.08.2013 13:22:27 +0200 - build 3618

1. Screen buffer could use more memory than it was necessary.

shmuel 17.08.2013 11:56:31 +0200 - build 3617

1. M#2468: incorrect working of Editor.Value and Editor.GetStr() if the string contains \x00.

drkns 17.08.2013 01:36:21 +0200 - build 3616

1. Correction of 1947.1 - copying strings from the position after zero character to the clipboard caused crash.

t-rex 16.08.2013 23:42:58 +0200 - build 3615

1. Mantis#2465: \x00 character breaks regexp search/replace.

svs 15.08.2013 12:09:54 +0400 - build 3614

1. Continuation of Mantis#0002442
   (from Smitis)

svs 15.08.2013 10:42:32 +0400 - build 3613

1. Correction of System.Executor.ComSpecParams - adding space symbols.

shmuel 15.08.2013 00:28:27 +0200 - build 3612

1. Refactoring.

svs 14.08.2013 18:52:13 +0400 - build 3611

1. Mantis#0002442: Add support for TakeCommand
   (from Smitis)
   Testing.

2. Experimental: strComSpecParams value in launcher (see "/C ") moved to System.Executor.ComSpecParams settings

drkns 14.08.2013 09:40:14 +0200 - build 3610

1. Warnings.

w17 14.08.2013 04:32:30 +0400 - build 3609

1. Continuation of 3602

w17 12.08.2013 18:51:45 +0400 - build 3608

1. M#2462: Cannot change to root of a volume with cd\

2. -warnings

shmuel 10.08.2013 19:41:07 +0200 - build 3607

1. Continuation of 3604: custom sorting in panels is now working.
   See the description of Panel.SetCustomSortMode function in macroapi_manual.chm.

drkns 10.08.2013 18:58:13 +0200 - build 3606

1. Continuation of 3596. BOOL Initialize(GlobalInfo*) (called when loading) and
   void Free(ExitInfo*) functions  (called when unloading) are added for adapters.
   Both must be present, fill GlobalInfo properly in Initialize.

drkns 09.08.2013 22:32:07 +0200 - build 3605

1. Plugins loading correction.

2. Correction of panel caption drawing.

3. Uninitialized variables in copier.

shmuel 09.08.2013 20:01:49 +0200 - build 3604

1. Custom sorting in panels. Still non-operating.

w17 09.08.2013 11:15:48 +0400 - build 3603

1. Continuation of 3602. GetPathRoot worked incorrectly for mountpoints in XP

w17 09.08.2013 04:54:02 +0400 - build 3602

1. M#2461: auto-create directory on the file system mounted via NTFS folder

drkns 08.08.2013 21:19:33 +0200 - build 3601

1. Correction of 3597.

w17 08.08.2013 17:46:03 +0400 - build 3600

1. Codepage names and typo (from Denis)

drkns 08.08.2013 14:46:51 +0200 - build 3599

1. URL open from help could malfunction in some cases.

drkns 07.08.2013 23:21:18 +0200 - build 3598

1. far:config poor handling of 64 bit numbers.

2. Continuing to remove FormatString.

drkns 07.08.2013 01:40:10 +0200 - build 3597

1. TPreRedrawFunc is partially redone. Storing pointers to anything is ok, but data
   addressed by those pointers can have vanished to the moment of call.

2. Removing FormatString.

drkns 06.08.2013 19:28:53 +0200 - build 3596

1. Implementing plugin adapters.
   See http://forum.farmanager.com/viewtopic.php?t=8114 for details, the description of interface is also there.

shmuel 06.08.2013 11:44:50 +0200 - build 3595

1. In "Unsorted" panel sorting mode, when "Show selected first" option was on, selected files
   were shown last instead of first.

w17 05.08.2013 14:27:36 +0400 - build 3594

1. Missing menu item for Panel.Text.Highlight config parameter in color settings menu (from ccaid)

w17 05.08.2013 09:33:40 +0400 - build 3593

1. Directories were deleted to recycle bin with Alt-Del

drkns 04.08.2013 16:11:41 +0200 - build 3592

1. Resource leak on cancelling the plugin choice menu (CtrlPgDn).

zg 04.08.2013 00:11:41 +0200 - build 3591

1. DN_INPUT now receives FOCUS_EVENT.

zg 01.08.2013 18:40:31 +0200 - build 3590

1. PluginStartupInfo.Menu crash if Title == nullptr.

drkns 01.08.2013 14:50:21 +0200 - build 3589

1. Incorrect order of owner and domain in "file owner" column.

drkns 31.07.2013 21:56:29 +0200 - build 3588

1. More on string and nullptr.

drkns 30.07.2013 20:58:19 +0200 - build 3587

1. Refactoring.

drkns 30.07.2013 19:28:34 +0200 - build 3586

1. Continuation of 3582.

w17 30.07.2013 18:13:20 +0400 - build 3585

1. fix copy to ..

drkns 30.07.2013 14:26:32 +0200 - build 3584

1. Possible double memory freeing while obtaining a list from a plugin panel.

2. ProcessOSAliases could use uninitialized data.

drkns 30.07.2013 10:31:31 +0200 - build 3583

1. Correction of 3579.

drkns 30.07.2013 00:55:42 +0200 - build 3582

1. Refactoring.

drkns 29.07.2013 14:50:21 +0200 - build 3581

1. The caption of the right panel was centered incorrectly when the clock was enabled.

drkns 28.07.2013 22:22:24 +0200 - build 3580

1. Correction of previous build, there were problems with copying.

drkns 28.07.2013 19:55:27 +0200 - build 3579

1. More on correct processing of "." and ".." directories - looping is removed at tree including them.

drkns 28.07.2013 16:34:30 +0200 - build 3578

1. More on search for all occurrences.

drkns 28.07.2013 15:56:53 +0200 - build 3577

1. Correction of 3570.2.

w17 28.07.2013 15:17:50 +0400 - build 3576

1. Another correction of 3475

drkns 28.07.2013 13:41:01 +0200 - build 3575

1. 0002453: FAR freeze on directories delete

drkns 28.07.2013 12:36:50 +0200 - build 3574

1. In some cases, search for all occurrences in editor could crash

2. While searching for all occurrences, a progress indicator was calculated incorrectly.

shmuel 28.07.2013 10:09:10 +0200 - build 3573

1. Crash on copying with F5 to ..\.. target directory

w17 28.07.2013 00:34:28 +0400 - build 3572

1. correction of 3475

shmuel 27.07.2013 18:36:26 +0200 - build 3571

1. More NullToEmpty (FAR crash with Hash Calculator plugin).

drkns 27.07.2013 16:48:32 +0200 - build 3570

1. Wrong error text was shown at attempt of changing to inexisting volume.

2. A couple of issues in wrapper.

drkns 27.07.2013 13:30:05 +0200 - build 3569

1. 0002452: Can't add new Mask to 'Groups of file masks' (since ver3566)

shmuel 27.07.2013 12:00:50 +0200 - build 3568

1. More NullToEmpty (FAR crash with AdvCmp plugin).

shmuel 27.07.2013 07:27:14 +0200 - build 3567

1. Crash on disk menu call.

2. GCC warnings.

w17 27.07.2013 01:23:56 +0400 - build 3566

1. -a few 'funny' crashes

drkns 26.07.2013 23:18:26 +0200 - build 3565

1. Placing NullToEmpty in right places.

drkns 26.07.2013 22:25:11 +0200 - build 3564

1. Placing NullToEmpty in right places.

drkns 26.07.2013 21:44:01 +0200 - build 3563

1. wstring is on by default. Various funny crashes are possible.

drkns 26.07.2013 21:05:55 +0200 - build 3562

1. GetStringBuffer = 0;

2. In one of previous builds, plugin settings import was broken.

3. "information under panels" was not kept on exit.

shmuel 26.07.2013 17:46:54 +0200 - build 3561

1. If FAR was started from an existing console then on closing it from a macro, a picture of closed FAR remained in the console.

drkns 25.07.2013 23:52:08 +0200 - build 3560

1. --GetStringBuffer

drkns 25.07.2013 23:04:09 +0200 - build 3559

1. --GetStringBuffer

drkns 25.07.2013 22:19:25 +0200 - build 3558

1. --GetStringBuffer

drkns 25.07.2013 21:32:10 +0200 - build 3557

1. --GetStringBuffer

w17 25.07.2013 12:23:31 +0400 - build 3556

1. fix fix 3551

w17 25.07.2013 11:11:29 +0400 - build 3555

1. fix 3551

w17 25.07.2013 10:55:50 +0400 - build 3554

1. GetStringBuffer -= 1

drkns 24.07.2013 22:04:58 +0200 - build 3553

1. --GetStringBuffer

drkns 24.07.2013 21:40:54 +0200 - build 3552

1. GetStringBuffer -= 2;

2. Refactoring array_ptr.

w17 24.07.2013 22:18:55 +0400 - build 3551

1. GetStringBuffer -= 2

drkns 24.07.2013 17:54:45 +0200 - build 3550

1. Incorrect display of date in filter settings for locales using YYYY-MM-DD format.

drkns 24.07.2013 12:33:57 +0200 - build 3549

1. --GetStringBuffer

w17 24.07.2013 12:43:43 +0400 - build 3548

1. GetStringBuffer -= 4

w17 24.07.2013 07:36:17 +0400 - build 3547

1. mf.date() UPPER

drkns 23.07.2013 23:38:13 +0200 - build 3546

1. mf.date() was broken in one of previous builds + a couple of issues.

w17 24.07.2013 00:07:21 +0400 - build 3545

1. GetStringBuffer -= 1

drkns 23.07.2013 12:20:54 +0200 - build 3544

1. Garbage could be shown in some columns of disk menu.

drkns 23.07.2013 01:05:58 +0200 - build 3543

1. Refactoring.

drkns 22.07.2013 22:15:54 +0200 - build 3542

1. Refactoring.

w17 22.07.2013 22:58:09 +0400 - build 3541

1. assertion -- lm:post Keys "a"

drkns 22.07.2013 20:24:28 +0200 - build 3540

1. 0002449: FAR crash on exit initiated by a macro

drkns 20.07.2013 22:22:03 +0200 - build 3539

1. Correction of 3528.

drkns 20.07.2013 21:45:17 +0200 - build 3538

1. Continuation of 3528.

drkns 20.07.2013 19:28:48 +0200 - build 3537

1. Continuation of 3528.

drkns 20.07.2013 19:14:34 +0200 - build 3536

1. Correction of 3535.

drkns 20.07.2013 19:05:41 +0200 - build 3535

1. Continuation of 3528.

drkns 20.07.2013 16:57:35 +0200 - build 3534

1. Continuation of 3528.

drkns 20.07.2013 14:15:36 +0200 - build 3533

1. Continuation of 3528.

w17 20.07.2013 12:51:48 +0400 - build 3532

1. more 3528, CtrlPgDn on files

w17 20.07.2013 11:51:56 +0400 - build 3531

1. more 3528, waiting when refactorness gets rid from deprecated...

drkns 20.07.2013 01:16:35 +0200 - build 3530

1. Continuation of 3528.

shmuel 19.07.2013 22:08:55 +0200 - build 3529

1. Correction of 3509 for End key.

drkns 19.07.2013 20:22:50 +0200 - build 3528

1. Refactoring.
   UnicodeString is compatible by interface with std::wstring, FAR can be built with standard strings using USE_STD_STRING define.
   But it is still not recommended, because there are still some places with zero pointer initialization of strings and out-of-bounds string indexation.

   Bugs are possible, so be careful.

svs 18.07.2013 15:57:44 +0400 - build 3527

1. Correction of 1609.3: Addition of Cut related code for CF_HDROP ("cut here, paste in Explorer - it has moved")
   As the most acceptable for cut operation key Ctrl-X is already busy (history cycling in command line),
   there is still no key chosen (the place is reserved). Any macro?

drkns 18.07.2013 14:10:32 +0200 - build 3526

1. Files were copied to clipboard incorrectly in CF_HDROP format.

shmuel 17.07.2013 21:51:48 +0200 - build

1. On macros loading %FARPROFILE%\Macros\scripts\_macroinit.lua is executed first if it exists.
   The running order of other macro files is undefined.

drkns 17.07.2013 15:19:59 +0200 - build 3525

1. Continuation of M#2446: EE_SAVE gets a EditorSaveFile structure instead of a file name.

shmuel 16.07.2013 14:59:58 +0200 - build 3524

1. M#2446: EE_SAVE event must be passed the saved file name as a parameter.

drkns 14.07.2013 19:12:10 +0200 - build 3523

1. refix refix. yes, memset is kinda bad.

w17 14.07.2013 20:05:25 +0400 - build 3522

1. refix refactoring

drkns 14.07.2013 17:33:21 +0200 - build 3521

1. Support for compilation with Intel C++ 14.

drkns 14.07.2013 12:17:59 +0200 - build 3520

1. Correction of 3519.

drkns 14.07.2013 01:00:31 +0200 - build 3519

1. Refactoring.

shmuel 14.07.2013 00:25:05 +0200 - build 3518

1. Macros: "Selection" and "NoSelection" flags are no longer used for editor/viewer/dialog areas.
   "EVSelection" and "NoEVSelection" should be used accordingly for these areas.

drkns 13.07.2013 13:00:15 +0200 - build 3517

1. Refactoring.

2. Solution for VS2013 + common far.vcxproj for all versions.

shmuel 13.07.2013 11:34:23 +0200 - build 3516

1. Refactoring.

drkns 13.07.2013 00:00:00 +0200 - build 3515

1. Refactoring.

shmuel 12.07.2013 21:16:04 +0200 - build 3514

1. Refactoring.

drkns 12.07.2013 12:49:43 +0200 - build 3513

1. Removed checks for deprecated GCC versions.

shmuel 12.07.2013 12:04:01 +0200 - build 3512

1. Continuation of 3509:
   correction of processing a single Up key press in an item at the beginning of the list when VMENU_WRAPMODE is active.

drkns 12.07.2013 00:38:43 +0200 - build 3511

1. Correction of 3510.

drkns 11.07.2013 22:07:42 +0200 - build 3510

1. Removed limit on number of panel columns.

shmuel 11.07.2013 17:00:14 +0200 - build 3509

1. In a menu with scroll bar, while navigating with End, PgDn, PgUp there was no way to make
   non-focusing items at the beginning/end of the list visible.

drkns 10.07.2013 23:48:04 +0200 - build 3508

1. Correction of 3507.

drkns 10.07.2013 21:55:39 +0200 - build 3507

1. Refactoring.

2. Correction of 3506.

drkns 10.07.2013 00:39:34 +0200 - build 3506

1. Refactoring.

svs 09.07.2013 16:52:15 +0400 - build

1. Help correction, incl. TI:
    #26 System.CopyTimeRule

svs 09.07.2013 11:29:32 +0400 - build

1. Some help on privilege elevation.

drkns 08.07.2013 23:47:50 +0200 - build 3505

1. Refactoring.

shmuel 08.07.2013 20:15:33 +0200 - build 3504

1. Refactoring.

drkns 05.07.2013 18:34:35 +0200 - build 3503

1. More reliable storing of LastError / LastNtStatus state for Message with MSG_ERRORTYPE.

2. 0002444: Search via "App Paths" does not use %PathExt% now.

drkns 04.07.2013 23:03:09 +0200 - build 3502

1. Refactoring.

2. Correction of minimal GCC version (4.7.1).

w17 04.07.2013 16:45:06 +0400 - build 3501

1. gcc 4.7.1 compilation fix

shmuel 04.07.2013 15:27:46 +0200 - build 3500

1. Rollback of 3496. This also can be reached with LuaFAR library modification.

drkns 04.07.2013 13:30:33 +0200 - build 3499

1. Refactoring.

drkns 04.07.2013 12:55:32 +0200 - build 3498

1. Refactoring.

drkns 04.07.2013 01:21:03 +0200 - build 3497

1. Refactoring.

shmuel 03.07.2013 21:13:37 +0200 - build 3496

1. Forum: "Why does FAR create directories in the root of disk C".
   CreatePath inner FAR function is imported into LuaMacro plugin.

svs 03.07.2013 12:49:18 +0400 - build 3495

1. Correction of help, incl. for TI:
    #80 XLat.Layouts
    #10 XLat.Flags
    "XLat.Table*" and "XLat.Rules*" parameters are described

2. Removing a bug with Rule3 overwriting in xlat

drkns 03.07.2013 00:38:12 +0200 - build 3494

1. Outer links did not (always) work in help.

2. Other issues.

drkns 02.07.2013 16:34:23 +0200 - build 3493

1. Avoiding the recursion in file mask groups.

svs 02.07.2013 17:15:47 +0400 - build 3492

1. Correction in help
   "так же" -> "также"
   @CopyAskOverwrite - capability of F3 on items was not described.
   @MaskGroupsSettings - list control keys were not described.

2. A link to "@MaskGroupsSettings" is added for the mask groups editing dialog

svs 02.07.2013 11:40:49 +0400 - build

1. Correction in help
   @MakeFolder
     creation of links
   @UserMenu
     capability of moving items with Ctrl-arrows is described

drkns 02.07.2013 10:01:16 +0200 - build 3491

1. Correction of 3490.

2. Refactoring.

drkns 02.07.2013 01:13:32 +0200 - build 3490

1. Refactoring.

svs 01.07.2013 16:30:04 +0400 - build 3489

1. Correction of build 3488
   Removing the "negation". Now:
   In config (far:config), search "Macros.ShowPlayIndicator", set it to false for switching 'P' off
   By default, 'P' is shown

svs 01.07.2013 15:09:19 +0400 - build 3488

1. Mantis#0002410: Optionally disable blinking 'P' macro execution indicator
   In config (far:config), search "Macros.DisableShowPlayMacro", set it to true
   By default, 'P' is shown

w17 01.07.2013 09:49:39 +0400 - build 3487

1. M#2439: Command line prompt format: environment variables don't work anymore

shmuel 30.06.2013 13:12:37 +0200 - build

1. Capability of calling script files with arguments is added.
   This is related to: MCTL_SENDSTRING, MCTL_ADDMACRO, eval, lm:post, lm:check.

shmuel 30.06.2013 01:46:43 +0200 - build 3486

1. Refactoring.

zg 29.06.2013 22:58:03 +0200 - build 3485

1. correction of 3482 for IsWordDiv: '\0' is always a words separator.

drkns 29.06.2013 14:58:18 +0200 - build 3484

1. Refactoring.

2. Support for compilation with VC++ 2013.

shmuel 28.06.2013 23:29:19 +0200 - build 3483

1. Incorrect renamings for some constants in 3482.

drkns 28.06.2013 16:40:17 +0200 - build 3482

1. Refactoring.

w17 28.06.2013 16:12:45 +0400 - build 3481

1. 3475++, cursor did not follow a file when renaming it with Shift-F6

w17 28.06.2013 15:13:42 +0400 - build 3480

1. 3475++, M#2437: Copy/Move on a mapped drive doesn't work in nightly

w17 27.06.2013 20:08:50 +0400 - build 3479

1. Another correction to 3475 -- processing of file descriptions

2. Quotes are added for the name of a file with leading space characters in attributes setting dialog.

w17 27.06.2013 07:41:30 +0400 - build 3478

1. M#2435: On copying files to a directory, a new directory is created aside.
   This is the fix for 3475.

drkns 26.06.2013 18:48:30 +0200 - build 3477

1. Adding some 'const'ness.

drkns 25.06.2013 21:41:36 +0200 - build 3476

1. Continuation of 3474.

w17 25.06.2013 19:24:28 +0400 - build 3475

1. M#2420: Problem with files moved from the temporary panel by their relative paths

drkns 25.06.2013 14:15:35 +0200 - build 3474

1. Analyzer warnings.

2. Refactoring.

shmuel 24.06.2013 17:28:37 +0200 - build 3473

1. Refactoring.

shmuel 22.06.2013 15:16:19 +0200 - build 3472

1. Corrections of 3458.

lort 20.06.2013 18:59:22 +0400 - build 3471

1. Correction of 3469.

drkns 20.06.2013 22:55:17 +0200 - build 3470

1. vc10.cpp/vc11.cpp are one file now.

lort 20.06.2013 20:50:11 +0400 - build 3469

1. Menu.Filter(4) call malfunction in macros

drkns 20.06.2013 01:17:10 +0200 - build 3468

1. VC2012 build can run in Windows 2000 SP4 + updates.

2. Default highlighting initialization error.

drkns 19.06.2013 20:11:42 +0200 - build 3467

1. Refactoring.

drkns 18.06.2013 23:40:14 +0200 - build 3466

1. Refactoring.

shmuel 18.06.2013 10:44:58 +0200 - build 3465

1. The names of macro flags moved from FAR to LuaMacro plugin.

drkns 17.06.2013 23:31:47 +0200 - build 3464

1. Refactoring.

w17 17.06.2013 14:53:30 +0400 - build 3463

1. Continuation of 3449 for directories. (M#2414: Cannot delete files with long name)

shmuel 15.06.2013 20:14:26 +0200 - build 3462

1. Correction of 3461.

shmuel 15.06.2013 12:28:39 +0200 - build 3461

1. Plugins API: MCTL_EXECSTRING allows passing arguments to called script.

drkns 15.06.2013 02:40:00 +0200 - build 3460

1. Refactoring.

drkns 14.06.2013 20:12:14 +0200 - build 3459

1. Refactoring.

shmuel 14.06.2013 16:21:37 +0200 - build 3458

1. Adding FMVT_NIL "type" - extending Plugin.Call and MacroControl(MCTL_EXECSTRING) capabilities.
   Passing from Lua to plugins meant nil -> FMVT_BOOLEAN(0) transformation before,
   and passing nil from plugins to Lua was impossible at all.

drkns 14.06.2013 01:17:12 +0200 - build 3457

1. Refactoring.

shmuel 14.06.2013 00:06:14 +0200 - build 3456

1. Plugins API: MCTL_EXECSTRING operation is added to MacroControl function.

drkns 13.06.2013 21:35:16 +0200 - build 3455

1. Continuation of task list: adding windows with non-empty caption only (as it was before) and sorting it by name (like it was before),
   because sorting by PID has no sense.

drkns 13.06.2013 17:27:23 +0400 - build 3454

1. The meaning of previous commit is not quite clear: GetModuleFileNameEx is available on XP and already used in apiGetModuleFileNameEx.

w17 13.06.2013 18:23:56 +0400 - build 3453

1. Another correction of 3451
   GetProcessImageNameW -- available on xp

svs 13.06.2013 18:09:50 +0400 - build 3452

1. Correction of 3451
   QueryFullProcessImageNameW -- unavailable on xp

svs 13.06.2013 13:34:37 +0400 - build 3451

1. Small changes in process list (Ctrl-W).
   a) process PID is added.
   b) F2 switches the view:
      "PID + process window caption"
      "PID + executable path"
   c) the list is sorted by PID

   The list includes duplicate items by PID - it's ok, "move" to a necessary window is performed correctly.

drkns 12.06.2013 21:24:50 +0200 - build 3450

1. 0002424: Undo does not restore bookmarks

w17 12.06.2013 15:06:41 +0400 - build 3449

1. M#2414: One cannot delete filea with long name -- deletion without recycle bin is still available

shmuel 12.06.2013 13:23:17 +0200 - build 3448

1. Refactoring.

shmuel 10.06.2013 14:38:45 +0200 - build 3447

1. Refactoring.

shmuel 10.06.2013 02:03:06 +0200 - build 3446

1. M#2307: On msgbox call from condition(), the msgbox closing key is passed further (not consumed).

svs 06.06.2013 16:03:29 +0400 - build

1. Menu filtering with RAlt is noted in help.

drkns 06.06.2013 00:33:31 +0200 - build 3445

1. Refactoring.

2. Deprecated items are removed from viewer/editor local settings dialogs.

shmuel 04.06.2013 21:12:53 +0200 - build 3444

1. Refactoring.

2. GCC warnings.

w17 01.06.2013 17:07:58 +0400 - build 3443

1. Correction of 3439.

drkns 01.06.2013 11:04:26 +0200 - build 3442

1. Correction of 3440.

2. A couple of minor issues.

w17 01.06.2013 09:41:07 +0400 - build 3441

1. gcc build fix

drkns 01.06.2013 01:31:00 +0200 - build 3440

1. We contiue to break panel modes:
   - insertion and deletion work in menu (ins/del respectively)

w17 31.05.2013 17:14:08 +0400 - build 3439

1. M#1511: Shift_jis encoding -- view must work for all 2-byte encodings

w17 31.05.2013 11:51:32 +0400 - build 3438

1. M#2418: a problem with shortcuts import from Default.farconfig

drkns 30.05.2013 20:59:59 +0200 - build 3437

1. We contiue to break panel modes:
   - a mode can be renamed;
   - a mode can be reset to default settings.

shmuel 30.05.2013 18:24:39 +0200 - build 3436

1. Plugins API:
   * KMFLAGS_DISABLEOUTPUT is the default value now and is ignored by FAR.
   * A new flag is added: KMFLAGS_ENABLEOUTPUT.

shmuel 30.05.2013 11:29:22 +0200 - build 3435

1. LuaMacro plugin is given exact information on FAR /e or /v keys.

2. Correction of 3434 (VC build failure).

drkns 30.05.2013 00:47:06 +0200 - build 3434

1. Unlimited number of panel modes.
   There's no interface for adding/removing modes so far, nevertheless a real Jedi can edit panelmodes.db.

2. The modes can be switched with CtrlEnter in panel mode editing menu.

shmuel 29.05.2013 17:52:04 +0200 - build 3433

1. Experimental: autostarting macros work on FAR start with /e and /v keys.

drkns 29.05.2013 17:12:23 +0200 - build 3432

1. Broken reading from standard input in viewer.

shmuel 28.05.2013 22:43:14 +0200 - build 3431

1. M#1662: Improper behavior of macros with mmode().

w17 27.05.2013 12:24:16 +0400 - build 3430

1. GCC again -- NetDfsGetInfo dynamic loading, lame mingw builds should accept it

w17 27.05.2013 06:17:07 +0400 - build 3429

1. GCC++.

drkns 26.05.2013 19:53:59 +0200 - build 3428

1. GCC.

shmuel 26.05.2013 18:42:19 +0200 - build 3427

1. M#1663: Macros do not work from user menu on large amount of items on a panel.

w17 26.05.2013 00:53:26 +0400 - build 3426

1. correction of 3425 -- NetDfsGetInfo does not need dynamic loading

w17 26.05.2013 00:04:03 +0400 - build 3425

1. M#2412: DFS links view on CtrlA

shmuel 24.05.2013 15:43:21 +0200 - build 3424

1. Forum: After Keys("ShiftF6 End ! Enter") macro run on a file,
          Far caption stays "Rename/Move ..."

drkns 23.05.2013 23:02:08 +0200 - build 3423

1. Malfunction of virtual drives detection and removal.

w17 23.05.2013 19:21:06 +0400 - build 3422

1. M#2413: Selection restored incorrectly after the selected file moved on ShiftF6

t-rex 22.05.2013 17:29:36 +0200 - build 3421

1. RegExp search in viewer used RegExp API incorrectly, back reference (\NN) could not be used.

2. Refactoring.

drkns 22.05.2013 01:35:24 +0200 - build 3420

